function LevelSetup()

	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(1)
	Globals.Asteroids.SpawnCap=50
	Globals.Asteroids.SeedlingCap=3333
	Globals.Asteroids.MinSendDistance=0.5
	Globals.Asteroids.MaxSendDistance=0.5
	Globals.AI.GraceTimer=(260)
	Globals.Structures.FlowerProbability=(0.08)
	Globals.Mines.GrowTime=(35)
	Globals.Asteroids.MinCoreHealth=50
	Globals.Asteroids.MaxCoreHealth=950
	
	--AI stuff
	GetAI(2).Cowardice = 0.04 		--chances of retreating a battle we are losing
	GetAI(2).MinExpansionForce = 12
	GetAI(2).BattleSavvy = 0.6 		--chances of picking a battle for a valuable asteroid - don't put this at 1 or the AI will only look at one asteroid at a time!
	GetAI(2).ReinforcementGreed = 0.6 	--proportion of existing forces elsewhere to send in aid of battle
	GetAI(2).GreedyExpansion = 0.4 		--likelihood of sending all/most of the seedlings to expand
	GetAI(2).AidEnthusiasm = 0.6 		--how much to overshoot the battle rating when sending aid, to allow for inbound enemy forces, estimate errors, travel time, wanting to win, etc
	GetAI(2).ExpandBlind = 0.2 		--likelihood of expanding to asteroids that haven't been scouted yet
	GetAI(2).ExpandToValuableAsteroidChance = 0.8 	--likelihood of choosing a more valuable asteroid to expand to
	
	GetAI(0).Cowardice = 0.08 	
	GetAI(0).MinExpansionForce = 25
	GetAI(0).BattleSavvy = 0.2 	
	GetAI(0).ReinforcementGreed = 0.8 
	GetAI(0).GreedyExpansion = 0.7 	
	GetAI(0).AidEnthusiasm = 0.1 	
	GetAI(0).ExpandBlind = 0.3 	
	GetAI(0).ExpandToValuableAsteroidChance = 0.2 

--HELLO! Welcome to the code side of Aeon. Here you will find the ham-fisted reasoning behind the level. Feel free to tweak and poke at this internal paradise to make your journey game-side that little more... interesting! or easy, it's your call.
--Enjoy...
--The final mega-giant asteroid of the original version hah had to be removed for now...)

SetCameraZoomNow(50.5)

	-- Asteroid 0 - my starting asteroid
	a = AddAsteroidWithAttribs(0,150, 0.8,0.8,0.7)
	a.Owner = 1
	a.TreeCap = 5
	a:SetRadius(500)
	a.SendDistance = 2900
	s = a:AddDysonTree()
	s:LevelUp()
	a:AddSeedlings(61)
	a.Moveable = False


	-- Asteroid last south
	b = AddAsteroidWithAttribs(1200,6550, 0.3,0.9,0.6)
	b.Owner = 0
	b.TreeCap = 4
	b:SetRadius(155)
	b.SendDistance = 3550
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddSeedlings(10)
	b.Moveable = False

	-- Asteroid last west
	b = AddAsteroidWithAttribs(-3400,6950, 0.4,0.8,0.5)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(100)
	b.SendDistance = 3750
	s = b:AddDysonTree()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddSeedlings(11)
	b.Moveable = False

	-- Asteroid last east
	b = AddAsteroidWithAttribs(6950,5500, 0.6,0.9,0.7)
	b.Owner = 0
	b.TreeCap = 4
	b:SetRadius(145)
	b.SendDistance = 3750
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddSeedlings(11)
	b.Moveable = False

	-- Asteroid 1st East
	b = AddAsteroidWithAttribs(2600,450, 0.8,0.5,0.7)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(450)
	b.SendDistance = 2800
	s = b:AddDysonTree()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddSeedlings(19)
	b.Moveable = False

	-- Asteroid 2nd East South East
	b = AddAsteroidWithAttribs(4800,2100, 0.7,0.8,0.5)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(200)
	b.SendDistance = 2100
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	b:AddSeedlings(15)
	b.Moveable = False

	-- Asteroid 3rd East East
	b = AddAsteroidWithAttribs(7000,800, 0.6,0.7,0.8)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(185)
	b.SendDistance = 1700
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddSeedlings(29)
	b.Moveable = False

	-- Asteroid 3rd East north east
	b = AddAsteroidWithAttribs(5900,-350, 0.9,0.9,0.4)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(150)
	b.SendDistance = 2000
	s = b:AddDysonTree()
	b:AddSeedlings(31)
	b.Moveable = False

	-- Asteroid 4th East south east
	b = AddAsteroidWithAttribs(9000,2400, 1,0.7,0.5)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(433)
	b.SendDistance = 4500
	s = b:AddDysonTree()
	s = b:AddDysonTree()
	b:AddSeedlings(31)
	b.Moveable = False

	-- Asteroid 1st South East
	b = AddAsteroidWithAttribs(975,3550, 0.6,0.9,0.3)
	b.Owner = 0
	b.TreeCap = 4	
	b:SetRadius(375)
	b.SendDistance = 3350
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(2)
	b.Moveable = False

	-- Asteroid 1st South East South
	b = AddAsteroidWithAttribs(3390,3785, 0.6,0.5,0.4)
	b.Owner = 0
	b.TreeCap = 2	
	b:SetRadius(185)
	b.SendDistance = 3500
	s = b:AddDysonTree()
	b:AddSeedlings(9)
	b.Moveable = False

	-- Asteroid 1st South West
	b = AddAsteroidWithAttribs(-1595,4700, 0.3,0.7,0.8)
	b.Owner = 0
	b.TreeCap = 3	
	b:SetRadius(255)
	b.SendDistance = 4100
	b:AddSeedlings(5)
	b.Moveable = False

	-- Asteroid 1st West
	b = AddAsteroidWithAttribs(-2400,1150, 0.8,0.7,0.4)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(275)
	b.SendDistance = 3700
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddSeedlings(15)
	b.Moveable = False

	-- Asteroid 2nd West
	b = AddAsteroidWithAttribs(-4850,-1750, 0.5,1,0.8)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(475)
	b.SendDistance = 2500
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddSeedlings(30)
	b.Moveable = False

	-- Asteroid 3rd West north
	b = AddAsteroidWithAttribs(-5200,-2750, 0.5,0.5,0.5)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(175)
	b.SendDistance = 1800
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddSeedlings(2)
	b.Moveable = False

	-- Asteroid 3rd West west
	b = AddAsteroidWithAttribs(-7600,370, 0.7,0.7,0.4)
	b.Owner = 0
	b.TreeCap = 4
	b:SetRadius(425)
	b.SendDistance = 2900
	s = b:AddDysonTree()
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddSeedlings(35)
	b.Moveable = False

	-- Asteroid 3rd West south west
	b = AddAsteroidWithAttribs(-6000,3500, 0.8,0.7,0.5)
	b.Owner = 2
	b.TreeCap = 5
	b:SetRadius(555)
	b.SendDistance = 3200
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddSeedlings(15)
	b.Moveable = False

	-- Asteroid 4th West North
	b = AddAsteroidWithAttribs(-6300,-4800, 0.8,0.5,0.8)
	b.Owner = 0
	b.TreeCap = 4
	b:SetRadius(475)
	b.SendDistance = 1800
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddSeedlings(12)
	b.Moveable = False

--

	-- Asteroid 1st North
	b = AddAsteroidWithAttribs(-250,-4000, 0.8,0.8,0.3)
	b.Owner = 0
	b.TreeCap = 6
	b:SetRadius(800)
	b.SendDistance = 2500
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	b:AddSeedlings(45)
	b.Moveable = False
	
	-- Asteroid 2nd North west
	b = AddAsteroidWithAttribs(-2650,-5000, 0.2,0.5,0.8)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(200)
	b.SendDistance = 900
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddSeedlings(10)
	b.Moveable = False

	-- Asteroid 2nd North north
	b = AddAsteroidWithAttribs(0,-5500, 0.4,0.8,0.4)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(150)
	b.SendDistance = 1500
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddSeedlings(10)
	b.Moveable = False

	-- Asteroid 2nd North east 
	b = AddAsteroidWithAttribs(2200,-5500, 0.6,0.6,0.6)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(385)
	b.SendDistance = 1800
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddSeedlings(28)
	b.Moveable = False

	-- Asteroid 2nd North west north
	b = AddAsteroidWithAttribs(-1250,-6500, 0.5,0.6,0.7)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(250)
	b.SendDistance = 1800
	s = b:AddDysonTree()
	b:AddSeedlings(28)
	b.Moveable = False

	-- Asteroid 3rd North east east
	b = AddAsteroidWithAttribs(2900,-7700, 0.7,0.8,0.6)
	b.Owner = 2
	b.TreeCap = 5
	b:SetRadius(385)
	b.SendDistance = 2500
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(58)
	b.Moveable = False


	-- Asteroid Bridge roid between Home and 1st North
	b = AddAsteroidWithAttribs(350,-2000, 0.9,0.9,0.1)
	b.Owner = 1
	b.TreeCap = 2
	b:AddDefenseTree()
	b:SetRadius(135)
	b.SendDistance = 1000
	b.Moveable = False

--the GIANT asteroids--

	-- Asteroid 4th North west GIANT
	b = AddAsteroidWithAttribs(-3000,-12000, 0.9,0.9,0.9)
	b.Owner = 0
	b.TreeCap = 8
	b:SetRadius(1350)
	b.SendDistance = 11000
	s = b:AddDysonTree()
	b:AddDefenseTree()
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(25)
	b.Moveable = False

	-- Asteroid 4th North east GIANT
	b = AddAsteroidWithAttribs(7500,-16000, 1,1,0.9)
	b.Owner = 2
	b.TreeCap = 9
	b:SetRadius(1800)
	b.SendDistance = 11000
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	b:AddDefenseTree()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(45)
	b.Moveable = False

	-- Asteroid 5th East east GIANT
	b = AddAsteroidWithAttribs(24900,-30000, 1,1,1)
	b.Owner = 2
	b.TreeCap = 10
	b:SetRadius(2400)
	b.SendDistance = 21500
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	b:AddDefenseTree()
	s:LevelUp()
	b:AddDefenseTree()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(65)
	b.Moveable = False

	-- Asteroid 5th north east bridge GIANT
	b = AddAsteroidWithAttribs(9000,-26000, 0.8,0.8,0.8)
	b.Owner = 0
	b.TreeCap = 10
	b:SetRadius(2400)
	b.SendDistance = 19000
	s = b:AddDysonTree()
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	b:AddDefenseTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddSeedlings(55)
	b.Moveable = False


	-- Asteroid 6th West North GIANT
	b = AddAsteroidWithAttribs(-11500,-29500, 1.1,0.8,1)
	b.Owner = 2
	b.TreeCap = 10
	b:SetRadius(2300)
	b.SendDistance = 19000
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	s:LevelUp()
	b:AddDefenseTree()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(50)
	b.Moveable = False

	-- Asteroid 6th North GIANT
	b = AddAsteroidWithAttribs(3500,-44000, 1.1,1,1)
	b.Owner = 2
	b.TreeCap = 10
	b:SetRadius(2900)
	b.SendDistance = 24000
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddDefenseTree()
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(105)
	b.Moveable = False


	-- Asteroid 6th east east GIANT
	b = AddAsteroidWithAttribs(24000,-11500, 0.8,0.9,1.1)
	b.Owner = 2
	b.TreeCap = 8
	b:SetRadius(1800)
	b.SendDistance = 19000
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	b:AddDefenseTree()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(45)
	b.Moveable = False


	-- Asteroid 6th  west west GIANT
	b = AddAsteroidWithAttribs(-22500,-13000, 1.1,1.1,0.7)
	b.Owner = 2
	b.TreeCap = 8
	b:SetRadius(2000)
	b.SendDistance = 24000
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	b:AddDefenseTree()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(15)
	b.Moveable = False


	

	
	
	
	
end


function LevelLogic()

-- Greeting

	Timer = GetGameTime() + 3


	while GetGameTime() < Timer do

		coroutine.yield()
	end

	Pause()
	MessageBox("Hello. Welcome to the world of Aeon.                                                                          Here you will find the dark forces of oppresion and other bad things in abundance and it is you who must get rid of them...                                                                ...It may take some time...")
	WaitDialog()
	Unpause()

--colour wave/ pulsing effect
	
	while GameRunning() do

	rtime = GetGameTime()	 -- setting the variable 'time' to whatever the game time is
	rtime = rtime / 280 	 -- taking that 'time' variable and dividing it by n.  divide slows down. multiply speeds up.
	--gtime = GetGameTime()
	--gtime = gtime / 250
	--btime = GetGameTime()
	--btime = btime / 250
	
	rcolour = math.sin(rtime) -- setting the variable 'rcolour' to wave up and down. like this the range is now -1 to 1. 1 being the peak of the wave and -1 being the trough. with the horizontal axis as 'time', in this case the 'time' variable.

	rcolour = rcolour * rcolour  -- square rcolour, if it is negative this will make it positive
	rcolour = math.sqrt(rcolour) -- now take the square root of it

   	rcolour = rcolour * 35  -- setting the range of 'rcolour' from 0 to 255. in this case the 'r' referring to 'red', multiplied by n. do the same with 'g' and 'b'

	--gcolour = math.sin(gtime)
	--gcolour = gcolour * 233
	--bcolour = math.sin(btime)
	--bcolour = bcolour * 17


	SetBackdropColour(rcolour,0,24) -- makes the background change between colours. 0 is black/min. 255 is white/max


-- Victory Trigger
			

		if GetEmpire(2):GetNumOwnedAsteroids() == 0 then 
		Pause()
		MessageBox("Well Done...                                                    You managed to vanquish them all to a dark voidy place, full of mystery and awe... I wonder where they will re-appear...")
		WaitDialog()
		Unpause()
		Quit(true)
		end
		

		if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
		Pause()
		MessageBox("Oops!                                                                      ...More Horses!")
		WaitDialog()
		Unpause()
		Quit(false)
		end

	coroutine.yield()
	end
	

--AI carefully and brutally stolen from Annikk.exe's Infected Empire. A thousand appreciative bows and nods in your direction...
 
	checkedroid = GetAI(2):GetRandomAsteroid()
	
		
		if GetGameTime() > purgetimer + 35 then
			purgetimer = 0
		end
		
		
	
		-- First, find out which asteroids are close enough to travel in 1 jump, and 
	
		traversable = {}
		pathsavailable = 0
		
		attackable = {}
		attackpaths = 0

		actiontaken = 0
		
		increasemetricvote = 1
		increasegathermetricvote = 1
		confirmedzero = 0
		confirmedgatherpoint = 0



		if GetEmpire(2):OwnsAsteroidID(checkedroid.ID) then
		
			if checkedroid:GetNumSeedlings(1) == 0 and checkedroid:GetNumSeedlings(2) > 5 then
				for minecheck = 0,roidnumber do
				
					if GetEmpire(2):OwnsAsteroidID(minecheck) == true and GetAsteroid(minecheck):GetNumMines(1) > 0 and checkedroid:GetNumMines(1) == 0 then
						checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),GetAsteroid(minecheck))
					end
				
				end
		
			end
		
			for u = 0,roidnumber do

				if GetAsteroid(u) ~= checkedroid then
					-- only learn about this asteroid if it's not the one being checked
					-- can we send seeds to this roid from the checked one?
					if (GetAsteroid(checkedroid.ID):GetSendDistance() + roidradius[u]) > math.sqrt(((coordx[u] - coordx[checkedroid.ID])^2) + ((coordy[u] - coordy[checkedroid.ID])^2)) then
						-- we can !  Now is this a friendly path or an attackable path?
						if GetEmpire(1):OwnsAsteroidID(u) == true or GetAsteroid(u):GetNumSeedlings(1) > 10 and GetAsteroid(u):GetNumTrees() == 0 then
							attackable[attackpaths] = GetAsteroid(u)
							attackpaths = attackpaths + 1
							
							-- moar aggression ! advantage pressing, etc
							if checkedroid:GetNumSeedlings(2) > 120 and GetAsteroid(u):GetNumSeedlings(1) < (checkedroid:GetNumSeedlings(2) / 2) then
								checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),GetAsteroid(u))
								if rcolour < 105 then
									rcolour = rcolour + 150
								end
							end
						end
					
						if GetAI(2):OwnsAsteroidID(u) == true then

							traversable[pathsavailable] = GetAsteroid(u)
							pathsavailable = pathsavailable + 1
						end
				
					end

					-- ok, this roid is not in range for us.



			
			
			
				end
				-- ok, we were trying to check ourselves.

			
	
	
	
			end
			-- end of neighbour-checking sequence

	
			
		
		

		
		
		
			-- end of metric checking sequence
	
		else
	
			torchlit[checkedroid.ID] = nil
			constructionmetric[checkedroid.ID] = nil
			gathermetric[checkedroid.ID] = nil
	
		end
	
	
		-- we have selected "checkedroid" for checking.  We must find out all we can about the asteroid and it's surroundings, and act appropriately.
		if GetAI(2):OwnsAsteroidID(checkedroid.ID) == true and checkedroid:GetNumMines(1) > 0 then
		
			-- do buggerysquat! (eloquently put, annikk!)
		

		elseif GetAI(2):OwnsAsteroidID(checkedroid.ID) == true then
			-- this roid is ours ! :>
			
			
			if pathsavailable == 0 then
				-- Orphan Control
				boltfriendly = GetEmpire(2):GetRandomAsteroid()
				letsgo = 0
				
				for iii = 0,attackpaths do
					
					if attackable[iii] ~= nil then
						letsgo = letsgo + (attackable[iii]:GetNumSeedlings(1))
					end
				
				end
				
				if letsgo > checkedroid:GetNumSeedlings(2) and checkedroid:GetNumSeedlings(2) > 10 and checkedroid:GetNumSeedlings(2) < 39 then
				
					checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),boltfriendly)
					
					
				elseif letsgo < checkedroid:GetNumSeedlings(2) and checkedroid:GetNumSeedlings(2) > (39 + (attackable[0]:GetNumDysonTrees() * 5) + (attackable[0]:GetNumDefenseTrees() * 15)) then
				
					checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),attackable[0])
					
					end

				
				elseif attackable[0]:GetNumSeedlings(2) > 5 then
				
					checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),attackable[0])
	
					
				end
				
				
			end
			-- how many player seedlings are here?

			-- more than what we have, and enough to be dangerous.  Also, we do have at least 1 tree here, right?
			if checkedroid:GetNumSeedlings(2) < checkedroid:GetNumSeedlings(1) and checkedroid:GetNumSeedlings(1) > 10 and checkedroid:GetNumTrees() > 0 then
				-- *** WE OWN THIS ASTEROID, THE ENEMY OUTNUMBER US.  WE HAVE AT LEAST ONE TREE HERE.  We are under attack.  torchmetric 0! ***
				torchlit[checkedroid.ID] = 0
				-- ***
			
		--	elseif checkedroid:GetNumSeedlings(2) < checkedroid:GetNumSeedlings(1) and checkedroid:GetNumSeedlings(1) > 10 and checkedroid:GetNumTrees() == 0 then
				-- *** ITS A FALSE ALARM....but dont try to build here unless the player leaves. ***
				--torchlit[checkedroid.ID] = nil
				--constructionmetric[checkedroid.ID] = nil				
				-- but once we get a bit more powerful, we can have a crack at it :>
				
				
			--		if purgetimer == 0 then
			--			purgetimer = GetGameTime() + 30
			--		end
					
			--		if GetGameTime() > purgetimer then
						
						
			--			torchlit[checkedroid.ID] = 0
						
						--for purge = 0,roidnumber do
						--	if GetEmpire(2):OwnsAsteroidID(purge) == true and torchlit[purge] == nil and GetGameTime() > purgetimer + 45 then
						
						--GetAsteroid(purge):SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(1),checkedroid)
						
						
						
						--	end
						
						--	end
						
			--			purgetimer = 0
						
			--		end
				
				-- ***
			end
	
			
			--  more than zero but less than what we have
			if checkedroid:GetNumSeedlings(1) > 0 and checkedroid:GetNumSeedlings(2) > checkedroid:GetNumSeedlings(1) then
				-- *** WE OWN THIS ASTEROID, THERE ARE ENEMIES BUT WE OUTNUMBER THEM.  Not elligible for sending reinforcements to other asteroids, but not in serious danger either. ***
				-- ***
			end
			
			-- No enemies here at all.
			if checkedroid:GetNumSeedlings(1) < 1 then
			
				-- how many of our seedlings are here?
				if checkedroid:GetNumSeedlings(2) > 1 then
					-- 1 or more
		
		
					--how many trees are here?
					if checkedroid:GetNumTrees() < 4 and checkedroid:GetNumSeedlings(2) > 9 then
						-- less than four trees
						-- *** WE OWN THIS ASTEROID, THERE ARE NO ENEMIES HERE.  WE HAVE AT LEAST 10 SEEDLINGS AND LESS THAN 4 TREES.  Plant a tree. ***
						
						
						-- but... is the enemy building up a force nearby, ready to take our freshly built trees..?
						
						danger[checkedroid.ID] = false
						
						for ooo = 0,roidnumber do
							if GetEmpire(1):OwnsAsteroidID(ooo) and GetAsteroid(ooo):GetSendDistance() > math.sqrt(((coordx[ooo] - coordx[checkedroid.ID])^2) + ((coordy[ooo] - coordy[checkedroid.ID])^2)) then
						
								if GetAsteroid(ooo):GetNumSeedlings(1) > 35 then
								
									danger[checkedroid.ID] = true
									dangertimer[checkedroid.ID] = GetGameTime()
								
								end
							
							end
						end
						
						if danger[checkedroid.ID] == true and checkedroid:GetNumSeedlings(2) > 15 then
							
							checkedroid:PlantDysonTree(2)
						
						elseif danger[checkedroid.ID] == false and GetGameTime() > dangertimer[checkedroid.ID] + 30 then
						
							checkedroid:PlantDysonTree(2)
							
						end
						-- ***
					
					
					
					elseif checkedroid:GetNumTrees() == 4 then
						-- four	trees.  ELIGIBLE FOR SENDING REINFORCEMENTS!
						
						if constructionmetric[checkedroid.ID] == 0 then
							-- we just built the last tree.  now we should stop advertising to neighbours that we need more seedlings for construction.
							constructionmetric[checkedroid.ID] = nil
						end
						
						
						-- is my torch metric nil?
						
						if torchlit[checkedroid.ID] ~= nil then
							-- no, my torch metric is not Nil.
							
							-- is my torch metric 0?  Cause, like, I don't have any enemies orbiting me dudez...
							if torchlit[checkedroid.ID] == 0 then
								-- *** ok, so my torch metric is 0 but there are no enemies here.  Switch all torches off....if other roids are under attack they will just switch theirs on again straight away. ***
								-- *** this step is needed to prevent the rest of the torch metrics from spiralling upward out of control.  ***
								for g = 0,roidnumber do
									torchlit[g] = nil
								end									
								-- ***
							else
							
								-- so my torch IS lit, but it's value is NOT zero.  checkedroid is not nil and not 0.
							
								totm = true
							
								for ooo = 0,pathsavailable do
								
									if traversable[ooo] ~= nil then
								
										trav = traversable[ooo]
								
										hopIDint = trav.ID
									
										if torchlit[hopIDint] == 0 and GetGameTime() < 180 then
											
											for emerg = 0,roidnumber do
												if GetEmpire(2):OwnsAsteroidID(emerg) == true then
													GetAsteroid(emerg):SendSeedlingsToTarget(2,GetAsteroid(emerg):GetNumSeedlings(2),traversable[ooo])
												end
											end
										
											totm = false
									
									
										elseif torchlit[hopIDint] == 0 then
											-- *** WE HAVE FOUND A NEIGHBOUR THAT HAS A ROUTE TO AN ASTEROID IN NEED OF DEFENCE.  Send seedlings ***
											
											if GetAsteroid(hopIDint):GetNumSeedlings(1) < 10 then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
												
											elseif GetAsteroid(hopIDint):GetNumSeedlings(2) > GetAsteroid(hopIDint):GetNumSeedlings(1) * 0.6 then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
											
											
											elseif checkedroid:GetNumSeedlings(2) > (GetEmpire(2).NumSeedlings / 20) then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
											end
											
											totm = false
											torchlit[checkedroid.ID] = 1
									
											--				elseif torchlit[checkedroid.ID] == nil then
											
											--					totm = false
											--					torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
											--					shortestpath = hopIDint
											
											
										elseif torchlit[hopIDint] == nil then
										
											-- do nothing, maybe there's no more attack and the metric should be turned off.
											
											
											
											-- my torch metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
										elseif torchlit[hopIDint] < torchlit[checkedroid.ID] - 1 then
											totm = false
											torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
											shortestpath = hopIDint
											checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
											
											
										elseif torchlit[hopIDint] == torchlit[checkedroid.ID] - 1 then
										
											totm = false
											torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
											shortestpath = hopIDint
											checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
										
											
									
										end
							
									end
								end
							
							
							
							
							
							
							
								-- *** WE OWN THIS ASTEROID.  THERE ARE NO ENEMIES HERE.  WE HAVE AT LEAST 10 SEEDLINGS AND MAXIMUM TREES.  OUR TORCH METRIC INDICATES ***
								-- *** THAT A NEARBY ASTEROID REQUIRES SEEDLINGS FOR DEFENSE.  Find a neighbour with the lower metric and send 10 seedlings there.  ***
							

							
							end
							
							
						
						elseif torchlit[checkedroid.ID] == nil then
						
							-- yes my torch metric is nil, now lets see if any neighbours have a torch metric of 0..
							
							totm = true
							
							
							
							for ooo = 0,pathsavailable do
								
								if traversable[ooo] ~= nil then
								
									trav = traversable[ooo]
								
									hopIDint = trav.ID
									
									
							
									if torchlit[hopIDint] == 0 then
										-- *** WE HAVE FOUND A NEIGHBOUR THAT NEEDS MORE SEEDS TO DEFEND WITH.  Send 10 seedlings, or more if we have them available. ***
										checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[ooo])
										totm = false
										torchlit[checkedroid.ID] = 1
										
										
									
									elseif torchlit[hopIDint] ~= nil then
										if torchlit[hopIDint] > 0 then
											-- seedlings needed in this direction!
											
											-- my torch metric is nil at the moment, so set it to his + 1.
											if torchlit[checkedroid.ID] == nil then
												totm = false
												torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											-- my torch metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
											if torchlit[hopIDint] < torchlit[checkedroid.ID] - 1 then
												totm = false
												torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											
										
										end
										
									
									
									end
							
								end
							end

							-- send seeds along the shortest torch path
							if torchlit[checkedroid.ID] ~= nil then
								if torchlit[checkedroid.ID] > 1 then
								
									checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),GetAsteroid(shortestpath))
								end
							end
							
							if totm == true and torchlit[checkedroid.ID] ~= nil then
								torchlit[checkedroid.ID] = nil
							end
						
						
							-- check if we are still under attack on any asteroids
							stillattacked = false
							
							for o = 0,roidnumber do
								if GetAsteroid(o):GetNumTrees() > 0 and GetAI(2):OwnsAsteroidID(o) and GetAsteroid(o):GetNumSeedlings(1) > 1 then
									stillattacked = true
								end
							end
							
							if stillattacked == false then
								for l = 0,roidnumber do
									torchlit[l] = nil
								end
							end
							
							
							
							-- yes, my torch metric is Nil and so is all my neighbours' - check my construction metric next.
						
							-- turn off construction metric
							tocm = true
							
							for cc = 0,pathsavailable do
								
								if traversable[cc] ~= nil then
								
									trav = traversable[cc]
								
									hopIDint = trav.ID
							
									if constructionmetric[hopIDint] == 0 and danger[checkedroid.ID] == false and GetGameTime() > (dangertimer[checkedroid.ID] + 90) and GetAsteroid(hopIDint):GetNumSeedlings(1) < 8 then
										-- *** WE HAVE FOUND A NEIGHBOUR THAT NEEDS MORE SEEDS TO BUILD WITH.  Send 10 seedlings, or more if we have them available. ***
										checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[cc])
										tocm = false
										constructionmetric[checkedroid.ID] = 1
									
									
									elseif danger[checkedroid.ID] == true or GetGameTime() < (dangertimer[checkedroid.ID] + 120) then
									
										-- *** WAIT A BIT... THERE'S STILL A BIG FORCE NEARBY ***
										
										tocm = false
										constructionmetric[checkedroid.ID] = 1
									
									
									
									
									elseif constructionmetric[hopIDint] ~= nil then
										if constructionmetric[hopIDint] > 0 then
											-- seedlings needed in this direction!
											
											-- my construction metric is nil at the moment, so set it to his + 1.
											if constructionmetric[checkedroid.ID] == nil then
												tocm = false
												constructionmetric[checkedroid.ID] = constructionmetric[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											-- my construction metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
											if constructionmetric[hopIDint] < constructionmetric[checkedroid.ID] - 1 then
												tocm = false
												constructionmetric[checkedroid.ID] = constructionmetric[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											
										
										end
										
									
									
									end
							
								end
							end
						
							-- send seeds along the shortest construction path
							if constructionmetric[checkedroid.ID] ~= nil then
								if constructionmetric[checkedroid.ID] > 1 then
								
									checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),GetAsteroid(shortestpath))
								end
							end
							
							if tocm == true and constructionmetric[checkedroid.ID] ~= nil then
								constructionmetric[checkedroid.ID] = nil
							end
						
						
							-- check if we are finished building trees on all asteroids
							stillbuilding = false
							
							for o = 0,roidnumber do
								if GetAsteroid(o):GetNumTrees() < 4 and GetAI(2):OwnsAsteroidID(o) then
									stillbuilding = true
								end
							end
							
							if stillbuilding == false then
								for l = 0,roidnumber do
									constructionmetric[l] = nil
								end
							end
						
							
						end
		end			
end					




end
end
