function LevelSetup()

	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(1)
	Globals.Asteroids.SpawnCap=50
	Globals.Asteroids.SeedlingCap=5555
	Globals.Asteroids.MinSendDistance=0.5
	Globals.Asteroids.MaxSendDistance=0.5
	Globals.AI.GraceTimer=(60)
	Globals.Structures.FlowerProbability=(0.07)
	Globals.Mines.GrowTime=(35)
	Globals.Asteroids.MinCoreHealth=50
	Globals.Asteroids.MaxCoreHealth=500
	
	--AI stuff
	GetAI(2).Cowardice = 0.04 	--chances of retreating a battle we are losing
	GetAI(2).MinExpansionForce = 12
	GetAI(2).BattleSavvy = 0.6 	--chances of picking a battle for a valuable asteroid - don't put this at 1 or the AI will only look at one asteroid at a time!
	GetAI(2).ReinforcementGreed = 0.5 --proportion of existing forces elsewhere to send in aid of battle
	GetAI(2).GreedyExpansion = 0.5 	--likelihood of sending all/most of the seedlings to expand
	GetAI(2).AidEnthusiasm = 0.6 	--how much to overshoot the battle rating when sending aid, to allow for inbound enemy forces, estimate errors, travel time, wanting to win, etc
	GetAI(2).ExpandBlind = 0.2 	--likelihood of expanding to asteroids that haven't been scouted yet
	GetAI(2).ExpandToValuableAsteroidChance = 0.6 	--likelihood of choosing a more valuable asteroid to expand to
	
	GetAI(0).Cowardice = 0.08 	
	GetAI(0).MinExpansionForce = 25
	GetAI(0).BattleSavvy = 0.1 	
	GetAI(0).ReinforcementGreed = 0.1 
	GetAI(0).GreedyExpansion = 0.1 	
	GetAI(0).AidEnthusiasm = 0.1 	
	GetAI(0).ExpandBlind = 0.1 	
	GetAI(0).ExpandToValuableAsteroidChance = 0.2 

	-- Asteroid 0 - my starting asteroid
	a = AddAsteroidWithAttribs(0,0, 0.9,0.9,0.6)
	a.Owner = 1
	a.TreeCap = 5
	a:SetRadius(500)
	a.SendDistance = 2600
	a:AddSeedlings(51)
	a.Moveable = False

	-- Asteroid 1st East
	b = AddAsteroidWithAttribs(2600,450, 0.9,0.5,0.8)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(450)
	b.SendDistance = 2800
	s = b:AddDysonTree()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddSeedlings(19)
	b.Moveable = False

	-- Asteroid 2nd East South East
	b = AddAsteroidWithAttribs(5000,1800, 0.8,0.8,0.5)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(200)
	b.SendDistance = 1700
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	b:AddSeedlings(15)
	b.Moveable = False

	-- Asteroid 3rd East East
	b = AddAsteroidWithAttribs(6800,1000, 0.6,0.7,0.8)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(185)
	b.SendDistance = 1700
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddSeedlings(29)
	b.Moveable = False

	-- Asteroid 3rd East north east
	b = AddAsteroidWithAttribs(6100,-200, 0.9,0.9,0.4)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(150)
	b.SendDistance = 2000
	s = b:AddDysonTree()
	b:AddSeedlings(31)
	b.Moveable = False

	-- Asteroid 1st South
	b = AddAsteroidWithAttribs(375,2850, 0.7,1,0.3)
	b.Owner = 0
	b.TreeCap = 4	
	b:SetRadius(375)
	b.SendDistance = 3000
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(1)
	b.Moveable = False

	-- Asteroid 1st South East
	b = AddAsteroidWithAttribs(1685,2555, 0.6,0.5,0.4)
	b.Owner = 0
	b.TreeCap = 2	
	b:SetRadius(185)
	b.SendDistance = 3500
	s = b:AddDysonTree()
	b:AddSeedlings(9)
	b.Moveable = False

	-- Asteroid 1st South West
	b = AddAsteroidWithAttribs(-1205,4010, 0.3,0.7,0.8)
	b.Owner = 0
	b.TreeCap = 3	
	b:SetRadius(255)
	b.SendDistance = 3500
	b:AddSeedlings(5)
	b.Moveable = False

	-- Asteroid 1st West
	b = AddAsteroidWithAttribs(-2500,500, 0.8,0.7,0.4)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(275)
	b.SendDistance = 3200
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddSeedlings(15)
	b.Moveable = False

	-- Asteroid 2nd West
	b = AddAsteroidWithAttribs(-4500,-750, 0.5,1,0.8)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(475)
	b.SendDistance = 2500
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddSeedlings(30)
	b.Moveable = False

	-- Asteroid 3rd West north
	b = AddAsteroidWithAttribs(-5200,-2750, 0.5,0.5,0.5)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(175)
	b.SendDistance = 1800
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddSeedlings(2)
	b.Moveable = False

	-- Asteroid 3rd West west
	b = AddAsteroidWithAttribs(-6900,150, 0.7,0.7,0.4)
	b.Owner = 0
	b.TreeCap = 4
	b:SetRadius(425)
	b.SendDistance = 2500
	s = b:AddDysonTree()
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddSeedlings(35)
	b.Moveable = False

	-- Asteroid 3rd West south west
	b = AddAsteroidWithAttribs(-5000,2500, 0.8,0.7,0.5)
	b.Owner = 2
	b.TreeCap = 5
	b:SetRadius(555)
	b.SendDistance = 2800
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddSeedlings(15)
	b.Moveable = False

	-- Asteroid 4th West North
	b = AddAsteroidWithAttribs(-6600,-4000, 0.8,0.5,0.8)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(475)
	b.SendDistance = 2400
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddSeedlings(12)
	b.Moveable = False

	-- Asteroid 1st North
	b = AddAsteroidWithAttribs(-250,-4000, 0.9,0.9,0.3)
	b.Owner = 0
	b.TreeCap = 6
	b:SetRadius(800)
	b.SendDistance = 2500
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	b:AddSeedlings(45)
	b.Moveable = False
	
	-- Asteroid 2nd North west
	b = AddAsteroidWithAttribs(-2650,-5000, 0.2,0.6,0.9)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(200)
	b.SendDistance = 900
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddSeedlings(10)
	b.Moveable = False

	-- Asteroid 2nd North north
	b = AddAsteroidWithAttribs(0,-5500, 0.4,0.9,0.4)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(150)
	b.SendDistance = 1500
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddSeedlings(10)
	b.Moveable = False

	-- Asteroid 2nd North east 
	b = AddAsteroidWithAttribs(1400,-5500, 0.7,0.7,0.7)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(385)
	b.SendDistance = 1800
	s = b:AddDysonTree()
	s:LevelUp()
	b:AddSeedlings(28)
	b.Moveable = False

	-- Asteroid 2nd North west north
	b = AddAsteroidWithAttribs(-1250,-6500, 0.6,0.6,0.8)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(250)
	b.SendDistance = 1800
	s = b:AddDysonTree()
	b:AddSeedlings(28)
	b.Moveable = False

	-- Asteroid 3rd North east east
	b = AddAsteroidWithAttribs(2900,-7700, 0.7,0.8,0.6)
	b.Owner = 2
	b.TreeCap = 5
	b:SetRadius(385)
	b.SendDistance = 2500
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(58)
	b.Moveable = False

	-- Asteroid 4th North west GIANT
	b = AddAsteroidWithAttribs(-3000,-12000, 0.9,0.9,0.9)
	b.Owner = 0
	b.TreeCap = 8
	b:SetRadius(1350)
	b.SendDistance = 8000
	s = b:AddDysonTree()
	b:AddDefenseTree()
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(15)
	b.Moveable = False

	-- Asteroid 5th North east GIANT
	b = AddAsteroidWithAttribs(4500,-18000, 1,1,0.9)
	b.Owner = 2
	b.TreeCap = 9
	b:SetRadius(1800)
	b.SendDistance = 11000
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	b:AddDefenseTree()
	s:LevelUp()
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b:AddSeedlings(15)
	b.Moveable = False

	-- Asteroid Bridge roid between Home and 1st North
	b = AddAsteroidWithAttribs(350,-2100, 0.9,0.9,0.1)
	b.Owner = 0
	b.TreeCap = 2
	b:SetRadius(130)
	b.SendDistance = 1000
	b.Moveable = False
	
	
end


function LevelLogic()


-- Greeting

	Timer = GetGameTime() + 3


	while GetGameTime() < Timer do

		coroutine.yield()
	end

	Pause()
	MessageBox("You pushed too far...                                                      You got cut off and are now surrounded...                                                             All that remains are the last of the few, the best of the rest.                                                 It's up to you to break free and finish off the remaining species, once and for all!                                                Good Luck!")
	WaitDialog()
	Unpause()


--colour wave/ pulsing effect
	
	while GameRunning() do

	rtime = GetGameTime()	 -- setting the variable 'time' to whatever the game time is
	rtime = rtime / 250 	 -- taking that 'time' variable and dividing it by n.  divide slows down. multiply speeds up.
	--gtime = GetGameTime()
	--gtime = gtime / 250
	--btime = GetGameTime()
	--btime = btime / 250
	
	rcolour = math.sin(rtime) -- setting the variable 'rcolour' to wave up and down. like this the range is now -1 to 1. 1 being the peak of the wave and -1 being the trough. with the horizontal axis as 'time', in this case the 'time' variable.

	rcolour = rcolour * rcolour  -- square rcolour, if it is negative this will make it positive
	rcolour = math.sqrt(rcolour) -- now take the square root of it

   	rcolour = rcolour * 35  -- setting the range of 'rcolour' from 0 to 255. in this case the 'r' referring to 'red', multiplied by n. do the same with 'g' and 'b'

	--gcolour = math.sin(gtime)
	--gcolour = gcolour * 233
	--bcolour = math.sin(btime)
	--bcolour = bcolour * 17


	SetBackdropColour(rcolour,0,24) -- makes the background change between colours. 0 is black/min. 255 is white/max


-- Victory Trigger
			

		if GetEmpire(2):GetNumOwnedAsteroids() == 0 then 
		Pause()
		MessageBox("Victory! Congratulations")
		WaitDialog()
		Unpause()
		Quit(true)
		end
		

		if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
		Pause()
		MessageBox("Oops!                                                                      A change of tactic next time, perhaps?...")
		WaitDialog()
		Unpause()
		Quit(false)
		end

	coroutine.yield()
	end

end
	
