function LevelSetup()

	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(1)
	Globals.Asteroids.SpawnCap=99
	Globals.Asteroids.SeedlingCap=3333
	Globals.Asteroids.MinSendDistance=0.5
	Globals.Asteroids.MaxSendDistance=0.5
	Globals.AI.GraceTimer=(120)
	Globals.Structures.FlowerProbability=(0.09)
	Globals.Mines.GrowTime=(0.8)
	Globals.Asteroids.MinCoreHealth=50
	Globals.Asteroids.MaxCoreHealth=250
	

	--AI stuff
	GetAI(2).Cowardice = 0.04 	--chances of retreating a battle we are losing
	GetAI(2).MinExpansionForce = 12
	GetAI(2).BattleSavvy = 0.4 	--chances of picking a battle for a valuable asteroid - don't put this at 1 or the AI will only look at one asteroid at a time!
	GetAI(2).ReinforcementGreed = 0.4 --proportion of existing forces elsewhere to send in aid of battle
	GetAI(2).GreedyExpansion = 0.4 	--likelihood of sending all/most of the seedlings to expand
	GetAI(2).AidEnthusiasm = 0.3 	--how much to overshoot the battle rating when sending aid, to allow for inbound enemy forces, estimate errors, travel time, wanting to win, etc
	GetAI(2).ExpandBlind = 0.4 	--likelihood of expanding to asteroids that haven't been scouted yet
	GetAI(2).ExpandToValuableAsteroidChance = 0.6 	--likelihood of choosing a more valuable asteroid to expand to
	
	SetBackdropColour (101,250,155)


	--Giant Planets are 1ESE,15NW,20SW,23W


	-- Asteroid 0 - my starting asteroid
	a = AddAsteroidWithAttribs(0,0, 0.8,0.7,0.8)
	a.Owner = 1
	a.TreeCap = 6
	a:SetRadius(550)
	a.SendDistance = 2100
	a:AddSeedlings(79)
	a.Moveable = False


	-- Asteroid 1 -  1st Giant Planet
	b = AddAsteroidWithAttribs(6000,1500, 0.7,0.8,0.5)
	b.Owner = 2
	b.TreeCap = 7
	b:SetRadius(995)
	b.SendDistance = 1500
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddSeedlings(89)
	b.Moveable = False

	
	-- Asteroid 2
	b = AddAsteroidWithAttribs(1500,1900, 0.3,0.4,0.2)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(450)
	b.SendDistance = 650
	b:AddSeedlings(20)
	b.Moveable = False
	

	
	-- Asteroid 3
	b = AddAsteroidWithAttribs(-1600,-850, 0.4,0.6,0.8)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(250)
	b.SendDistance = 100
	b:AddSeedlings(20)
	b.Moveable = False
	
	
	-- Asteroid 4
	b = AddAsteroidWithAttribs(-1800,2200, 0.6,0.6,0.2)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(450)
	b.SendDistance = 400
	b:AddSeedlings(25)
	b.Moveable = False

	
	-- Asteroid 5
	b = AddAsteroidWithAttribs(2600,900, 0.5,0.5,0.6)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(150)
	b.SendDistance = 100
	b:AddSeedlings(18)
	b.Moveable = False
	
	-- Asteroid 6
	b = AddAsteroidWithAttribs(3300,2300, 0.5,0.3,0.6)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(400)
	b.SendDistance = 500
	b:AddSeedlings(11)
	b.Moveable = False
	
	
	-- Asteroid 7
	b = AddAsteroidWithAttribs(2100,-3000, 0.5,0.5,0.6)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(200)
	b.SendDistance = 7000
	b:AddSeedlings(4)
	b.Moveable = False
	
	
	-- Asteroid 8
	b = AddAsteroidWithAttribs(2000,-1000, 0.5,0.4,0.4)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(420)
	b.SendDistance = 600
	b:AddSeedlings(10)

	
	-- Asteroid 9
	b = AddAsteroidWithAttribs(3000,-2200, 0.6,0.5,0.5)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(350)
	b.SendDistance = 1000


	-- Asteroid 10
	b = AddAsteroidWithAttribs(-3000,-2300, 0.5,0.5,0.6)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(200)
	b.SendDistance = 700
	b:AddSeedlings(0)
	b.Moveable = False

	-- Asteroid 11
	b = AddAsteroidWithAttribs(-2100,-2700, 0.7,0.6,0.4)
	b.Owner = 0
	b.TreeCap = 4
	b:SetRadius(320)
	b.SendDistance = 700
	b:AddSeedlings(15)
	b.Moveable = False

	-- Asteroid 12
	b = AddAsteroidWithAttribs(200,-3200, 0.6,0.6,0.5)
	b.Owner = 0
	b.TreeCap = 2
	b:SetRadius(210)
	b.SendDistance = 200
	b:AddSeedlings(11)
	b.Moveable = False

	-- Asteroid 13
	b = AddAsteroidWithAttribs(-3600,-1100, 0.6,0.6,0.4)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(320)
	b.SendDistance = 200
	b:AddSeedlings(15)
	b.Moveable = False

	-- Asteroid 14
	b = AddAsteroidWithAttribs(900,3200, 0.4,0.6,0.6)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(210)
	b.SendDistance = 500
	b:AddSeedlings(11)
	b.Moveable = False

	-- Asteroid 15 -- 2nd Giant 
	b = AddAsteroidWithAttribs(-5600,-4600, 0.9,0.7,0.9)
	b.Owner = 2
	b.TreeCap = 7
	b:SetRadius(995)
	b.SendDistance = 1500
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddSeedlings(55)
	b.Moveable = False

	-- Asteroid 16
	b = AddAsteroidWithAttribs(-2900,2500, 0.7,0.5,0.7)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(210)
	b.SendDistance = 500
	b:AddSeedlings(11)
	b.Moveable = False
	
	-- Asteroid 17
	b = AddAsteroidWithAttribs(-4200,1600, 0.5,0.7,0.7)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(290)
	b.SendDistance = 200
	b:AddSeedlings(5)
	b.Moveable = False

	-- Asteroid 18
	b = AddAsteroidWithAttribs(-5100,3100, 0.4,0.8,0.5)
	b.Owner = 0
	b.TreeCap = 2
	b:SetRadius(210)
	b.SendDistance = 200
	b:AddSeedlings(11)
	b.Moveable = False
	
	-- Asteroid 19
	b = AddAsteroidWithAttribs(-3200,4400, 0.5,0.5,0.7)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(110)
	b.SendDistance = 400
	b:AddSeedlings(11)
	b.Moveable = False
	
	-- Asteroid 20 - 3rd Giant
	b = AddAsteroidWithAttribs(-5700,5200, 0.9,0.9,0.8)
	b.Owner = 2
	b.TreeCap = 8
	b:SetRadius(1100)
	b.SendDistance = 900
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddSeedlings(21)
	b.Moveable = False
	
	-- Asteroid 21
	b = AddAsteroidWithAttribs(-5000,1000, 0.7,0.8,0.6)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(310)
	b.SendDistance = 1000
	b:AddSeedlings(35)
	b.Moveable = False
	
	-- Asteroid 22
	b = AddAsteroidWithAttribs(-6500,-700, 0.5,0.7,0.8)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(420)
	b.SendDistance = 300
	b:AddSeedlings(11)
	b.Moveable = False
	
	-- Asteroid 23 - 4th Giant
	b = AddAsteroidWithAttribs(-10000,-2700, 0.9,0.9,0.9)
	b.Owner = 2
	b.TreeCap = 14
	b:SetRadius(1500)
	b.SendDistance = 1500
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = b:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddDefenseTree()
	b:AddSeedlings(215)
	b.Moveable = False

end


function LevelLogic()


-- Greeting

	Timer = GetGameTime() + 3


	while GetGameTime() < Timer do

		coroutine.yield()
	end

	Pause()
	MessageBox("Greetings...                                                      Your task is to eradicate the enemy threat in this sector.                                        Good Luck!")
	WaitDialog()
	Unpause()


--colour wave/ pulsing effect
	
	while GameRunning() do

	--rtime = GetGameTime()	 -- setting the variable 'time' to whatever the game time is
	--rtime = rtime / 16 	 -- taking that 'time' variable and dividing it by n.  divide slows down. multiply speeds up.
	--gtime = GetGameTime()
	--gtime = gtime / 24
	btime = GetGameTime()
	btime = btime / 42


	--rcolour = math.sin(rtime) -- setting the variable 'rcolour' to wave up and down. like this the range is now -1 to 1. 1 being the peak of the wave and -1 being the trough. with the horizontal axis as 'time', in this case the 'time' variable.
	--rcolour = rcolour * 195  -- setting the range of 'rcolour' from 0 to 255. in this case the 'r' referring to 'red'. do the same with 'g' and 'b'
	--gcolour = math.sin(gtime)
	--gcolour = gcolour * 235
	bcolour = math.sin(btime)
	bcolour = bcolour * 95


	SetBackdropColour(5,15,bcolour) -- makes the background change between black and red. the 2 numbers refer to the green and blue. 0 is black/min. 255 is white/max


	-- Victory Trigger
			

		if GetEmpire(2):GetNumOwnedAsteroids() == 0 then 
		Pause()
		MessageBox("Victory! Well Done...   Ice and a slice?")
		WaitDialog()
		Unpause()
		Quit(true)
		end
		

		if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
		Pause()
		MessageBox("Try again..                                                     It's not for girls...")
		WaitDialog()
		Unpause()
		Quit(false)
		end

	coroutine.yield()
	end

end
	
