-- AWS -- Montezuma's Revenge
function LevelSetup()
Game = luanet.import_type("Eufloria.Game") -- Import the game type to get access to the game instance and therefore the backdrop colour.
	Colour=Game.Instance.BackdropColour -- Copy the existing backdrop colour - we're only doing this to get hold of a colour object we can change.
	Colour.R = 0 -- insert your own colour.  allowed values 0-1
	Colour.G = 0
	Colour.B = 0.012
	Game.Instance.BackdropColour = Colour -- re-assign the backdrop colour to your own value.
	Game.Instance.TargetBackdropColour = Colour -- Set the target backdrop colour or the backdrop will fade right back to where it was. If you don't do this you'll get a flash of your desired colour - could also be useful.
	
-- ** Set Global Values **( --

	Globals.G.Asteroids=(0)				 -- this sets the number of auto-added asteroids.... since you're placing your own, you don't want any added, so set it to 0!)

	Globals.Asteroids.SpawnCap=55
	Globals.Asteroids.SeedlingCap=3456
	--Globals.Asteroids.MinSendDistance=0.5
	--Globals.Asteroids.MaxSendDistance=0.5
	Globals.Asteroids.MinCoreHealth=50
	Globals.Asteroids.MaxCoreHealth=1250

	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(2)				 --multiple enemies!!!

	--Globals.Structures.MinHealth=(90)			 --test these values
	--Globals.Structures.MaxHealth=(200)
	Globals.Structures.FlowerProbability=(0.178)
	
	--Globals.Structures.StartThickness=(.1)
	--Globals.Structures.OnGrowthThickness=(1.4)	--(2.0) is thick!
	--Globals.StructuresDefense.StartThickness=(.8)
	--Globals.StructuresDefense.OnGrowthThickness=(1.6)
	
	Globals.Flowers.MinSpeed=30				-- takes long time to plant itself at 1000speed! bounces around for a minute before planting
	Globals.Flowers.MaxSpeed=60
	Globals.Flowers.GrowTime=(85)			-- 85 seems good

	Globals.Mines.MinSpeed=50				-- imo, more important than maxspeed. 100 is too fast! 
	Globals.Mines.MaxSpeed=95
	Globals.Mines.MinHealth=275
	Globals.Mines.MaxHealth=700
	Globals.Mines.GrowTime=(71)				-- the higher, the slower growth. 71 is perfect for Monte's Revenge

	Globals.Mines.LaserPowerMin=(0.150)		-- want to make mines more powerful to compensate for making them slightly slower to build.
	Globals.Mines.LaserPowerMax=(0.275)
	Globals.Mines.LaserRange=(222)			-- a second compensation for making it more powerful, limit the range slightly.
	Globals.Mines.NumberOfLasers=7			-- interesting option -- nice ingame visuals -- proving to be a v.interesting game-balancing device...
	Globals.Mines.ExplosionRadiusPower=(550)-- final tweak to balance all values for mines. had to increase due to AIv2's increased stats!

--AI stuff for Greys

	GetAI(0).Cowardice = 0.06				--chances of retreating a battle we are losing
	GetAI(0).MinExpansionForce = 30
	GetAI(0).BattleSavvy = 0.85				--chances of picking a battle for a valuable asteroid - don't put this at 1 or the AI will only look at one asteroid at a time!
	GetAI(0).ReinforcementGreed = 0.71		--proportion of existing forces elsewhere to send in aid of battle
	GetAI(0).GreedyExpansion = 0.68		 	--likelihood of sending all/ most of the seedlings to expand
	GetAI(0).AidEnthusiasm = 0.69			--how much to overshoot the battle rating when sending aid, to allow for inbound enemy forces, estimate errors, travel time, wanting to win, etc
	GetAI(0).ExpandBlind = 0.45			 	--likelihood of expanding to asteroids that haven't been scouted yet
	GetAI(0).ExpandToValuableAsteroidChance = 0.89 --likelihood of choosing a more valuable asteroid to expand to

	--SetBackdropColour (0,0,2) -- not necessary with Game.Instance.BackdropColour at very top :)
	SetCameraZoomNow(15)


--
-- Below is for CENTRAL GATEWAY region --
--


	--  (0) -- 'central Czar Star' --
	b = AddAsteroidWithAttribs(12500,900, 0.93,0.91,0.85)
	b.Owner = 0
	b.TreeCap = 8
	b:SetRadius(1205)
	b.SendDistance = 9200
	s = b:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s = b:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = b:AddDysonTree()
	s = b:AddDysonTree()
	b:AddSeedlings(45)
	GetAsteroid(0):Reveal(1) -- which asteroid ID? 0 in this case as its roid no.1 in the list, then reveal it to which player? no.1

	--  (0) -- 'gateway West'
	c = AddAsteroidWithAttribs(7000,0, 0.81,0.85,0.75)
	c.Owner = 0
	c.TreeCap = 5
	c:SetRadius(475)
	c.SendDistance = 5300
	c:AddSeedlings(10)
	s = c:AddDefenseTree()
	s = b:AddDysonTree()
	c.Moveable = False

	--  (0) -- 'gateway North East'
	c = AddAsteroidWithAttribs(16500,-3500, 0.85,0.81,0.75)
	c.Owner = 0
	c.TreeCap = 5
	c:SetRadius(465)
	c.SendDistance = 6000
	c:AddSeedlings(10)
	s = c:AddDefenseTree()
	s = b:AddDysonTree()
	c.Moveable = False

	--  (1) -- ' Southside ' -- PLAYER START ROID --
	a = AddAsteroidWithAttribs(14500,12000, 0.8,0.89,0.85)
	a.Owner = 1
	a.TreeCap = 7
	a:SetRadius(630)
	a.SendDistance = 8000
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()	
	s:LevelUp()
	s:LevelUp()
	f = s:AddFlower()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()	
	s:LevelUp()
	s = a:AddDysonTree()
	a:AddSeedlings(45)
	a.Moveable = False

--
-- END of CENTRAL. Below is the WEST REGION , land of 3's --
--

	-- Asteroid 0
	b = AddAsteroidWithAttribs(0,0, 0.7,0.8,0.8)
	b.Owner = 3
	b.TreeCap = 6
	b:SetRadius(445)
	b.SendDistance = 2800
	s = b:AddDysonTree()
	b:AddDefenseTree()
	b.Moveable = False

	--  due south of central bloc gateway west 1 -- nearest first main action roid to the north! leftover player roid **
	c = AddAsteroidWithAttribs(6000,4500, 0.75,0.7,0.85)
	c.Owner = 0
	c.TreeCap = 4
	c:SetRadius(395)
	c.SendDistance = 3000
	c:AddSeedlings(10)
	b:AddDefenseTree()
	c.Moveable = False

	--  due south of central bloc gateway west 2 -- pushed out roid! **
	c = AddAsteroidWithAttribs(5500,8800, 0.61,0.58,0.72)
	c.Owner = 0
	c.TreeCap = 3
	c:SetRadius(280)
	c.SendDistance = 1600
	c:AddSeedlings(5)
	c.Moveable = False

	--  due south of central bloc gateway west 4 -- smallest of those nearest start roid to the west  (0)**
	c = AddAsteroidWithAttribs(8500,8000, 0.49,0.70,0.59)
	c.Owner = 3
	c.TreeCap = 2
	c:SetRadius(180)
	c.SendDistance = 900
	c.Moveable = False

	--  due south of central bloc gateway west 3 -- closest west to start roid** (0)
	c = AddAsteroidWithAttribs(10000,11500, 0.39,0.71,0.79)
	c.Owner = 2
	c.TreeCap = 3
	c:SetRadius(280)
	c.SendDistance = 1500
	c.Moveable = False

--

	--  south east 1 (0)
	b = AddAsteroidWithAttribs(1300,1950, 0.45,0.5,0.7)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(250)
	b.SendDistance = 2050
	b.Moveable = False	
	
	-- north east a bridge 1 (0)
	b = AddAsteroidWithAttribs(955,-1950, 0.5,0.45,0.25)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(150)
	b.SendDistance = 1800
	s = b:AddDefenseTree()
	s:LevelUp()
	b.Moveable = False

	-- north west 2 (3)
	b = AddAsteroidWithAttribs(-20,-2600, 0.56,0.71,0.93)
	b.Owner = 3
	b.TreeCap = 3
	b:SetRadius(225)
	b.SendDistance = 2000
	b.Moveable = False

	-- north west 4 (3)
	b = AddAsteroidWithAttribs(-6500,-5700, 0.7,0.49,0.6)
	b.Owner = 3
	b.TreeCap = 4
	b:SetRadius(300)
	b.SendDistance = 4300
	b.Moveable = False
	
	-- north west 4 (3)
	b = AddAsteroidWithAttribs(-4500,-4500, 0.37,0.59,0.33)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(170)
	b.SendDistance = 2000
	b.Moveable = False

	-- north north west 2 (3)
	b = AddAsteroidWithAttribs(-1100,-4200, 0.47,0.51,0.67)
	b.Owner = 3
	b.TreeCap = 2
	b:SetRadius(100)
	b.SendDistance = 1800
	b.Moveable = False

	-- north west 5 (3)
	b = AddAsteroidWithAttribs(-2450,-5300, 0.57,0.61,0.6)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(190)
	b.SendDistance = 2300
	b.Moveable = False

	-- north north west 1 -- main west roid (2)
	b = AddAsteroidWithAttribs(-2900,-3050, 0.95,0.77,0.58)
	b.Owner = 2
	b.TreeCap = 6
	b:SetRadius(440)
	b.SendDistance = 2900
	s = b:AddDefenseTree()
	s:LevelUp()
	b:AddSeedlings(10)
	b.Moveable = False

	-- north west 3 triangle connector (3)
	c = AddAsteroidWithAttribs(-2800,-500, 0.71,0.82,0.61)
	c.Owner = 3
	c.TreeCap = 4
	c:SetRadius(190)
	c.SendDistance = 2000
	s = c:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	c:AddSeedlings(10)
	c.Moveable = False

	--  south west 1 (3)!
	d = AddAsteroidWithAttribs(-4500,1350, 0.77,0.8,0.66)
	d.Owner = 3
	d.TreeCap = 4
	d:SetRadius(370)
	d.SendDistance = 4100
	d:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	f = s:AddFlower()
	d.Moveable = False

	-- south south west 1 (3) -- beyond Defense tree roid
	d = AddAsteroidWithAttribs(-2100,4000, 0.85,0.69,0.75)
	d.Owner = 3
	d.TreeCap = 3
	d:SetRadius(275)
	d.SendDistance = 3900
	d:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	f = s:AddFlower()
	d:AddSeedlings(5)
	d.Moveable = False

	-- west south west 1 (3) -- 'BIG' roid
	d = AddAsteroidWithAttribs(-8200,-1000, 0.95,0.95,0.85)
	d.Owner = 3
	d.TreeCap = 6
	d:SetRadius(860)
	d.SendDistance = 8800
	d:AddSeedlings(10)
	d.Moveable = False

	-- east south east 1 (3)
	c = AddAsteroidWithAttribs(2600,600, 0.55,0.55,0.5)
	c.Owner = 3
	c.TreeCap = 3
	c:SetRadius(190)
	c.SendDistance = 2300
	s = c:AddDefenseTree()
	s:LevelUp()	
	c:AddSeedlings(10)
	c.Moveable = False

	-- north east a bridge 2 (2)
	b = AddAsteroidWithAttribs(3700,-4450, 0.56,0.65,0.44)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(195)
	b.SendDistance = 2500
	b:AddSeedlings(15)
	s = b:AddDefenseTree()
	s:LevelUp()
	b.Moveable = False

	-- east north east 1 (3)
	c = AddAsteroidWithAttribs(4500,-900, 0.7,0.51,0.72)
	c.Owner = 3
	c.TreeCap = 3
	c:SetRadius(240)
	c.SendDistance = 2900
	c.Moveable = False

	-- N.E. Region  -- northern big connectors west (3)
	b = AddAsteroidWithAttribs(3600,-2250, 0.79,0.62,0.85)
	b.Owner = 3
	b.TreeCap = 3
	b:SetRadius(255)
	b.SendDistance = 3000
	s = b:AddDysonTree()
	s:LevelUp()
	b.Moveable = False

--
-- END of WEST region. Below is for NORTH EAST TERRITORY --	
--

	-- 1st N.E. Region -- closest to Gateway roid -- east -- COORDS 12000, 0 (2)
	b = AddAsteroidWithAttribs(21200,-3500, 0.64,0.78,0.72)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(275)
	b.SendDistance = 4000
	s = b:AddDysonTree()
	s:LevelUp()
	b.Moveable = False

	-- N.E. Region -- closest to Gateway roid -- north (2)
	b = AddAsteroidWithAttribs(14900,-5600, 0.54,0.59,0.8)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(155)
	b.SendDistance = 4000
	b.Moveable = False

	-- N.E. Region  -- northern big connectors south  (2)
	b = AddAsteroidWithAttribs(12500,-9000, 0.83,0.82,0.86)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(410)
	b.SendDistance = 4000
	b.Moveable = False

	-- N.E. Region  -- most northern biggest connector north  (2)
	b = AddAsteroidWithAttribs(10100,-12100, 0.89,0.74,0.88)
	b.Owner = 2
	b.TreeCap = 6
	b:SetRadius(650)
	b.SendDistance = 7000
	s = b:AddDysonTree()
	b.Moveable = False

	-- N.E. Region  -- due west of biggest most northern connector (code immediately above)  (2)
	b = AddAsteroidWithAttribs(6100,-12500, 0.62,0.7,0.86)
	b.Owner = 2
	b.TreeCap = 3
	b:SetRadius(300)
	b.SendDistance = 4000
	s = b:AddDysonTree()
	b.Moveable = False

	-- N.E. Region  -- tiny roid due west of biggest most northern connector (code immediately above)  (3)
	b = AddAsteroidWithAttribs(4550,-9750, 0.35,0.71,0.9)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(200)
	b.SendDistance = 3200
	b.Moveable = False

	-- N.E. Region  -- due west most northern connector	(2)
	b = AddAsteroidWithAttribs(5000,-7000, 0.83,0.69,0.8)
	b.Owner = 2
	b.TreeCap = 5
	b:SetRadius(400)
	b.SendDistance = 3500
	b:AddSeedlings(10)
	b.Moveable = False

	-- N.E. Region  --  closer roids to West Region due west of biggest most northern connector !  (3)
	b = AddAsteroidWithAttribs(1150,-9000, 0.52,0.78,0.76)
	b.Owner = 3
	b.TreeCap = 3
	b:SetRadius(315)
	b.SendDistance = 4000
	s = b:AddDysonTree()
	s:LevelUp()
	b.Moveable = False

	-- N.E. Region  --  closer roids to West Region due west of biggest most northern connector -- 5 tree!	(3)
	b = AddAsteroidWithAttribs(-3900,-9000, 0.86,0.95,0.69)
	b.Owner = 3
	b.TreeCap = 5
	b:SetRadius(475)
	b.SendDistance = 4900
	b:AddSeedlings(10)
	s = b:AddDysonTree()
	b.Moveable = False

	-- N.E. Region  --  closest to West Region  (3) 
	b = AddAsteroidWithAttribs(-450,-5700, 0.5,0.38,0.86)
	b.Owner = 0
	b.TreeCap = 2
	b:SetRadius(120)
	b.SendDistance = 2800
	s = b:AddDysonTree()
	b.Moveable = False

	-- N.E. Region  -- connectors due north of start roid(2) -- in between 2 main AI roids and skirting north of Czar
	b = AddAsteroidWithAttribs(9350,-2150, 0.43,0.6,0.5)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(215)
	b.SendDistance = 2910
	s = b:AddDysonTree()
	s:LevelUp()
	s = b:AddDefenseTree()
	b.Moveable = False

	-- N.E. Region  -- southern connectors right lower speed (2) -- in between 2 main AI roids and skirting north of Czar
	b = AddAsteroidWithAttribs(11200,-4300, 0.35,0.5,0.71)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(175)
	b:AddSeedlings(5)
	s = b:AddDefenseTree()
	b.SendDistance = 3000
	b.Moveable = False
	
	-- N.E. Region  -- southern connectors right lower speed (2) -- in between 2 main AI roids and skirting north of Czar
	b = AddAsteroidWithAttribs(13500,-3900, 0.55,0.37,0.21)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(170)
	b:AddSeedlings(5)
	s = b:AddDefenseTree()
	b.SendDistance = 2800
	b.Moveable = False

	-- N.E. Region  -- southern connectors right upper balanced (2)
	b = AddAsteroidWithAttribs(12500,-6200, 0.56,0.55,0.57)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(140)
	b.SendDistance = 3500
	b.Moveable = False

	-- N.E. Region  -- southern connectors middle strength (2)
	b = AddAsteroidWithAttribs(8500,-5000, 0.39,0.88,0.55)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(115)
	b.SendDistance = 3000
	b.Moveable = False

	-- N.E. Region  -- southern connectors left energy (3)
	b = AddAsteroidWithAttribs(5900,-3850, 0.88,0.35,0.55)
	b.Owner = 0
	b.TreeCap = 4
	b:SetRadius(245)
	b.SendDistance = 3000
	b.Moveable = False

	-- N.E. Region -- north (2)
	b = AddAsteroidWithAttribs(15550,-10000, 0.68,0.25,0.65)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(345)
	b.SendDistance = 4000
	b.Moveable = False

	-- N.E. Region -- north (2)
	b = AddAsteroidWithAttribs(18000,-7150, 0.66,0.78,0.46)
	b.Owner = 0
	b.TreeCap = 3
	b:SetRadius(230)
	b.SendDistance = 3500
	b.Moveable = False

	-- N.E. Region -- north (2)
	b = AddAsteroidWithAttribs(20000,-8500, 0.38,0.68,0.82)
	b.Owner = 0
	b.TreeCap = 2
	b:SetRadius(180)
	b.SendDistance = 2000
	b.Moveable = False

	-- N.E. Region -- north (2)
	b = AddAsteroidWithAttribs(23800,-7200, 0.68,0.78,0.28)
	b.Owner = 2
	b.TreeCap = 4
	b:SetRadius(430)
	b.SendDistance = 4400
	b.Moveable = False

	-- N.E. Region -- north (2)
	b = AddAsteroidWithAttribs(19500,-11000, 0.35,0.75,0.5)
	b.Owner = 2
	b.TreeCap = 2
	b:SetRadius(140)
	b.SendDistance = 4000
	b.Moveable = False

	-- N.E. Region -- NE BIG roid (2)
	b = AddAsteroidWithAttribs(26800,-13000, 0.94,0.95,0.85)
	b.Owner = 2
	b.TreeCap = 7
	b:SetRadius(1000)
	b.SendDistance = 15500
	b:AddSeedlings(10)
	b.Moveable = False
	
--	
-- ** Below is the SOUTH REGION ** -- there to help the player get a grip on the game!
--

	-- due east of starting roid --
	a = AddAsteroidWithAttribs(18000,16000, 0.52,0.9,0.35)
	a.Owner = 1
	a.TreeCap = 2
	a:SetRadius(195)
	s = a:AddDysonTree()
	a:AddSeedlings(10)
	a.SendDistance = 5500
	a.Moveable = False
	
	a = AddAsteroidWithAttribs(22500,21500, 0.9,0.3,0.65)
	a.Owner = 1
	a.TreeCap = 3
	a:SetRadius(275)
	s = a:AddDysonTree()
	s = a:AddDysonTree()
	a.SendDistance = 7000
	a.Moveable = False
	
	a = AddAsteroidWithAttribs(20000,9600, 0.8,0.79,0.75)
	a.Owner = 1
	a.TreeCap = 5
	a:SetRadius(415)
	a.SendDistance = 4800
	a:AddSeedlings(35)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	a.Moveable = False
	
	a = AddAsteroidWithAttribs(30000,20000, 0.9,0.985,0.49)
	a.Owner = 1
	a.TreeCap = 6
	a:SetRadius(899)
	s = a:AddDefenseTree()
	s = a:AddDysonTree()
	s = a:AddDysonTree()
	a.SendDistance = 15000
	a.Moveable = False
--	
	a = AddAsteroidWithAttribs(23500,6100, 0.66,0.5,0.75)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(345)
	a.SendDistance = 4550
	a.Moveable = False
	
	a = AddAsteroidWithAttribs(19000,4700, 0.8,0.32,0.78)
	a.Owner = 3
	a.TreeCap = 4
	a:SetRadius(295)
	a.SendDistance = 4800
	a.Moveable = False
	
	a = AddAsteroidWithAttribs(16400,2850, 0.45,0.49,0.5)
	a.Owner = 0
	a.TreeCap = 2
	a:SetRadius(150)
	a.SendDistance = 2500
	a:AddSeedlings(5)
	a.Moveable = False
	
-- (54 roids)
	
--	
-- ** Pilchard's Rallypoint Code part 1/2 ** --
--

	
--	
-- ** AI part 1/2 ** --
--
	
	-- *** INFECTED AI V2 INIT ***
	-- BETA VERSION 2.3
	-- Author: ANNIKK.EXE [at] GMAIL [dot] COM
	
	
	Globals.AI.GraceTimer=(99999)
	
	-- Number of times the engine is run per While loop:
	numberofiterations = 0
	-- Set to 0 for very large maps. (50 asteroids+)
	-- Set to 2-4 for small maps for quicker AI response.
	
	metric = {}
	currentowner = {}
	
	for i = 0,200 do
		metric[i] = 500
		end

	-- *** END INFECTED AI INIT ***
	
end


--
--
--


function LevelLogic()
	

-- ** Greeting ** --

	Timer = GetGameTime() + 7
	
	while GameRunning() do

		if Timer < GetGameTime() and Timer > 5 and Timer < 20 then -- annikk's additions
			Pause()
			MessageBox("Namast...																																							 Be at peace with your fellow universal inhabitants.																													War is so unpleasant...")
			WaitDialog()
			Unpause()
			
			Timer = 0 -- annikk's additions
		end
	
	
-- ** Pilchard's Rallypoint Code part 2/2 ** --

	
	
	

-- ** Colourwave/ pulsing effect ** --




	
-- ** Victory Trigger ** -- for 2 enemies
		  

		if GetEmpire(2):GetNumOwnedAsteroids() == 0 and GetEmpire(3):GetNumOwnedAsteroids() == 0 then

			if newtimer == nil then
				newtimer = GetGameTime() + 5
			end

			if newtimer <= GetGameTime() then
			Pause()
			MessageBox("You have controlled The Entire Region. This is most excellent news! Be pleased that you have conquered another bunch of pesky inter-galactic hooligans.")
			WaitDialog()
			Unpause()
			Quit(true)
			end
		end
		
	if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
		Pause()
		MessageBox("Calamity! 																									Total  DEFEAT! 																								...The Central Region is a hostile place indeed...	")
		WaitDialog()
		Unpause()
		Quit(false)
	end

	
-- ** AI part 2/2 ** --

		-- *** INFECTED AI V2 ***
		-- BETA VERSION 2.3
		-- Author: ANNIKK.EXE [at] GMAIL [dot] COM
		numberofasteroids = -1
		neighbours = {}

		for i = 0, 200 do
			if GetAsteroid(i) ~= nil then
				if GetAsteroid(i).radius > 10 then
					numberofasteroids = numberofasteroids + 1
				end
			end
		end

		-- now the variable called "numberofasteroids" accurately represents the number of playable asteroids on the field.


		for iterations = 0,numberofiterations do
		
		
			-- Select an asteroid for checking.
			checkedroid = GetAsteroid(math.random(0,numberofasteroids))

			
			-- Record the current asteroid owner
			
			changedowner = false
			
			if currentowner[checkedroid.id] ~= nil then
				if currentowner[checkedroid.id] ~= checkedroid.owner then
					currentowner[checkedroid.id] = checkedroid.owner
					changedowner = true
				end
			else
				currentowner[checkedroid.id] = checkedroid.owner
			end

			
			tree = nil
			flower = nil
		
			-- flower check !
			tree = checkedroid:GetRandomDysonTree()
			
			if tree ~= nil then
				flower = tree:GetSuperSeedling()
			end
			
			if checkedroid.owner > 1 and flower ~= nil then
				flower:Pluck()
			end
			
			flower = checkedroid:GetFlower(checkedroid.owner)
			
			if checkedroid.owner > 1 and flower ~= nil then
				flower:PlantOnRandomDysonTree()
			end

		
		
			-- calculate which asteroids are a neighbour to checkedroid
			
			numberofneighbours = -1

			for i = 0,numberofasteroids do
				
				length = GetAsteroid(i).position.x - checkedroid.position.x
				height = GetAsteroid(i).position.y - checkedroid.position.y
				
				distancetoroid = math.sqrt((length * length) + (height * height))
				distancetoroid = distancetoroid - GetAsteroid(i).Radius
				
				if distancetoroid < checkedroid.SendDistance then
					-- this asteroid is in range.  Add it to the neighbours list, and increment the neighbour count by one.  ALSO ADDS SELF AS NEIGHBOUR!  But we trap for this in the Metric Update section.
					numberofneighbours = numberofneighbours + 1
					neighbours[numberofneighbours] = GetAsteroid(i)
				end
			end
		
			
		
		
			-- Metric update
		
			-- did we update from our own status?
			
			updated = false
			
			-- are we under attack?  if so set metric 0
			
			
			if checkedroid.owner ~= 1 and checkedroid.owner ~= 0 then
				
				
				if (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner)) > (checkedroid:GetNumTrees() * 5) or checkedroid:GetNumMines(1) > 0 then
					
					
					-- ok well we own this asteroid, and there are more enemy seeds here than our seeds (or there's a player mine here).  Now, we DO have at least 1 tree worth defending here, right?
					if checkedroid:GetNumTrees() > 0 then
						-- ok, we're under attack!  METRIC 0!
						metric[checkedroid.ID] = 0
						updated = true
						
						
					end
				end
			end
			
			
			
			-- are we maxed on trees?  if not, set metric 100
			
			-- (make sure we don't run this if we are under attack!)
			if updated == false then

				if checkedroid:GetNumTrees() < checkedroid.TreeCap then
					-- we don't have max trees here yet.  Metric 100!
					metric[checkedroid.ID] = 100
					updated = true
				end
				
			end
			-- Not under attack, maxed on trees, and ready to contribute to the empire.
			-- Check the status of our neighbours first before trying to become a gather point.
			
			
			-- only run this part of the code if we didn't get our metric from our own status
			if updated == false then
			
			
			
		

			
				-- are we a suitable gather point?
				
				enemydetected = false
				frienddetected = false
				gatherpointdetected = false
				lowermetricsnearby = false
			
				for i = 0, numberofneighbours do
				
					-- check that we're not examining ourself.
					if neighbours[i] ~= checkedroid then
			
						if neighbours[i].owner == checkedroid.owner then
							-- this asteroid is friendly to us
							frienddetected = true
						end
					
						if neighbours[i].owner ~= checkedroid.owner and neighbours[i].owner ~= 0 and neighbours[i]:GetNumTrees() > 0 then
							-- this asteroid doesn't belong to us or player 0, and has at least 1 tree.  It must be an enemy roid.
							enemydetected = true
						end
						
						
						numberofenemies = neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)
					
						if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumTrees() == 0 and numberofenemies > 0 then
							-- this asteroid doesn't belong to us, has no trees on it, but has enemy seedlings on it.  Treat it as enemy.
							enemydetected = true
						end
			
						
						if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].ID] == 200 then
							-- this asteroid is friendly to us, and is a gather point.
							gatherpointdetected = true
						end
					
						if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] ~= 500 then
							-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
							lowermetricsnearby = true
						end
					
					end
				
				end
				
				
				if enemydetected == true and frienddetected == true and gatherpointdetected == false and lowermetricsnearby == false then
					-- the conditions are right for me to become a gather point.
					metric[checkedroid.id] = 200
				elseif changedowner == true then
					-- the asteroid just became mine.  insta-gather point please!
					metric[checkedroid.id] = 200
				end
				

				
				-- Find the lowest metric among my neighbours
				lowestmetric = metric[checkedroid.ID]
				
				
				for i = 0, numberofneighbours do
					
					-- check that we're not examining ourself.
					if neighbours[i].id ~= checkedroid.id then
				
						if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
							-- this asteroid belongs to our empire, or it doesn't belong to anyone (and we should therefore follow its metrics)
							
							-- is this neighbour's metric less than mine?  (also, have we just taken this asteroid..?)
							if metric[neighbours[i].ID] < lowestmetric and changedowner == false then
								-- yes it's lower.
								lowestmetric = metric[neighbours[i].ID]
							end
					
						
						end
					
					end
				end
			
				
			
				-- now we've established what the lowest metric is.  If it's lower than ours, set ours to that +1.  If the lowest metric of a neighbour is the same as our metric, increase ours by 1.
				-- UNLESS we are a gather point
				if metric[checkedroid.ID] > lowestmetric and metric[checkedroid.ID] ~= 200 and metric[checkedroid.ID] ~= 100 then
					metric[checkedroid.ID] = lowestmetric + 5
				end
				
				if metric[checkedroid.ID] == lowestmetric and metric[checkedroid.ID] ~= 200 and metric[checkedroid.ID] ~= 100 then
					-- if my metric is the same as the lowest metric of my neighbours, i must be 1 step further away than they are.
					metric[checkedroid.ID] = metric[checkedroid.ID] + 5
				end
				
				-- check for errors, reset metric if necessary
				
				if metric[checkedroid.id] > 500 then
					metric[checkedroid.id] = 200
				end
				
				if metric[checkedroid.ID] > 0 and metric[checkedroid.ID] < 99 then
					stillinneed = false
					
					for i = 0,numberofasteroids do
						if GetAsteroid(i).Owner == checkedroid.Owner and metric[i] == 0 then
							stillinneed = true
						end
					end
					
					if stillinneed == false then
						for i = 0,numberofasteroids do
							if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 0 and metric[i] < 99 then
								metric[i] = 500
							end
						end
					end
				
				end
				
				if metric[checkedroid.ID] > 100 and metric[checkedroid.ID] < 199 then
					stillinneed = false
					for i = 0,numberofasteroids do
						if GetAsteroid(i).Owner == checkedroid.Owner or GetAsteroid(i).owner == 0 then
							if metric[i] == 100 then
								stillinneed = true
							end
						end
					end
					
					if stillinneed == false then
						for i = 0,numberofasteroids do
							if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 100 and metric[i] < 199 then
								metric[i] = 500
							end
						end
					end
				end
				
				if metric[checkedroid.ID] > 200 and metric[checkedroid.ID] < 299 then
					stillinneed = false
					for i = 0,numberofasteroids do
						if GetAsteroid(i).Owner == checkedroid.Owner and metric[i] == 200 then
							stillinneed = true
						end
					end
					
					if stillinneed == false then
						for i = 0,numberofasteroids do
							if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 200 and metric[i] < 299 then
								metric[i] = 500
							end
						end
					end
				end
				
				
				
				
				
				
			end
		
		
		
			-- Now to check that if we have metric 0, 100 or 200, we still require that status.
			
			if metric[checkedroid.id] == 0 then
				-- ok.  Am I REALLY still under attack?
				if checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner) > 1 or checkedroid:GetNumMines(1) > 0 then
					-- the enemy outnumber us, or there's a player mine here.  Yes, we're really under attack...
				else
					-- we're not really under attack anymore.  lets reset the metric.
					for i = 0, numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner then
							metric[i] = 500
						end
					
					end
					
					metric[checkedroid.id] = 200
					
				end
			end
			
			if metric[checkedroid.id] == 100 then
				-- ok.  Am I REALLY still under construction?
				if checkedroid:GetNumTrees() < checkedroid.TreeCap then
					-- we do indeed have less trees than the treecap, so we still need seeds.
				else
					-- we're not really under construction anymore.  lets reset the metric.
					metric[checkedroid.id] = 200
				end
			end
			
			
			
			enemydetected = false
			frienddetected = false
			gatherpointdetected = false	
			lowermetricsnearby = false
			
			
	
			-- ok.  Am I REALLY still a suitable gather point?
			for i = 0, numberofneighbours do
				-- check that we're not examining ourself.
				if metric[checkedroid.ID] == 200 and neighbours[i].ID ~= checkedroid.id and changedowner == false then
					if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
						-- this asteroid is friendly or neutral to us
						frienddetected = true
					end
				
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i].owner ~= 0 and neighbours[i]:GetNumTrees() > 0 then
						-- this asteroid doesn't belong to us or player 0, and has at least 1 tree.  It must be an enemy roid.
						enemydetected = true
					end
					
					numberofenemies = neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)
					
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumTrees() == 0 and numberofenemies > 9 then
						-- this asteroid doesn't belong to us, has no trees on it, but has enemy seedlings on it.  Treat it as enemy.
						enemydetected = true
					end
					
					if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].ID] == 200 then
						-- this asteroid is friendly to us, and is a gather point.
						gatherpointdetected = true
					end
					
					if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] < 200 then
						-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
						lowermetricsnearby = true
					end			
					if neighbours[i].owner == 0 and metric[neighbours[i].id] < 200 then
						-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
						lowermetricsnearby = true
					end	
				end
			
			
			end
			
			
			if metric[checkedroid.id] == 200 and changedowner == false then
				
				if enemydetected == true and gatherpointdetected == false and lowermetricsnearby == false then
					-- the conditions are right for me to continue as a gather point.

				else
					-- the conditions are no longer right.  Best to reset the metric.
					metric[checkedroid.id] = 500
				end
				

				
			end
		
			if frienddetected == false and enemydetected == true and checkedroid:GetNumTrees() == checkedroid.TreeCap then
				-- we're an orphan with max trees!  lets become a gather point.
				metric[checkedroid.id] = 200
			end
		
		
		
		
			-- Actions
			
			-- There are 3 different action types.  We must make sure not to use any actions for players 0 and 1!
			-- 1.  Plant trees
			
			-- trap for player 0, exclude player 1
			if checkedroid.owner == 0 or checkedroid.owner > 1 then
				-- so plant one :>
				for i = 2,10 do		
					
					if metric[checkedroid.id] == 100 and (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(i)) < 5 and checkedroid:GetNumSeedlings(i) > 9 then
						-- this asteroid isn't owned by greys or player, the enemy only has a bit of seedlings here
						-- its metric is 100
						-- and it has enough seedlings belonging to the asteroid's empire to plant a tree
						a = checkedroid:PlantDysonTree(i)
					end
				end
			end
			
			
			
			-- 2.  Send seedlings to the next lowest metric
			
			if metric[checkedroid.id] ~= 0 and metric[checkedroid.id] ~= 100 and metric[checkedroid.id] ~= 500 and checkedroid.owner > 1 then
			
				-- we're not under attack or construction.
				numberofdestinations = 0
				
				for i = 0,numberofneighbours do
					if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
						-- this neighbour is one of our asteroids, or it's a blank asteroid

						if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
							if metric[neighbours[i].ID] < metric[checkedroid.ID] then
								-- we've found a friendly neighbour with a metric lower than ours!
								-- add it to the destinations list
								numberofdestinations = numberofdestinations + 1
							end
						end


		
					end
				end
				
				if numberofdestinations > 0 then
				
					-- we've found some destinations to send seeds to.  Lets send some.
					numberofseedsleft = checkedroid:GetNumSeedlings(checkedroid.owner) - (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner))
					numberperdestination = numberofseedsleft / numberofdestinations
					
					for i = 0,numberofneighbours do
						if neighbours[i] ~= checkedroid then
							if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
								if metric[neighbours[i].ID] < metric[checkedroid.ID] then
									-- this destination has less than our metric.  This is one of the valid destinations.  Send a proportional amount of seeds to it.
									if neighbours[i].owner == 0 and numberofseedsleft < 10 then
										-- don't bother sending.
									
									elseif neighbours[i].owner == 0 and neighbours[i]:GetNumSeedlings(0) > 0 and numberofseedsleft > 9 + (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) then
										-- attack the greys!
										checkedroid:SendSeedlingsToTarget(checkedroid.owner, checkedroid:GetNumSeedlings(checkedroid.owner), neighbours[i])
										numberofseedsleft = 0
									
									elseif neighbours[i].owner == 0 and numberofseedsleft > 9 and (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) == 0 then
										-- this is the last we can manage.  Send all 10.
										checkedroid:SendSeedlingsToTarget(checkedroid.owner, 10, neighbours[i])
										numberofseedsleft = numberofseedsleft - 10
									
									elseif neighbours[i].owner == checkedroid.owner then
										checkedroid:SendSeedlingsToTarget(checkedroid.owner, numberperdestination, neighbours[i])
										numberofseedsleft = numberofseedsleft - numberperdestination
									end
								end
							end
						end
					end
				end
				
			
			
			
			
				-- 3.  Attack the weakest nearby asteroid
				
				-- Are we a gather point?  Only gather points are allowed to attack.
				
				if metric[checkedroid.id] == 200 then

					totalenemies = 0
					totalfriendlies = checkedroid:GetNumSeedlings(checkedroid.owner)
					weakestamount = 10000
					weakestroid = checkedroid
					attack = false
					orphan = true
					numberofenemyroids = 0

					
					for i = 0,numberofneighbours do
						
						if neighbours[i].owner == checkedroid.owner and neighbours[i] ~= checkedroid then
							orphan = false
						end
						
						if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner) > 5 then
							-- found an attack path
							numberofenemyroids = numberofenemyroids + 1
						end
						
						for j = 0,10 do
							if checkedroid.owner ~= j then
								totalenemies = totalenemies + neighbours[i]:GetNumSeedlings(j)
								
								if weakestamount > neighbours[i]:GetNumSeedlings(j) and neighbours[i].owner == j then
									-- the owner of this asteroid has a smaller number of seeds than we've seen before...
									weakestamount = neighbours[i]:GetNumSeedlings(j)
									weakestroid = neighbours[i]
								end
							
							
							end
						end
						
						if neighbours[i] ~= checkedroid and neighbours[i].owner ~= checkedroid.owner then
							if neighbours[i]:GetNumSeedlings(checkedroid.owner) > (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) then
								-- already attacking, and winning.  send reinforcements.
								checkedroid:SendSeedlingsToTarget(checkedroid.owner, checkedroid:GetNumSeedlings(checkedroid.owner), neighbours[i])
							
							end
						end
					end
					
					
					
					-- in the first case, we have more seedlings than all the neighbouring asteroids put together.
					if totalfriendlies > totalenemies + (weakestroid:GetNumTrees() * 10) then
						attack = true
					end
					
					split = false
					
					-- in the second case, we have more than 150 seedlings on this roid, and it's time to move out!
					if totalfriendlies > 150 then
						attack = true
						split = true
					end
					
					if totalfriendlies >= Globals.Asteroids.SpawnCap and orphan == true then
						attack = true
					end
					
					
					if attack == true and checkedroid.owner > 1 and split == false then
						-- ok so we're a gather point, we're ready to attack, and we aren't a player or greys asteroid.
						-- lets move out.
						checkedroid:SendSeedlingsToTarget(checkedroid.owner, totalfriendlies, weakestroid)
					elseif attack == true and checkedroid.owner > 1 and split == true then
					
						for i = 0,numberofneighbours do
							if neighbours[i].owner ~= checkedroid.owner then
								-- attackable path - send proportional amount of seeds.
								checkedroid:SendSeedlingsToTarget(checkedroid.owner, totalfriendlies / numberofenemyroids, neighbours[i])
							end
						end
					end
					
				
					
				end
			
			end
			-- Set asteroid names to whatever their metric is.
			

		
			--checkedroid.Name = metric[checkedroid.ID]
		end
	
		-- *** END INFECTED AI V2.3 ***

		
		
	
		coroutine.yield()
	end
end
