function LevelSetup()
	
	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.G.EnemyFactionsMin=(2)
	Globals.G.EnemyFactionsMax=(2)
	Globals.Structures.SpawnTime1 = 64
	Globals.Structures.SpawnTime2 = 32
	Globals.Structures.SpawnTime3 = 16
	Globals.Structures.SpawnTime4 = 8
	Globals.Asteroids.MaxTrees=(1)
	Globals.Asteroids.SpawnCap=(50)
	br = 200
	bg = 165
	bb = 188
	r = br
	g = bg
	bcolor = bb
	dev = false
	redcolor = 0
	warn = true
	
	--Transporter - 0
	transporter = AddAsteroidWithAttribs(20000,-40000, 0.01,0.01,0.01)
	transporter.Owner = 0
	transporter:SetRadius(500)
	transporter.SendDistance = 1000
	transporter.Moveable = false
	
	--Center - 1
	a = AddAsteroidWithAttribs(20000,0, 1.0,1.0,1.0)
	a.Owner = 0
	a:SetRadius(1000)
	a.SendDistance = 40000
	s = a:AddDysonTree()
	a.Moveable = false
	
	AddAsteroidRing(50, 20000, 0, 40000, 150)	-- Outer Ring		- 2 to 52
	AddAsteroidRing(25, 20000, 0, 30000, 150)	-- Inner outer Ring	- 53 to 77
	AddAsteroidRing(15, 20000, 0, 15000, 150)	-- Outer inner Ring	- 78 to 92
	AddAsteroidRing(8, 20000, 0, 5000, 150)		-- Inner Ring		- 92 to 100
	
	p1=math.random(2,11)
	GetAsteroid(p1).Owner = 1
	GetAsteroid(p1):SetEnergy(0.3)
	GetAsteroid(p1):SetStrength(0.4)
	GetAsteroid(p1):SetSpeed(0.3)
	GetAsteroid(p1):AddSeedlings(50)
	p1dt = GetAsteroid(p1):AddDysonTree()
	p2=math.random(27,37)
	GetAsteroid(p2).Owner = 2
	GetAsteroid(p2):SetEnergy(0.7)
	GetAsteroid(p2):SetStrength(0.6)
	GetAsteroid(p2):SetSpeed(0.5)
	GetAsteroid(p2):AddSeedlings(100)
	p2dt = GetAsteroid(p2):AddDysonTree()
	p3=math.random(42,50)
	GetAsteroid(p3).Owner = 3
	GetAsteroid(p3):SetEnergy(0.4)
	GetAsteroid(p3):SetStrength(0.8)
	GetAsteroid(p3):SetSpeed(0.6)
	GetAsteroid(p3):AddSeedlings(100)
	p3dt = GetAsteroid(p3):AddDysonTree()
	
	SetCameraPositionToAsteroidID(p1)
	SetCameraZoomNow(9)
	
end



function LevelLogic()
	
	Pause()
	MessageBox("Greetings, we have a problem in this galaxy of asteroids!\nWe have two enemies both fighting for the galaxy consiting of around 100 asteroids. \n\n Destroy the enemies and you have won!")
	WaitDialog()
	Unpause()
	
	GetEmpire(2).ExpandBlind = 0
	GetEmpire(2).MinExpansionTime = 4
	GetEmpire(2).MaxExpansionTime = 8
	GetEmpire(2).MinExpansionForce=(20)
	GetEmpire(2).ExpandToValuableAsteroidChance = 1
	GetEmpire(2).Cowardice = 1
	GetEmpire(2).MinScoutTime = 1	
	GetEmpire(2).MaxScoutTime = 3
	GetEmpire(2).MinScoutableArmy=(3)
	GetEmpire(2).MinGatherTime = 15
	GetEmpire(2).MaxGatherTime = 60
	GetEmpire(2).ReinforcementGreed = 1
	GetEmpire(2).AidEnthusiasm = 1
	GetEmpire(2).BattleSavvy = 0
	GetEmpire(2).RecognisableThreatProportion = 1
	GetEmpire(3).ExpandBlind = 1
	GetEmpire(3).MinExpansionTime = 1
	GetEmpire(3).MaxExpansionTime = 5
	GetEmpire(3).MinExpansionForce=(16)
	GetEmpire(3).ExpandToValuableAsteroidChance = 0
	GetEmpire(3).Cowardice = 0
	GetEmpire(3).MinScoutTime = 1		
	GetEmpire(3).MaxScoutTime = 2
	GetEmpire(3).MinScoutableArmy=(1)
	GetEmpire(3).MinGatherTime = 12
	GetEmpire(3).MaxGatherTime = 20
	GetEmpire(3).ReinforcementGreed = 0
	GetEmpire(3).AidEnthusiasm = 1
	GetEmpire(3).BattleSavvy = 0
	GetEmpire(3).RecognisableThreatProportion = 1
	
	print("Hello, thanks for playing my first public map 'Rings'!")
	print("If you encounter any problems PM me at the Eufloria forum!")
	print("")
	print("")
	print("Here you will be able to capture over 100 asteroids, fight two")
	print("enemy empires at the same time + the greys!")
	print("")
	print("This map contains flashing background, you can turn off this")
	print("by writing 'warn = false' in the console!")
	print("")
	print("")
	print("Thanks to Alex May and annikk.exe for the codes I have been")
	print("able to use!")
	
	while GameRunning() do
		
		if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
			Pause()
			MessageBox("You lost the rings to the enemy, what a fool!")
			WaitDialog()
			Unpause()
			Quit(false)
		end
		
		if GetEmpire(2):GetNumOwnedAsteroids() == 0 and GetEmpire(3):GetNumOwnedAsteroids() == 0 then
			Pause()
			MessageBox("The enemy is destroyed and the rings are safe, good job!")
			WaitDialog()
			Unpause()
			Quit(true)
		end
		
		SetVignetteAlpha(GetEmpire(2):GetNumOwnedAsteroids()*2.55 + GetEmpire(3):GetNumOwnedAsteroids()*2.55)
		
		DiceGift()
		Assault()
		if warn == true then
		CheckAttacks()
		end
		if GetAsteroid(0):GetSendDistance() < 40000 then
			GrowTransporter(0.1)
		end
		
		coroutine.yield()
		
	end
end

function DiceGift()
	
	local a = GetRandomAsteroid()
	local b = a.ID
	Dice(100)
	
	if dice < 5 then
		
		Dice(1000)
		
		if dice > 950 then
			
			Dice(10)
			
			if dice > 5 then
				
				Dice(100)
				local c = math.random(5,15)
				
				if dice > 85 then
					
					a:AddSuperSeedlings(c)
					if dev == true then
					print (string.format("%s %i %s", "Superseedlings added on ", b, "!"))
					end
					
				elseif dice < 65 then
					
					a:AddSeedlings(c)
					if dev == true then
					print (string.format("%s %i %s", "Seedlings added on ", b, "!"))
					end
					
				end
				
			end
			
		elseif dice < 50 and a:FreeSlots() > 0 and a:GetNumSeedlings(1) == 0 and a:GetNumSeedlings(2) == 0 and a:GetNumSeedlings(3) == 0 then
			
			Dice(10)
			
			if dice > 5 then
				
				Dice(100)
				
				if dice > 85 then
					
					a:AddDysonTree()
					if dev == true then
					print (string.format("%s %i %s", "Dyson added on ", b, "!"))
					end
					
				elseif dice < 65 then
					
					a:AddDefenseTree()
					if dev == true then
					print (string.format("%s %i %s", "Defensetree added on ", b, "!"))
					end
					
				end
				
			end
			
		end
		
	end
	
end

function Assault()
	
	local a = GetRandomAsteroid()
	local b = a.Owner
	local c = math.random(25,60)
	local d = a.ID 
	local e = GetAsteroid(1).Owner
	Dice(1000)
	
	if dice == 1 and e ~= b and b ~= 0 then
		
		GetAsteroid(1):AddSeedlings(c,0,0.7,0.7,0.7)
		GetAsteroid(1):SendSeedlingsToTarget(0,c,a)
		if dev == true then
			print (string.format("%s %i %s %i %s", "Sent ", c, "seedlings to assault ", d, "!"))
		end
		
	end
	
end

function Dice(inputednumber)
	
	dice = math.random(1,inputednumber)
	
end

function CheckAttacks() --Warns the player when asteroids are attacked
	
	for i = 0,99 do
		
		local warnasteroid = GetAsteroid(i)
		local b = warnasteroid.Owner
		local c = warnasteroid.ID
		
		if b == 1 then
			
			if warnasteroid:GetNumSeedlings(0) > 0 or warnasteroid:GetNumSeedlings(2) > 0 or warnasteroid:GetNumSeedlings(3) > 0 then
				
				if bcolor > 0 then
					bcolor=bcolor-2
				end
				if g > 0 then
					g=g-2
				end
				if r > 99 then
					redcolor = -2
				end
				if r < 33 then
					redcolor = 2
				end
				r=r+redcolor
				SetBackdropColor(r,g,bcolor)
				
			elseif warnasteroid:GetNumSeedlings(0) == 0 and warnasteroid:GetNumSeedlings(2) == 0 and warnasteroid:GetNumSeedlings(3) == 0 then
				
				if bcolor < bb then
					bcolor=bcolor+1
				end
				if g < bg then
					g=g+1
				end
				if r < br then
					r=r+1
				end
				SetBackdropColor(r,g,bcolor)
				
			end
			
		end
		
	end
	
end

function GrowTransporter(senddistancegrowt)
	
	local a = GetAsteroid(0)
	
	a.SendDistance = a:GetSendDistance() + senddistancegrowt
	
end