--	Made by 			Aino
--	Type: 				Map
--	Purpose				Fun
--	Other:				Nothing

function LevelSetup()
	
	Globals.G.Asteroids = 0
	Globals.G.EnemyFactionsMin=0
	Globals.G.EnemyFactionsMax=0
	SetBackdropColour(0,0,0)
	--Customizeable Variables:
	
	Numberofstars = 8
	MapSize = 60000
	Solarsystemsize = MapSize/10
	Starsizevariation_max = 3000
	Starsizevariation_min = 1500
	MinSystemSeparation = MapSize/10
	
	--Non-cutomizeable Variables!!!!!!!
	Star = {}
	Star_Attacked = {}
	Recommended_Dist = {}
	Numberoforbiters = {}
	PosX = {}
	PosY = {}
	Numberofroids = -1
	Home_System = math.random(1,Numberofstars)
	Enemy_System = math.random(1,Numberofstars)
	CheckSystem()
	Actual_Numberofstars = Numberofstars-1
	Home_Set = false
	Enemy_Set = false
	Score = 0
	Generator_done = false
	Generator()
end

function LevelDraw()
	
	if Generator_done == true then
		for draw_star = 0,Actual_Numberofstars do
			if IsOnScreen(PosX[draw_star],PosY[draw_star],Star[draw_star].Radius) then
				DrawSprite(5,PosX[draw_star],PosY[draw_star],math.sin(GetGameTime())+1.85,math.sin(GetGameTime())+0.9,0,0.9,Star[draw_star].Radius)
			end
		end
	end
end

function LevelLogic()
	
	Pause()
	MessageBox("Welcome commander, the galaxy is a dangerous place, we have a competing faction aganst us on another solar system.\n\nKill the oppositions and we can proceed to take over the rest of the galaxy, unless you do it...")
	WaitDialog()
	Unpause()
	
	while Score == 0 do
		coroutine.yield()
	end
	
	if Score == -1 then
		Pause()
		MessageBox("You lost the stars to the enemy, try again...")
		WaitDialog()
		Unpause()
		Quit(false)
	elseif Score == 1 then
		Pause()
		MessageBox("You won the stars, the vast space is ours!")
		WaitDialog()
		Unpause()
		Quit(true)
	end
end

function Generator()
	for i = 0,Actual_Numberofstars do
		Star_Attacked[i] = false
		PosX[i] = math.random(-MapSize,MapSize)
		PosY[i] = math.random(-MapSize,MapSize)
		CheckStarPos(i)
		Star[i] = AddAsteroidWithAttribs(PosX[i],PosY[i],1,1,1)
		Star[i].Moveable = false
		Star[i].Owner = 0
		Star[i].TreeCap = 1
		Star[i]:SetRadius(math.random(Starsizevariation_min,Starsizevariation_max))
		if i == Home_System then
			Numberoforbiters[i] = math.random(10,15)
		else
			Numberoforbiters[i] = math.random(5,10)
		end
	end
	for i = 0,Actual_Numberofstars do
		longest_dist = 0
		for j = 0,Actual_Numberofstars do
			if i ~= j then
				
				xdif = math.abs(PosX[i] - PosX[j])
				ydif = math.abs(PosY[i] - PosY[j])
				
				dist = math.sqrt((xdif*xdif)+(ydif*ydif))
				
				if dist > longest_dist then
					longest_dist = dist
				end
			end
		end
		Star[i].SendDistance = longest_dist
	end
	for i = 0,Actual_Numberofstars do
		for j = 1,Numberoforbiters[i] do
			temp_x = PosX[i] + math.random(-Solarsystemsize,Solarsystemsize)
			temp_y = PosY[i] + math.random(-Solarsystemsize,Solarsystemsize)
			
			temp = AddAsteroid(temp_x,temp_y)
			if i == Home_System then
				temp:SetEnergy(math.random(50,80)/100)
				temp:SetStrength(math.random(50,80)/100)
				temp:SetSpeed(math.random(50,80)/100)
				random_int = math.random(1,100)
				if random_int < 30 and Home_Set == false then
					temp.Owner = 1
					temp:AddSeedlings(50)
					temp2 = temp:AddDysonTree()
					temp2:LevelUp()
					Home_Set = true
					SetCameraPositionToAsteroidID(temp.ID)
				elseif Home_Set == false and j == Numberoforbiters[i] then
					temp.Owner = 1
					temp:AddSeedlings(50)
					temp2 = temp:AddDysonTree()
					temp2:LevelUp()
					Home_Set = true
					SetCameraPositionToAsteroidID(temp.ID)
				end
			elseif i == Enemy_System then
				temp:SetEnergy(math.random(50,80)/100)
				temp:SetStrength(math.random(50,80)/100)
				temp:SetSpeed(math.random(50,80)/100)
				random_int = math.random(1,100)
				if random_int < 30 and Enemy_Set == false then
					temp.Owner = 2
					temp:AddSeedlings(100)
					temp2 = temp:AddDysonTree()
					temp2:LevelUp()
					Enemy_Set = true
				elseif Enemy_Set == false and j == Numberoforbiters[i] then
					temp.Owner = 2
					temp:AddSeedlings(100)
					temp2 = temp:AddDysonTree()
					temp2:LevelUp()
					Enemy_Set = true
				end
			end
		end
	end
	Generator_done = true
end

function CheckSystem()
	if Home_System == Enemy_System then
		Enemy_System = math.random(1,Numberofstars)
		CheckSystem()
	end
end

function CheckStarPos(i)
	for j = 0,Actual_Numberofstars do
		if i ~= j and PosX[j] ~= nil and PosY[j] ~= nil then
			
			xdif = math.abs(PosX[i] - PosX[j])
			ydif = math.abs(PosY[i] - PosY[j])
			
			dist = math.sqrt((xdif*xdif)+(ydif*ydif))
			
			if dist <= MinSystemSeparation then
				longest_dist = dist
				PosX[i] = math.random(-MapSize,MapSize)
				PosY[i] = math.random(-MapSize,MapSize)
				CheckStarPos(i)
			end
		end
	end
end

function OnAsteroidRevealed(id, owner)
	if id <= Actual_Numberofstars then
		if owner ~= 0 and Star_Attacked[id] == false and Star[id].Owner == 0 then
			Star[id]:AddSeedlings(50)
			Star_Attacked[id] = true
		end
	end
end

function OnAsteroidTaken(id, owner)
	
	if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
		Score = -1
	elseif GetEmpire(2):GetNumOwnedAsteroids() == 0 then
		Score = 1
	end
end