function LevelSetup()
	
	Globals.G.Asteroids = 0
	Globals.G.GreysProbability = 0
	Globals.Asteroids.MaxTrees = 3
	Globals.G.EnemyFactionsMin=0
	Globals.G.EnemyFactionsMax=0
	Globals.Structures.FlowerProbability = 0.00
	SetBackdropColour(0,0,0)
	
	for i = 1,6 do
		for j = 1,6 do
			
			a = AddAsteroidWithAttribs(i*2000,j*2000, 0.5,0.5,0.5)
			
			if i == 1 and j == 1 then
				
				a.Owner = 1
				a:AddSeedlings(50)
				a:AddDysonTree()
				
			elseif i == 6 and j == 6 then
				
				a.Owner = 2
				a:AddSeedlings(50)
				a:AddDysonTree()
				
			elseif i == 6 and j == 1 then
				
				a.Owner = 3
				a:AddSeedlings(50)
				a:AddDysonTree()
				
			elseif i == 1 and j == 6 then
				
				a.Owner = 4
				a:AddSeedlings(50)
				a:AddDysonTree()
				
			end
			
		end
	end
	
	AAIInit()
	AIinit()
	
	Defeated = {false,false,false}
	
end

function LevelLogic()
	
	Pause()
	MessageBox("We seems to be fighting with four diferent races at once! Each of them have their strategic plan for capturing this vast board of asteroids. Kill them, destroy them!")
	WaitDialog()
	Unpause()
	
	GameTime = GetGameTime()
	while GameRunning() do
		if GetGameTime() > GameTime then
			GameTime = GetGameTime()
			AAIEngine()
			InfectedAIEngine()
		end
		if GetEmpire(1):GetNumOwnedAsteroids() == 0 and GetEmpire(1).NumSeedlings == 0 then
			Pause()
			MessageBox("What do you call this?! Victory? You've failed!")
			WaitDialog()
			Unpause()
			Quit(false)
		end
		if GetEmpire(2):GetNumOwnedAsteroids() == 0 and GetEmpire(2).NumSeedlings == 0 and Defeated[1] == false then
			Defeated[1] = true
			Pause()
			MessageBox("The Aliens have fled from the battlefield!")
			WaitDialog()
			Unpause()
		end
		if GetEmpire(3):GetNumOwnedAsteroids() == 0 and GetEmpire(3).NumSeedlings == 0 and Defeated[2] == false then
			Defeated[2] = true
			Pause()
			MessageBox("The Infected have died in war!")
			WaitDialog()
			Unpause()
		end
		if GetEmpire(4):GetNumOwnedAsteroids() == 0 and GetEmpire(4).NumSeedlings == 0 and Defeated[3] == false then
			Defeated[3] = true
			Pause()
			MessageBox("The *insert name for normal AI* has been extinct from the battlefield.")
			WaitDialog()
			Unpause()
		end
		if Defeated[1] == true and Defeated[2] == true and Defeated[3] == true then
			Pause()
			MessageBox("You won! I never thought you would... Ehhhrm... I mean: I knew you would do it!")
			WaitDialog()
			Unpause()
			Quit(true)
		end
		coroutine.yield()
	end
	
end

function AAIInit()
	
	Empire = 2	--Which AI empire should the AI control?
	
	Globals.AI.GraceTimer = 9999999
	Numroids = -1
	SelectedRoid = 0
	Priority = {}
	No_Priority = false
	ROwner = {}
	TakeBack = {}
	HaveRoots = {}
	HighestEnergy = 0
	HighestStr = 0
	HighestSpeed = 0
	
	for i = 0,100000 do
		if GetAsteroid(i) ~= nil then
			
			Numroids = Numroids + 1
			Priority[i] = 0
			TakeBack[i] = false
			ROwner[i] = GetAsteroid(i).Owner
			HaveRoots[i] = false
		
		else
		
			break
			
		end
		
	end
	
end

function AAIEngine()
	
	--Switches between the roids, randomly >.<
	
	HighestEnergy = 0
	HighestStr = 0
	HighestSpeed = 0
	
	for i = 0,Numroids do
	
		if ROwner[i] == Empire then
				
			if GetAsteroid(i).attribs.energy > HighestEnergy then
				
				HighestEnergy = GetAsteroid(i).attribs.energy
				
			end
			
			if GetAsteroid(i).attribs.strength > HighestStr then
				
				HighestStr = GetAsteroid(i).attribs.strength
				
			end
			
			if GetAsteroid(i).attribs.speed > HighestSpeed then
				
				HighestSpeed = GetAsteroid(i).attribs.speed
				
			end
			
		end
		
		if HaveRoots[i] == false and GetAsteroid(i):GetNumTrees() > 0 then
			
			HaveRoots[i] = true
			
		end
	
	end
	
	SelectedRoid = math.random(0,Numroids)
	Numneighbours = 0
	Neighbour = {}
	
	ChangedOwner = false
	
	if GetAsteroid(SelectedRoid).Owner ~= ROwner[SelectedRoid] then
	
		ChangedOwner = true
		
	end
	
	if ChangedOwner == true and ROwner[SelectedRoid] == Empire then
		
		TakeBack[SelectedRoid] = true
		
	end
	
	if ChangedOwner == true and TakeBack[SelectedRoid] == true and ROwner[SelectedRoid] ~= Empire and GetAsteroid(SelectedRoid).Owner == Empire then
		
		TakeBack[SelectedRoid] = false
		
	end
	
	--Flowertime :D No seriously -.-
	
	Tree = GetAsteroid(SelectedRoid):GetRandomDysonTree()
	
	if Tree ~= nil then
	
		Flower = Tree:GetSuperSeedling()
		
	end
	
	if Flower ~= nil and GetAsteroid(SelectedRoid).Owner == Empire then
	
		Flower:Pluck()
		
	end
	
	Flower = GetAsteroid(SelectedRoid):GetFlower(Empire)
	
	if Flower ~= nil and GetAsteroid(SelectedRoid).Owner == Empire then
	
		Flower:PlantOnRandomDysonTree()
		
	end
	
	--Now as we have the selectedroid here, begin making conditions for priorities to be set...
	--First if the roid is attacked, what do we do? We set the priority to zero, so the neighbours know that: "OMGosh, that roid is attacked, help it!"
	if GetAsteroid(SelectedRoid):GetNumSeedlingsExcluding(Empire) > GetAsteroid(SelectedRoid):GetNumSeedlings(Empire)/4 and GetAsteroid(SelectedRoid).Owner == Empire and Priority[SelectedRoid] > 0 then
		
		Priority[SelectedRoid] = 0
		
	elseif TakeBack[SelectedRoid] == true and Priority[SelectedRoid] ~= 0 then
		
		Priority[SelectedRoid] = 0
	
	end
	
	if GetAsteroid(SelectedRoid):GetMine(1) ~= nil then
		
		Priority[SelectedRoid] = 0
	
	end
	
	if GetAsteroid(SelectedRoid):GetNumTrees() < GetAsteroid(SelectedRoid).TreeCap and GetAsteroid(SelectedRoid):GetNumTrees() >= 1 and GetAsteroid(SelectedRoid).Owner == Empire and Priority[SelectedRoid] > Numroids*2 then
		
		Priority[SelectedRoid] = Numroids*2
		
	end
	
	if GetAsteroid(SelectedRoid):IsVisible(Empire) ~= true and Priority[SelectedRoid] > Numroids*4 then
		
		Priority[SelectedRoid] = Numroids*4
		
	end
	
	if GetAsteroid(SelectedRoid):GetNumTrees() == 0 and HaveRoots[SelectedRoid] == false and Priority[SelectedRoid] > Numroids*6 then
		
		Priority[SelectedRoid] = Numroids*6
		
	end
	
	if GetAsteroid(SelectedRoid).Owner ~= Empire and GetAsteroid(SelectedRoid):IsVisible(Empire) == true and GetEmpire(Empire).NumSeedlings > GetAsteroid(SelectedRoid):GetNumSeedlingsExcluding(Empire)*1.5 and Priority[SelectedRoid] > Numroids*8 then
		
		Priority[SelectedRoid] = Numroids*8
		
	end
	
	--Now check if all of the priorities are still correct, so we can decide if we want it to refresh or not...
	
	--Are we still attacked?
	if Priority[SelectedRoid] == 0 and GetAsteroid(SelectedRoid):GetNumSeedlingsExcluding(Empire) == 0 and GetAsteroid(SelectedRoid).Owner == Empire and TakeBack[SelectedRoid] == false and GetAsteroid(SelectedRoid):GetMine(1) == nil then
		
		Priority[SelectedRoid] = Numroids*10
		
	elseif Priority[SelectedRoid] == 0 and GetAsteroid(SelectedRoid).Owner ~= Empire and Priority[SelectedRoid] == 0 and TakeBack[SelectedRoid] == false then
		
		Priority[SelectedRoid] = Numroids*10
	
	end
	
	if Priority[SelectedRoid] == Numroids*2 and GetAsteroid(SelectedRoid):GetNumTrees() == GetAsteroid(SelectedRoid).TreeCap and GetAsteroid(SelectedRoid).Owner == Empire then
		
		Priority[SelectedRoid] = Numroids*10
		
	end
	
	if Priority[SelectedRoid] == Numroids*4 and GetAsteroid(SelectedRoid):IsVisible(Empire) == true then
		
		Priority[SelectedRoid] = Numroids*10
		
	end
	
	if Priority[SelectedRoid] == Numroids*6 and GetAsteroid(SelectedRoid):GetNumTrees() > 0 then
		
		Priority[SelectedRoid] = Numroids*10
		
	end
	
	if GetAsteroid(SelectedRoid).Owner == Empire and Priority[SelectedRoid] == Numroids*8 then
		
		Priority[SelectedRoid] = Numroids*10
		
	end
	
	if Priority[SelectedRoid] == Numroids*2 and GetAsteroid(SelectedRoid):GetNumSeedlings(Empire) >= 10 and GetAsteroid(SelectedRoid).Owner == Empire then
			
			GetAsteroid(SelectedRoid):PlantDysonTree(Empire)
			
	end
	
	if Priority[SelectedRoid] == Numroids*6 and GetAsteroid(SelectedRoid):GetNumSeedlings(Empire) >= 10 then
			
			Lowerstats = 0
			if GetAsteroid(SelectedRoid).attribs.energy < HighestEnergy/2 then
			
				Lowerstats = Lowerstats+1
			
			end
			
			if GetAsteroid(SelectedRoid).attribs.strength < HighestStr/2 then
			
				Lowerstats = Lowerstats+1
			
			end
			
			if GetAsteroid(SelectedRoid).attribs.speed < HighestSpeed/2 then
			
				Lowerstats = Lowerstats+1
			
			end
			
			if Lowerstats >= 2 then
				
				GetAsteroid(SelectedRoid):PlantDefenseTree(Empire)
				
			else
				
				GetAsteroid(SelectedRoid):PlantDysonTree(Empire)
				
			end
			
	end
	
	Yes_Priority = false
	No_Priority = false
	
	--Scanning for every empire, so everyone can see the status for the roid...
	for i = 0,Numroids do
		if i ~= SelectedRoid then
			
			--Figuring the distance between the two roids...
			Xdif = GetAsteroid(SelectedRoid).position.X - GetAsteroid(i).position.X
			Ydif = GetAsteroid(SelectedRoid).position.Y - GetAsteroid(i).position.Y
			Dist = math.abs(math.sqrt((Xdif*Xdif)+(Ydif*Ydif)))
			
			if Dist <= GetAsteroid(SelectedRoid).SendDistance+GetAsteroid(i).Radius then
				--Ok, we have a neighbour, add it to the list so we can check it for several stuff later!
				Numneighbours = Numneighbours+1
				Neighbour[Numneighbours] = GetAsteroid(i)
			end
			
		end
	end
	
	for i = 1,Numneighbours do
		
		
		if Priority[SelectedRoid] > Priority[Neighbour[i].ID] and GetAsteroid(SelectedRoid).Owner == Empire then
			
			Priority[SelectedRoid] = Priority[Neighbour[i].ID]+1
			if Priority[Neighbour[i].ID] == Numroids*8 and GetAsteroid(SelectedRoid):GetNumSeedlings(Empire)/1.5 > Neighbour[i]:GetNumSeedlings(Neighbour[i].Owner) then
				GetAsteroid(SelectedRoid):SendSeedlingsToTarget(Empire, GetAsteroid(SelectedRoid):GetNumSeedlings(Empire), GetAsteroid(Neighbour[i].ID))
			elseif Priority[Neighbour[i].ID] ~= Numroids*8 then
				GetAsteroid(SelectedRoid):SendSeedlingsToTarget(Empire, GetAsteroid(SelectedRoid):GetNumSeedlings(Empire), GetAsteroid(Neighbour[i].ID))
			end
			Yes_Priority = true
			
		elseif Priority[SelectedRoid]~=0 and Priority[SelectedRoid]~=Numroids*2 and Priority[SelectedRoid]~=Numroids*4 and Priority[SelectedRoid]~=Numroids*6 and Priority[SelectedRoid]~=Numroids*8 and Priority[SelectedRoid]~=Numroids*10 then
			
			No_Priority = true
			
		end
	end
	
	if Yes_Priority == true and No_Priority == true then
				
		No_Priority = false
				
	end
			
	if No_Priority == true and GetAsteroid(SelectedRoid).Owner == Empire then
			
		Priority[SelectedRoid] = Numroids*10
			
	end
	
	ROwner[SelectedRoid] = GetAsteroid(SelectedRoid).Owner
	
	--GetAsteroid(SelectedRoid).Name = Priority[SelectedRoid]
	
end

function AIinit()
	-- *** INFECTED AI V2.3 : INIT ***
	-- *** AUTHOR: ANNIKK.EXE ***
	-- *** EMAIL: annikk [dot] exe [at] gmail [dot] com ***
	
	Globals.AI.GraceTimer=(99999)
	
	-- Number of times the engine is run per While loop:
	numberofiterations = 0
	-- Set to 0 for very large maps. (50 asteroids+)
	-- Set to 2-4 for small maps for quicker AI response.
	
	metric = {}
	currentowner = {}
	
	for i = 0,300 do
		metric[i] = 500
	end
	

	-- *** END INFECTED AI : INIT ***
end


function InfectedAIEngine()
	-- *** INFECTED AI V2.3 : ENGINE ***
	-- Author: ANNIKK.EXE [at] GMAIL [dot] COM
	numberofasteroids = -1
	neighbours = {}

	for i = 0, 300 do
		if GetAsteroid(i) ~= nil then
			if GetAsteroid(i).radius > 10 then
				numberofasteroids = numberofasteroids + 1
			end
		end
	end

	-- now the variable called "numberofasteroids" accurately represents the number of playable asteroids on the field.

	for iterations = 0,numberofiterations do
	
		-- Select an asteroid for checking.
		checkedroid = GetAsteroid(math.random(0,numberofasteroids))
		
		if checkedroid.owner == Empire then
			break
		elseif checkedroid.owner == 4 then
			break
		end
		
		for i = 0,numberofasteroids do
			if GetAsteroid(i).owner == 4 then
				GetAsteroid(i):SetGraceTime(0)
			else
				GetAsteroid(i):SetGraceTime(99999)
			end
		end
		
		-- Record the current asteroid owner
		changedowner = false
		
		if currentowner[checkedroid.id] ~= nil then
			if currentowner[checkedroid.id] ~= checkedroid.owner then
				currentowner[checkedroid.id] = checkedroid.owner
				changedowner = true
			end
		else
			currentowner[checkedroid.id] = checkedroid.owner
		end
	
		tree = nil
		flower = nil
	
		-- flower check !
		tree = checkedroid:GetRandomDysonTree()
		
		if tree ~= nil then
			flower = tree:GetSuperSeedling()
		end
		
		if checkedroid.owner > 1 and flower ~= nil then
			flower:Pluck()
		end
		
		flower = checkedroid:GetFlower(checkedroid.owner)
		
		if checkedroid.owner > 1 and flower ~= nil then
			flower:PlantOnRandomDysonTree()
		end

		-- calculate which asteroids are a neighbour to checkedroid
		numberofneighbours = -1

		for i = 0,numberofasteroids do
			
			length = GetAsteroid(i).position.x - checkedroid.position.x
			height = GetAsteroid(i).position.y - checkedroid.position.y
			
			distancetoroid = math.sqrt((length * length) + (height * height))
			distancetoroid = distancetoroid - GetAsteroid(i).Radius
			
			if distancetoroid < checkedroid.SendDistance then
				-- this asteroid is in range.  Add it to the neighbours list, and increment the neighbour count by one.  ALSO ADDS SELF AS NEIGHBOUR!  But we trap for this in the Metric Update section.
				numberofneighbours = numberofneighbours + 1
				neighbours[numberofneighbours] = GetAsteroid(i)
			end
		end

		-- Metric update
		-- did we update from our own status?
		updated = false

		-- are we under attack?  if so set metric 0
		if checkedroid.owner ~= 1 and checkedroid.owner ~= 0 then
			
			if (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner)) > (checkedroid:GetNumTrees() * 5) or checkedroid:GetNumMines(1) > 0 then
				
				-- ok well we own this asteroid, and there are more enemy seeds here than our seeds (or there's a player mine here).  Now, we DO have at least 1 tree worth defending here, right?
				if checkedroid:GetNumTrees() > 0 then
					-- ok, we're under attack!  METRIC 0!
					metric[checkedroid.ID] = 0
					updated = true
				
				end
			end
		end
		
		-- are we maxed on trees?  if not, set metric 100
		-- (make sure we don't run this if we are under attack!)
		if updated == false then

			if checkedroid:GetNumTrees() < checkedroid.TreeCap then
				-- we don't have max trees here yet.  Metric 100!
				metric[checkedroid.ID] = 100
				updated = true
			end
			
		end
		-- Not under attack, maxed on trees, and ready to contribute to the empire.
		-- Check the status of our neighbours first before trying to become a gather point.
		-- only run this part of the code if we didn't get our metric from our own status
		if updated == false then
			-- are we a suitable gather point?
			
			enemydetected = false
			frienddetected = false
			gatherpointdetected = false
			lowermetricsnearby = false
		
			for i = 0, numberofneighbours do
			
				-- check that we're not examining ourself.
				if neighbours[i] ~= checkedroid then
		
					if neighbours[i].owner == checkedroid.owner then
						-- this asteroid is friendly to us
						frienddetected = true
					end
				
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i].owner ~= 0 and neighbours[i]:GetNumTrees() > 0 then
						-- this asteroid doesn't belong to us or player 0, and has at least 1 tree.  It must be an enemy roid.
						enemydetected = true
					end
					
					numberofenemies = neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)
				
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumTrees() == 0 and numberofenemies > 0 then
						-- this asteroid doesn't belong to us, has no trees on it, but has enemy seedlings on it.  Treat it as enemy.
						enemydetected = true
					end
					
					if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].ID] == 200 then
						-- this asteroid is friendly to us, and is a gather point.
						gatherpointdetected = true
					end
				
					if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] < 200 then
						-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
						lowermetricsnearby = true
					end
					if neighbours[i].owner == 0 and metric[neighbours[i].id] < 200 then
						-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
						lowermetricsnearby = true
					end	
				end
			
			end
			
			if enemydetected == true and frienddetected == true and gatherpointdetected == false and lowermetricsnearby == false then
				-- the conditions are right for me to become a gather point.
				metric[checkedroid.id] = 200
			elseif changedowner == true then
				-- the asteroid just became mine.  insta-gather point please!
				metric[checkedroid.id] = 200
			end

			-- Find the lowest metric among my neighbours
			lowestmetric = metric[checkedroid.ID]
			
			for i = 0, numberofneighbours do
				
				-- check that we're not examining ourself.
				if neighbours[i].id ~= checkedroid.id then
			
					if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
						-- this asteroid belongs to our empire, or it doesn't belong to anyone (and we should therefore follow its metrics)
						
						-- is this neighbour's metric less than mine?  (also, have we just taken this asteroid..?)
						if metric[neighbours[i].ID] < lowestmetric and changedowner == false then
							-- yes it's lower.
							lowestmetric = metric[neighbours[i].ID]
						end
					
					end
				
				end
			end
		
			-- now we've established what the lowest metric is.  If it's lower than ours, set ours to that +1.  If the lowest metric of a neighbour is the same as our metric, increase ours by 1.
			-- UNLESS we are a gather point
			if metric[checkedroid.ID] > lowestmetric and metric[checkedroid.ID] ~= 200 and metric[checkedroid.ID] ~= 100 then
				metric[checkedroid.ID] = lowestmetric + 5
			end
			
			if metric[checkedroid.ID] == lowestmetric and metric[checkedroid.ID] ~= 200 and metric[checkedroid.ID] ~= 100 then
				-- if my metric is the same as the lowest metric of my neighbours, i must be 1 step further away than they are.
				metric[checkedroid.ID] = metric[checkedroid.ID] + 5
			end
			
			-- check for errors, reset metric if necessary
			
			if metric[checkedroid.id] > 500 then
				metric[checkedroid.id] = 200
			end
			
			if metric[checkedroid.ID] > 0 and metric[checkedroid.ID] < 99 then
				stillinneed = false
				
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner and metric[i] == 0 then
						stillinneed = true
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 0 and metric[i] < 99 then
							metric[i] = 500
						end
					end
				end
			
			end
			
			if metric[checkedroid.ID] > 100 and metric[checkedroid.ID] < 199 then
				stillinneed = false
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner or GetAsteroid(i).owner == 0 then
						if metric[i] == 100 then
							stillinneed = true
						end
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 100 and metric[i] < 199 then
							metric[i] = 500
						end
					end
				end
			end
			
			if metric[checkedroid.ID] > 200 and metric[checkedroid.ID] < 299 then
				stillinneed = false
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner and metric[i] == 200 then
						stillinneed = true
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 200 and metric[i] < 299 then
							metric[i] = 500
						end
					end
				end
			end
			
		end

		-- Now to check that if we have metric 0, 100 or 200, we still require that status.
		
		if metric[checkedroid.id] == 0 then
			-- ok.  Am I REALLY still under attack?
			if checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner) > 1 or checkedroid:GetNumMines(1) > 0 then
				-- the enemy outnumber us, or there's a player mine here.  Yes, we're really under attack...
			else
				-- we're not really under attack anymore.  lets reset the metric.
				for i = 0, numberofasteroids do
					if GetAsteroid(i).owner == checkedroid.owner then
						metric[i] = 500
					end
				
				end
				metric[checkedroid.id] = 200
			end
		end
		
		if metric[checkedroid.id] == 100 then
			-- ok.  Am I REALLY still under construction?
			if checkedroid:GetNumTrees() < checkedroid.TreeCap then
				-- we do indeed have less trees than the treecap, so we still need seeds.
			else
				-- we're not really under construction anymore.  lets reset the metric.
				metric[checkedroid.id] = 200
			end
		end

		enemydetected = false
		frienddetected = false
		gatherpointdetected = false	
		lowermetricsnearby = false

		-- ok.  Am I REALLY still a suitable gather point?
		for i = 0, numberofneighbours do
			-- check that we're not examining ourself.
			if metric[checkedroid.ID] == 200 and neighbours[i].ID ~= checkedroid.id and changedowner == false then
				if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
					-- this asteroid is friendly or neutral to us
					frienddetected = true
				end
			
				if neighbours[i].owner ~= checkedroid.owner and neighbours[i].owner ~= 0 and neighbours[i]:GetNumTrees() > 0 then
					-- this asteroid doesn't belong to us or player 0, and has at least 1 tree.  It must be an enemy roid.
					enemydetected = true
				end
				
				numberofenemies = neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)
				
				if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumTrees() == 0 and numberofenemies > 9 then
					-- this asteroid doesn't belong to us, has no trees on it, but has enemy seedlings on it.  Treat it as enemy.
					enemydetected = true
				end
				
				if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].ID] == 200 then
					-- this asteroid is friendly to us, and is a gather point.
					gatherpointdetected = true
				end
				
				if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] < 200 then
					-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
					lowermetricsnearby = true
				end			
				if neighbours[i].owner == 0 and metric[neighbours[i].id] < 200 then
					-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
					lowermetricsnearby = true
				end	
			end
		
		end
		
		if metric[checkedroid.id] == 200 and changedowner == false then
			
			if enemydetected == true and gatherpointdetected == false and lowermetricsnearby == false then
				-- the conditions are right for me to continue as a gather point.

			else
				-- the conditions are no longer right.  Best to reset the metric.
				metric[checkedroid.id] = 500
			end
			
		end
	
		if frienddetected == false and enemydetected == true and checkedroid:GetNumTrees() == checkedroid.TreeCap then
			-- we're an orphan with max trees!  lets become a gather point.
			metric[checkedroid.id] = 200
		end
	
		-- Actions
		
		-- There are 3 different action types.  We must make sure not to use any actions for players 0 and 1!
		-- 1.  Plant trees
		
		-- trap for player 0, exclude player 1
		if checkedroid.owner == 0 or checkedroid.owner > 1 then
			-- so plant one :>
			for i = 2,10 do		
				
				if metric[checkedroid.id] == 100 and (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(i)) < 5 and checkedroid:GetNumSeedlings(i) > 9 then
					-- this asteroid isn't owned by greys or player, the enemy only has a bit of seedlings here
					-- its metric is 100
					-- and it has enough seedlings belonging to the asteroid's empire to plant a tree
					a = checkedroid:PlantDysonTree(i)
				end
			end
		end

		-- 2.  Send seedlings to the next lowest metric
		
		if metric[checkedroid.id] ~= 0 and metric[checkedroid.id] ~= 100 and metric[checkedroid.id] ~= 500 and checkedroid.owner > 1 then
		
			-- we're not under attack or construction.
			numberofdestinations = 0
			
			for i = 0,numberofneighbours do
				if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
					-- this neighbour is one of our asteroids, or it's a blank asteroid

					if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
						if metric[neighbours[i].ID] < metric[checkedroid.ID] then
							-- we've found a friendly neighbour with a metric lower than ours!
							-- add it to the destinations list
							numberofdestinations = numberofdestinations + 1
						end
					end

				end
			end
			
			if numberofdestinations > 0 then
			
				-- we've found some destinations to send seeds to.  Lets send some.
				numberofseedsleft = checkedroid:GetNumSeedlings(checkedroid.owner) - (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner))
				numberperdestination = numberofseedsleft / numberofdestinations
				
				for i = 0,numberofneighbours do
					if neighbours[i] ~= checkedroid then
						if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
							if metric[neighbours[i].ID] < metric[checkedroid.ID] then
								-- this destination has less than our metric.  This is one of the valid destinations.  Send a proportional amount of seeds to it.
								if neighbours[i].owner == 0 and numberofseedsleft < 10 then
									-- don't bother sending.
								
								elseif neighbours[i].owner == 0 and neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner) > 0 and numberofseedsleft > 9 + (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) then
									-- attack the greys!  (or whoever is camping the roid!)
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, checkedroid:GetNumSeedlings(checkedroid.owner), neighbours[i])
									numberofseedsleft = 0
								
								elseif neighbours[i].owner == 0 and numberofseedsleft > 9 and (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) == 0 then
									-- this is the last we can manage.  Send all 10.
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, 10, neighbours[i])
									numberofseedsleft = numberofseedsleft - 10
								
								elseif neighbours[i].owner == checkedroid.owner then
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, numberperdestination, neighbours[i])
									numberofseedsleft = numberofseedsleft - numberperdestination
								end
							end
						end
					end
				end
			end

			-- 3.  Attack the weakest nearby asteroid
			
			-- Are we a gather point?  Only gather points are allowed to attack.
			
			if metric[checkedroid.id] == 200 then

				totalenemies = 0
				totalfriendlies = checkedroid:GetNumSeedlings(checkedroid.owner)
				weakestamount = 10000
				weakestroid = checkedroid
				attack = false
				orphan = true
				numberofenemyroids = 0
				
				for i = 0,numberofneighbours do
					
					if neighbours[i].owner == checkedroid.owner and neighbours[i] ~= checkedroid then
						orphan = false
					end
					
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner) > 5 then
						-- found an attack path
						numberofenemyroids = numberofenemyroids + 1
					end
					
					for j = 0,10 do
						if checkedroid.owner ~= j then
							totalenemies = totalenemies + neighbours[i]:GetNumSeedlings(j)
							
							if weakestamount > neighbours[i]:GetNumSeedlings(j) and neighbours[i].owner == j then
								-- the owner of this asteroid has a smaller number of seeds than we've seen before...
								weakestamount = neighbours[i]:GetNumSeedlings(j)
								weakestroid = neighbours[i]
							end
						
						end
					end
					
					if neighbours[i] ~= checkedroid and neighbours[i].owner ~= checkedroid.owner then
						if neighbours[i]:GetNumSeedlings(checkedroid.owner) > (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) then
							-- already attacking, and winning.  send reinforcements.
							checkedroid:SendSeedlingsToTarget(checkedroid.owner, checkedroid:GetNumSeedlings(checkedroid.owner), neighbours[i])
						end
					end
				end
				
				-- in the first case, we have more seedlings than all the neighbouring asteroids put together.
				if totalfriendlies > totalenemies + (weakestroid:GetNumTrees() * 10) then
					attack = true
				end
				
				split = false
				
				-- in the second case, we have more than 150 seedlings on this roid, and it's time to move out!
				if totalfriendlies > 150 then
					attack = true
					split = true
				end
				
				if totalfriendlies >= Globals.Asteroids.SpawnCap and orphan == true then
					attack = true
				end
				
				if attack == true and checkedroid.owner > 1 and split == false then
					-- ok so we're a gather point, we're ready to attack, and we aren't a player or greys asteroid.
					-- lets move out.
					checkedroid:SendSeedlingsToTarget(checkedroid.owner, totalfriendlies, weakestroid)
				elseif attack == true and checkedroid.owner > 1 and split == true then
				
					for i = 0,numberofneighbours do
						if neighbours[i].owner ~= checkedroid.owner then
							-- attackable path - send proportional amount of seeds.
							checkedroid:SendSeedlingsToTarget(checkedroid.owner, totalfriendlies / numberofenemyroids, neighbours[i])
						end
					end
				end
			end
		end
		-- Set asteroid names to whatever their metric is.  Uncomment the
		-- line below for testing purposes if the AI shows unexpected behaviours.
		-- checkedroid.Name = metric[checkedroid.ID]
	end
	-- *** END INFECTED AI : ENGINE ***
end