--[[
	
	Tough Collisions v5
	
	New content: Save/Load
	
--]]

function LevelSetup()
	
	Globals.G.Asteroids=0
	Globals.G.EnemyFactionsMin=0
	Globals.G.EnemyFactionsMax=0
	SetBackdropColour(0,0,0)
	AddAsteroid(0,0)
	Globals.Flowers.Available = 0
	Gameinit = false
	BasicSaveFolder = "C:\\EufloriaSaves\\"
	
end

function ScreenDraw()
	
	if Gameinit == true then
		DrawText(0,20,"Mass  " .. Mass[1],1,0,0,1,15,10)
		if math.abs(((Vx[1] + Vy[1])/2)) > 0.0001 then
			DrawText(0,40,"Speed  " .. math.abs(((Vx[1] + Vy[1])/2)),1,0,0,1,15,10)
		else
			DrawText(0,40,"Speed  0",1,0,0,1,15,10)
		end
		if SaveFile ~= nil then
			DrawText(0,60,"Savefile:  " .. SaveFile,1,0,0,1,15,10)
		end
		if ShowCoords then
			DrawText(0,80,"(" .. Px[1] .. "," .. Py[1] .. ")",1,0,0,1,15,10)
		end
	end
end

function LevelDraw()
	
	if Gameinit ~= true then
		
		Tracking = true
		GameTime = 0
		SaveFile = nil
		
		NumDrawings = 40			--the max amount of units on the game at once, so this is the limit...
		NumParticles = -1			--This number is changing frequently
		GameInitRange = 50			--the max amount of  distance between the player and where the units might spawn, this also affects if the game is to remove the units...
		NormalBrakeFactor = 0.95
		SizeRatio = 0.1				--The most required varibale, it tells how much of the size of the dot it ate it will increase in size itself(Mass[1/player dot] = Mass[1] + Mass[atenDot]*SizeRatio
		MinSizeFactor = 80			--Take this / 10 and you get the size
		MaxSizeFactor = 120			--This one too
		ParticleDelay = 0.05
		NormalFade = 0.015
		PLimit = 0.25
		SpeedDrain = 0.001
		ZoomPercent = 0.015			--Percent of the size!
		GPercent = 0.001
		G = 1
		
		--Arrays/table variables
		
		Px = {}
		Py = {}
		Vx = {}
		Vy = {}
		Ax = {}
		Ay = {}
		Mass = {}
		Drawn = {}
		SpawnP = {}
		DrawAlpha = {}
		
		-- AI stuff
		
		IsAlive = {}
		AIBrakeFactor = 0.99
		AIChance = 1
		
		--for particles:
		
		PX = {}
		PY = {}
		PFade = {}
		PR = {}
		PG = {}
		PB = {}
		PS = {}
		
		--Calculations and stuff
		
		--Set every property for the player...
		
		Px[1] = 0
		Py[1] = 0
		Mass[1] = 2
		Vx[1] = 0
		Vy[1] = 0
		Ax[1] = 0
		Ay[1] = 0
		Drawn[1] = true
		SpawnP[1] = GetGameTime() + ParticleDelay
		Hold = false
		
		--And to prevent an infinite loop, do this:
		
		Gameinit = true
		
	else
		if Testing == true then
			MinSizeFactor = 30
			MaxSizeFactor = 50
		elseif MinSizeFactor ~= 80 and MaxSizeFactor ~= 120 and Testing ~= true then
			MinSizeFactor = 80
			MaxSizeFactor = 120
		end
		if GetGameTime() > GameTime then
			
			G = Mass[1] * GPercent
			
			GameRange = GameInitRange * Mass[1]
			GameTime = GetGameTime()
			CheckDrawn()
			
			if Hold == true then
				
				DistX = Px[1] - GetMouseX()
				DistY = Py[1] - GetMouseY()
				
				Vx[1] = Vx[1] + DistX*SpeedDrain
				Vy[1] = Vy[1] + DistY*SpeedDrain
				
				DrawLine(Px[1],Py[1],Px[1] + ((Px[1] - GetMouseX())*0.1),Py[1] + ((Py[1] - GetMouseY())*0.1),1,1,1,1,1,1,1,1,GetCameraZoom())
				
			end
			
			if Mass[1] > 1250 then
				
				SetCameraZoom((Mass[1] / 125000)+32)
				
			end
			
			Vx[1] = Vx[1] * NormalBrakeFactor
			Vy[1] = Vy[1] * NormalBrakeFactor
			
			TooFast = {}
			TooLarge = {}
			
			if Mass[1] <= 0 then
				
				Gameinit = false
				SetCameraZoom(1)
				
			end
			
			for i = 1,NumDrawings do
				if IsAlive[i] == true then
					Vx[i] = Vx[i] * AIBrakeFactor
					Vy[i] = Vy[i] * AIBrakeFactor
				end
				for j = 1,NumDrawings do
					if i ~= j then
						
						xdiff = Px[i] - Px[j]
						ydiff = Py[i] - Py[j]
						
						Fx = G*((Mass[i]*Mass[j])/DistanceSquared(Px[i],Py[i],Px[j],Py[j]))
						Fy = G*((Mass[i]*Mass[j])/DistanceSquared(Px[i],Py[i],Px[j],Py[j]))
						
						NV = math.sqrt((xdiff^2)+(ydiff^2))
						
						if i == 1 then
							
							DrawAlpha[j] = (GameRange - NV) / (10*string.len(GameRange^2))
							
						end
						
						if IsAlive[i] == true then
							RunAI(i,j,NV)
						end
						
						DiffX = Px[j] - Px[i]
						DiffY = Py[j] - Py[i]
						NVx = DiffX / NV
						NVy = DiffY / NV
						Ax[i] = Ax[i] + (NVx * Fx / Mass[i])
						Ay[i] = Ay[i] + (NVy * Fy / Mass[i])
						
						DiffX = Px[i] - Px[j]
						DiffY = Py[i] - Py[j]
						NVx = DiffX / NV
						NVy = DiffY / NV
						Ax[j] = Ax[j] + (NVx * Fx / Mass[j])
						Ay[j] = Ay[j] + (NVy * Fy / Mass[j])
						
						if NV < Mass[j]+Mass[i] then
							
							if Mass[j] > Mass[i] then
								
								Mass[j] = Mass[j] + (Mass[i]*SizeRatio)
								Vx[j] = Vx[j] * NormalBrakeFactor
								Vy[j] = Vy[j] * NormalBrakeFactor
								Drawn[i] = false
								if i == 1 then
									
									Gameinit = false
									SetCameraZoom(1)
									
								end
								
							elseif Mass[i] > Mass[j] then
								
								Mass[i] = Mass[i] + (Mass[j]*SizeRatio)
								Vx[i] = Vx[i] * NormalBrakeFactor
								Vy[i] = Vy[i] * NormalBrakeFactor
								Drawn[j] = false
								if j == 1 then
									
									Gameinit = false
									SetCameraZoom(1)
									
								end
								
							end
							
						end
						
					end
					
				end
				
				Vx[i] = Vx[i] + Ax[i]
				Vy[i] = Vy[i] + Ay[i]
				
				Px[i] = Px[i] + Vx[i]
				Py[i] = Py[i] + Vy[i]
				
				Ax[i] = 0
				Ay[i] = 0
				if Px[i] < Px[1] - GameRange then
					if IsAlive[i] ~= true then
						Drawn[i] = false
					else
						Vx[i] = Vx[i] + 1
					end
				elseif Px[i] > Px[1] + GameRange then
					if IsAlive[i] ~= true then
						Drawn[i] = false
					else
						Vx[i] = Vx[i] - 1
					end
				end
				if Py[i] < Py[1] - GameRange then
					if IsAlive[i] ~= true then
						Drawn[i] = false
					else
						Vy[i] = Vy[i] + 1
					end
				elseif Py[i] > Py[1] + GameRange then
					if IsAlive[i] ~= true then
						Drawn[i] = false
					else
						Vy[i] = Vy[i] - 1
					end
				end
				
				if SpawnP[i] < GameTime and math.abs(((Vx[i] + Vy[i])/2)) > Mass[i]*PLimit then
					
					local special = false
					
					SpawnP[i] = GameTime + ParticleDelay
					
					if math.abs(((Vx[i] + Vy[i])/2)) > Mass[i]*PLimit*3 then
						
						special = true
						Mass[i] = Mass[i] - (math.abs(((Vx[i] + Vy[i])/2))/Mass[i]*PLimit*3)/1000
						
						TooFast[i] = true
						TooLarge[i] = math.abs(((Vx[i] + Vy[i])/2))/Mass[i]*PLimit*3
						
					end
					
					AddParticle(Px[i],Py[i],Mass[i],special)
					AddParticle(Px[i],Py[i],Mass[i],special)
					
				end
				
				if Tracking == true then
				
					SetCameraTarget(Px[1],Py[1])
					
				end
		
			end
			
			for i = 0,NumParticles do
				
				if PFade[i] > 0.05 then
				
					PFade[i] = PFade[i] - NormalFade
					
					if IsOnScreen(PX[i],PY[i],PS[i]) then
						DrawSprite(1,PX[i],PY[i],PR[i],PG[i],PB[i],PFade[i],PS[i])
					end
					
				--else
					
					--CheckParticles(i)
					
				end
				
			end
			
		end
		for i = 1,NumDrawings do
			if Drawn[i] == true then
				if IsOnScreen(Px[i],Py[i],Mass[i]) then
					if TooFast[i] then
						if i ~= 1 then
							if Mass[i] > Mass[1] then
								if IsAlive[i] == true then
									DrawSprite(5,Px[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),Py[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),0.7,0.2,0.45,DrawAlpha[i],Mass[i]/2)
								else
									DrawSprite(5,Px[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),Py[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),0.7,0.2,0.2,DrawAlpha[i],Mass[i]/2)
								end
							elseif Mass[i] < Mass[1] then
								if IsAlive[i] == true then
									DrawSprite(5,Px[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),Py[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),0.45,0.2,0.7,DrawAlpha[i],Mass[i]/2)
								else
									DrawSprite(5,Px[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),Py[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),0.2,0.2,0.7,DrawAlpha[i],Mass[i]/2)
								end
							else
								if IsAlive[i] == true then
									DrawSprite(5,Px[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),Py[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),0.7,0,0.7,DrawAlpha[i],Mass[i]/2)
								else
									DrawSprite(5,Px[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),Py[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),1,1,1,DrawAlpha[i],Mass[i]/2)
								end
							end
						else
							DrawSprite(5,Px[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),Py[i]+math.random(-TooLarge[i]*2,TooLarge[i]*2),1,1,1,1,Mass[i]/2)
						end
					else
						if i ~= 1 then
							if Mass[i] > Mass[1] then
								if IsAlive[i] == true then
									DrawSprite(5,Px[i],Py[i],0.7,0.2,0.45,DrawAlpha[i],Mass[i])
								else
									DrawSprite(5,Px[i],Py[i],0.7,0.2,0.2,DrawAlpha[i],Mass[i])
								end
							elseif Mass[i] < Mass[1] then
								if IsAlive[i] == true then
									DrawSprite(5,Px[i],Py[i],0.45,0.2,0.7,DrawAlpha[i],Mass[i])
								else
									DrawSprite(5,Px[i],Py[i],0.2,0.2,0.7,DrawAlpha[i],Mass[i])
								end
							else
								if IsAlive[i] == true then
									DrawSprite(5,Px[i],Py[i],0.7,0,0.7,DrawAlpha[i],Mass[i])
								else
									DrawSprite(5,Px[i],Py[i],1,1,1,DrawAlpha[i],Mass[i])
								end
							end
						else
							DrawSprite(5,Px[i],Py[i],1,1,1,1,Mass[i])
						end
					end
				end
			end
		end
	end
end

function CheckParticles(start)
	
	for p = 0,NumParticles do
		
		if p > start then
			
			PX[p] = PX[p-1]
			PY[p] = PY[p-1]
			PR[p] = PR[p-1]
			PG[p] = PG[p-1]
			PB[p] = PB[p-1]
			PS[p] = PS[p-1]
			PFade[p] = PFade[p-1]
			
		end
		
	end
	
	NumParticles = NumParticles - 1
	
end

function RunAI(id,id2,Dist)
	
	if Dist < GameInitRange * Mass[id] and Mass[id2] > Mass[id] then
		
		if Px[id] < Px[id2] then
			
			if Mass[id2] > Mass[id] then
				Vx[id] = Vx[id] - ((Mass[id]+Mass[id2])/Dist)
			elseif Mass[id2] < Mass[id] then
				Vx[id] = Vx[id] + ((Mass[id]+Mass[id2])/Dist)
			end
		elseif Px[id] > Px[id2] then
			if Mass[id2] > Mass[id] then
				Vx[id] = Vx[id] + ((Mass[id]+Mass[id2])/Dist)
			elseif Mass[id2] < Mass[id] then
				Vx[id] = Vx[id] - ((Mass[id]+Mass[id2])/Dist)
			end
		end
		if Py[id] < Py[id2] then
			
			if Mass[id2] > Mass[id] then
				Vy[id] = Vy[id] - ((Mass[id]+Mass[id2])/Dist)
			elseif Mass[id2] < Mass[id] then
				Vy[id] = Vy[id] + ((Mass[id]+Mass[id2])/Dist)
			end
		elseif Py[id] > Py[id2] then
			if Mass[id2] > Mass[id] then
				Vy[id] = Vy[id] + ((Mass[id]+Mass[id2])/Dist)
			elseif Mass[id2] < Mass[id] then
				Vy[id] = Vy[id] - ((Mass[id]+Mass[id2])/Dist)
			end
		end
	end
end

function CheckDrawn()
	
	for i = 1,NumDrawings do
		
		if Drawn[i] ~= true then
			
			Px[i] = Px[1] + math.random(-GameRange,GameRange)
			Py[i] = Py[1] + math.random(-GameRange,GameRange)
			CheckCoords(i)
			Mass[i] = Mass[1]*(math.random(MinSizeFactor,MaxSizeFactor)/100)
			Vx[i] = (math.random(-100,100)/1000)*Mass[i]
			Vy[i] = (math.random(-100,100)/1000)*Mass[i]
			Ax[i] = 0
			Ay[i] = 0
			Drawn[i] = true
			SpawnP[i] = GetGameTime() + ParticleDelay
			IsAlive[i] = false
			
			if math.random()*100 < AIChance and i ~= 1 then
				
				IsAlive[i] = true
				
			end
		end
			
	end
	
end

function AddParticle(x,y,s,waytoofast)
	
	NumParticles = NumParticles + 1
	
	if s > Mass[1] then
		PR[NumParticles] = 0.7
		PG[NumParticles] = 0.2
		PB[NumParticles] = 0.2
	elseif s < Mass[1] then
		PR[NumParticles] = 0.2
		PG[NumParticles] = 0.2
		PB[NumParticles] = 0.7
	else
		PR[NumParticles] = 1
		PG[NumParticles] = 1
		PB[NumParticles] = 1
	end
	
	if waytoofast then
		
		PR[NumParticles] = math.random()
		PG[NumParticles] = math.random()
		PB[NumParticles] = math.random()
		
	end
	
	PS[NumParticles] = s*0.2
	PX[NumParticles] = x + math.random(-s,s)
	PY[NumParticles] = y + math.random(-s,s)
	PFade[NumParticles] = 0.7
	
end

function CheckCoords(n)
	
	SeparationDist = GameRange*0.1
	
	BadOutcome = false
	
	if Px[n] < Px[1] + SeparationDist and Px[n] > Px[1] - SeparationDist then
		Px[n] = Px[1] + math.random(-GameRange,GameRange)
		BadOutcome = true
	end
	if Py[n] < Py[1] + SeparationDist and Py[n] > Py[1] - SeparationDist then
		Py[n] = Py[1] + math.random(-GameRange,GameRange)
		BadOutcome = true
	end
	
	if BadOutcome == true then
		
		CheckCoords(n)
		
	end
	
end

function Save(savename)
	
	if not io.open(BasicSaveFolder .. "acces.acces") then
		os.execute("mkdir " .. BasicSaveFolder)
		io.output(io.open(BasicSaveFolder .. "acces.acces", "w"))
		io.write("Don't delete this file unless you want to remove the Eufloria Saves. Thank you!")
		io.close()
	end
	io.output(io.open(BasicSaveFolder .. savename .. ".TCS", "w"))
	local txt = "truesave\n"
	for i = 1,NumDrawings do
		
		txt = txt .. Px[i] .. "\n"
		txt = txt .. Py[i] .. "\n"
		txt = txt .. Vx[i] .. "\n"
		txt = txt .. Vy[i] .. "\n"
		txt = txt .. Ax[i] .. "\n"
		txt = txt .. Ay[i] .. "\n"
		txt = txt .. Mass[i] .. "\n"
		if Drawn[i] == true then
			txt = txt .. "1" .. "\n"
		else
			txt = txt .. "0" .. "\n"
		end
		if IsAlive[i] == true then
			txt = txt .. "1" .. "\n"
		else
			txt = txt .. "0" .. "\n"
		end
		if i < NumDrawings then
			txt = txt .. SpawnP[i] .. "\n"
		else
			txt = txt .. SpawnP[i]
		end
		
	end
	io.write(txt)
	io.close()
	SaveFile = savename
end

function Load(initsavename)
	
	if initsavename == "lastused" then
		local file = assert(io.open(BasicSaveFolder .."lastusedload.lud", "r"))
		
		for line in file:lines() do
			
			savename = line
			
		end
	else 
		savename = initsavename
	end
	
	io.output(io.open(BasicSaveFolder .."lastusedload.lud", "w"))
	io.write(savename)
	io.close()
	
	local file = assert(io.open(BasicSaveFolder .. savename .. ".TCS", "r"))
	
	local attribchange = 1
	local currentdot = 1
	local check = true
	
	for line in file:lines() do
		
		if check == true then
			if line == "truesave" then
				check = false
			else
				print("File format invalid, loading couldn't be done!")
			end
		else
			
			if attribchange == 1 then
				Px[currentdot] = tonumber(line)
				attribchange = attribchange + 1
			elseif attribchange == 2 then
				Py[currentdot] = tonumber(line)
				attribchange = attribchange + 1
			elseif attribchange == 3 then
				Vx[currentdot] = tonumber(line)
				attribchange = attribchange + 1
			elseif attribchange == 4 then
				Vy[currentdot] = tonumber(line)
				attribchange = attribchange + 1
			elseif attribchange == 5 then
				Ax[currentdot] = tonumber(line)
				attribchange = attribchange + 1
			elseif attribchange == 6 then
				Ay[currentdot] = tonumber(line)
				attribchange = attribchange + 1
			elseif attribchange == 7 then
				Mass[currentdot] = tonumber(line)
				attribchange = attribchange + 1
			elseif attribchange == 8 then
				if tonumber(line) == 1 then
					Drawn[currentdot] = true
				else
					Drawn[currentdot] = false
				end
				attribchange = attribchange + 1
			elseif attribchange == 9 then
				if tonumber(line) == 1 then
					IsAlive[currentdot] = true
				else
					IsAlive[currentdot] = false
				end
				attribchange = attribchange + 1
			elseif attribchange == 10 then
				SpawnP[currentdot] = tonumber(line)
				currentdot = currentdot + 1
				attribchange = 1
			end
		end
	end
	if check == false then
		SaveFile = savename
	end
end

function LevelLogic()
	
	GetAsteroid(0).Radius = 0
	GetAsteroid(0):Hide(1)
	GetAsteroid(0):SetVisible(1,false)
	
end

function OnMouseLeftDown(x,y)
	
	Hold = true
	
end

function OnMouseLeftUp(x,y)
	
	Hold = false
	
end

function OnMouseRightDown(x,y)
	
	if SaveFile ~= nil then
		Save(SaveFile)
	else
		Load("lastused")
	end
end

function GetMouseX()
	
	return(GetCameraX()+(((GetMouseScreenX()-(GetScreenWidth()/2)))*GetCameraZoom()))
	
end

function GetMouseY()
	
	return(GetCameraY()+(((GetMouseScreenY()-GetScreenHeight()/2))*GetCameraZoom()))
	
end

function DistanceSquared(x1,y1,x2,y2)
	
	local Xd = x1-x2
	local Yd = y1-y2
	return((Xd^2)+(Yd^2))
	
end

function DrawText(startx, starty, text, r, g, b, a,h, w)
	--And here is a long function, supporting drawing text!
	x = startx
	y = starty
	for i = 0, string.len(text) do
		letter = string.sub(text, i, i)
		if letter == 'A' or letter == 'a' then
			DrawLine(x, y,x+(w/2),y-h, r,g,b,a,r,g,b,a,h/w)
			DrawLine(x+w, y,x+(w/2),y-h, r,g,b,a,r,g,b,a,h/w)
			DrawLine(x+(w/4), y-(h/2),(x+w)-(w/4),y-(h/2), r,g,b,a,r,g,b,a,h/w)
		elseif letter == 'B' or letter == 'b' then
			DrawLine(x, y, x+w, y-(h/8), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+w, y-h+(h/8), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-(h/8), x+w, y-(h/2)+(h/8), r,g,b,a,r,g,b,a,h/w)
			DrawLine(x+w, y-h+(h/8), x+w, y-(h/2)-(h/8), r,g,b,a,r,g,b,a,h/w)
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+w, y-(h/2)+(h/8), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+w, y-(h/2)-(h/8), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'C' or letter == 'c' then
			DrawLine(x, y-(h/8), x, y-h+(h/8), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/8), x+w, y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h+(h/8), x+w, y-h, r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'D' or letter == 'd' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+w-(w/4), y-(h/8), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+w-(w/4), y-h+(h/8), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h+(h/4), x+w, y-(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w-(w/4), y-(h/8), x+w, y-(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w-(w/4), y-h+(h/8), x+w, y-h+(h/4), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'E' or letter == 'e' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+w, y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+(w/2), y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'F' or letter == 'f' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+(w/2), y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'G' or letter == 'g' then
			DrawLine(x+(w/2), y-h, x+w, y-(h/2)-(h/8), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+(w/2), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+(w/2), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y, x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y-(h/2), x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y-(h/2), x+(w/2), y-(h/2)+(h/6), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'H' or letter == 'h' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'I' or letter == 'i' then
			DrawLine(x+(w/2), y, x+(w/2), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2)-(w/8), y, x+(w/2)+(w/8), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2)-(w/8), y-h, x+(w/2)+(w/8), y-h, r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'J' or letter == 'j' then
			DrawLine(x+(w/1.5), y, x+(w/1.5), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/1.5)-(w/2), y, x+(w/1.5), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/1.5)-(w/2), y, x+(w/1.5)-(w/2), y-(h/8), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'K' or letter == 'k' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h, x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'L' or letter == 'l' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+w, y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x+w, y-(h/16), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'M' or letter == 'm' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h, x+(w/2), y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+(w/2), y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'N' or letter == 'n' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+w, y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'O' or letter == 'o' then
			DrawLine(x+(w/2), y-h, x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y-h, x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y, x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y, x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'P' or letter == 'p' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h, x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'Q' or letter == 'q' then
			DrawLine(x+(w/2), y-h, x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y-h, x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y, x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y, x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2)+(w/4), y-(h/4), x+w, y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'R' or letter == 'r' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h, x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+w, y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'S' or letter == 's' then
			DrawLine(x, y-(h/4), x+(w/2), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-(h/4), x+(w/2), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h+(h/4), x+(w/2), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h+(h/4), x+(w/2), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-(h/4), x, y-h+(h/4), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'T' or letter == 't' then
			DrawLine(x+(w/2), y, x+(w/2), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'U' or letter == 'u' then
			DrawLine(x, y-(h/4), x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-(h/4), x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/4), x+(w/2), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-(h/4), x+(w/2), y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'V' or letter == 'v' then
			DrawLine(x, y-h, x+(w/2), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h, x+(w/2), y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'W' or letter == 'w' then
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x+(w/2), y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+(w/2), y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'X' or letter == 'x' then
			DrawLine(x, y, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'Y' or letter == 'y' then
			DrawLine(x, y-h, x+(w/2), y-(h/1.5), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h, x+(w/2), y-(h/1.5), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y, x+(w/2), y-(h/1.5), r,g,b,a, r,g,b,a,h/w)
		elseif letter == 'Z' or letter == 'z' then
			DrawLine(x, y-h, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+w, y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
		elseif letter == '1' then
			DrawLine(x+(w/2), y, x+(w/2), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2)-(w/8), y, x+(w/2)+(w/8), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y-h, x+(w/2)-(w/4), y-h+(h/4), r,g,b,a, r,g,b,a,h/w)
		elseif letter == '2' then
			DrawLine(x, y-h+(h/4), x+(w/2), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h+(h/4), x+(w/2), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+w, y-h+(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+w, y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == '3' then
			DrawLine(x+(w/1.5), y, x+w, y-(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/1.5), y-(h/2), x+w, y-(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/1.5), y-(h/2), x+w, y-h+(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/1.5), y-h, x+w, y-h+(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+(w/1.5), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+(w/1.5), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/1.5), y-(h/2), x+(w/2.5), y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == '4' then
			DrawLine(x+w, y, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-(h/2), x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x, y-h, r,g,b,a, r,g,b,a,h/w)
		elseif letter == '5' then
			DrawLine(x, y-(h/2), x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-(h/2), x+(w/2), y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y-(h/2), x+w, y-(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-(h/4), x+(w/2), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+(w/2), y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == '6' then
			DrawLine(x+w, y-h, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x, y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x+w, y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x+w, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-(h/2), x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == '7' then
			DrawLine(x, y-h, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h, x, y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == '8' then
			DrawLine(x+w, y-h, x+w, y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y-h, x, y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-(h/2), x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x, y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == '9' then
			DrawLine(x+(w/2), y-h, x+w, y-h+(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y-h, x, y-h+(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y-(h/2), x+w, y-h+(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y-(h/2), x, y-h+(h/4), r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h+(h/4), x+w, y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == '0' then
			DrawLine(x+w, y, x, y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-h, x, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y, x+w, y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x, y, x, y-h, r,g,b,a, r,g,b,a,h/w)
		elseif letter == '+' then
			DrawLine(x+(w/2), y, x+(w/2), y-h, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+w, y-(h/2), x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == '-' then
			DrawLine(x+w, y-(h/2), x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == '' then
			DrawLine(x+w, y-h, x+(w/2), y, r,g,b,a, r,g,b,a,h/w)
			DrawLine(x+(w/2), y, x, y-(h/2), r,g,b,a, r,g,b,a,h/w)
		elseif letter == '/' then
			DrawLine(x+w, y-h, x, y, r,g,b,a, r,g,b,a,h/w)
		elseif letter == ":" then
			DrawSprite(1,x+(w/2),y,r,g,b,a,h/w)
			DrawSprite(1,x+(w/2),y-h,r,g,b,a,h/w)
		elseif letter == "." then
			DrawSprite(1,x,y,r,g,b,a,h/w)
		end
		x = x + w + 5
	end
end