--level start
function LevelSetup()

	Globals.G.Asteroids = 0
	Globals.G.EnemyFactionsMin=0
	Globals.G.EnemyFactionsMax=0
	Globals.G.GreysProbability=(math.random(0,70) / 100)
	Globals.G.GreysMin=math.random(5,15)
	Globals.G.GreysMax = Globals.G.GreysMin + math.random(10,50)
	Globals.Asteroids.SpawnCap=100
	Globals.G.StartingSeedlingsPlayer=0
	--Globals.Agents.MinAltitude=20
	--Globals.Agents.MaxAltitude=40
	Globals.Asteroids.MinCoreHealth = 90
	Globals.Asteroids.MaxCoreHealth = 1500
	Globals.Flowers.MinSpeed=80
	Globals.Flowers.MaxSpeed=320
	Globals.Missiles.DamageMin=20
	Globals.Missiles.DamageMax=35
	Globals.Structures.FlowerProbability=(math.random(1,50) / 100)
	
	
	-- set backdrop and vignette
	bw = math.random(0,1)

	SetBackdropColour(bw*210,bw*227,bw*224)
	
	SetVignetteAlpha(0)
	if bw == 1 then
		SetVignetteAlpha(255)
		bw = 255
	end
	
	-- go engines !
	AIinit()
	GenerateLevel()
	StarfieldInit()
	parallax = true


end


function ScreenDraw()
	if parallax == true then
		StarfieldEngine()
	end
end

function Twinkle()
	-- twinkle twinkle blackened star
	-- how i wonder what starsize you are ^_^
	twinklingspeed = 4
	-- generate a pulsing between 0 and 1
	pulse = (math.sin(GetGameTime() * twinklingspeed) + 1) / 2
	
	-- pulse the star only if pulse is greater than 0.6!
	if pulse > 0.6 then
		-- pulse the twinklestar
		SetStarSize[twinklestar] = defaultsize + (defaultsize * 12 * (pulse - 0.6))
		
		if nextcolour == nil then
			nextcolour = math.random(0,2)
		elseif nextcolour == 0 then
			red[twinklestar] = (pulse - 0.6) * 2.5
		elseif nextcolour == 1 then
			green[twinklestar] = (pulse - 0.6) * 2.5
		elseif nextcolour == 2 then
			blue[twinklestar] = (pulse - 0.6) * 2.5
		end
	
		-- get ready to select the next star after this pulse is done
		selectnext = true
		
	elseif pulse < 0.6 and selectnext == true then
		-- we must select a new star for twinkling
		starsize[twinklestar] = defaultsize
		
		if nextcolour == nil then
			nextcolour = math.random(0,2)
		elseif nextcolour == 0 then
			red[twinklestar] = oldred
		elseif nextcolour == 1 then
			green[twinklestar] = oldgreen
		elseif nextcolour == 2 then
			blue[twinklestar] = oldblue
		end
		
		
		twinklestar = math.random(0,numberofstars)
		oldred = red[twinklestar]
		oldgreen = green[twinklestar]
		oldblue = blue[twinklestar]
		
		selectnext = false
		nextcolour = math.random(0,2)
	end
end

function LevelLogic()


	UpdateAttribs()
	
	playerasteroid.owner = 0
	playerasteroid:PlantDysonTree(1)
	
	for i = 0,numberofasteroids do
		if GetAsteroid(i).owner ~= 0 and GetAsteroid(i).owner ~= 1 then
			s = GetAsteroid(i):AddDefenseTree()
			s:LevelUp()
		end
	end
	
	-- the game hasn't been won yet.  it's only just starting!
	gamewon = false

	SetCameraPositionToAsteroidID(playerasteroid.ID)
	
	while GameRunning() do
		

		
		if GetGameTime() < 10 then
		
			Globals.Structures.RootSpeed=15
			
			
			if GetGameTime() > 1 then
				if bw > 50 then
					bw = bw - 1
					SetVignetteAlpha(bw)
				end
			end
		
		else
			Globals.Structures.RootSpeed=100
		end
		
		
		Twinkle()
		
		
		
		if starchasers == true then
			StarChasers(playerasteroid,2.5,0,1,2,3,4,5)
		end
	
		-- check if the empires are dead.
		-- start out by assuming they are all dead, and try to prove they are still alive
		aliveempires = numberofempires - 1
		for i = 2,numberofempires do
			if GetEmpire(i):GetNumOwnedAsteroids() == 0 and GetGameTime() > 30 then
				-- this empire is not dead.
				aliveempires = aliveempires - 1
			end
		end
		
		
		-- if all the empires are dead and we've not yet shown the player the "win" message...
		if aliveempires == 0 and gamewon == false then
			Pause()
			MessageBox("You won!")
			WaitDialog()
			Unpause()
			gamewon = true
			quittimer = GetGameTime() + 5
		end
		
		-- if it's 5 seconds after the player saw the "win" message...
		if gamewon == true then
			if quittimer < GetGameTime() then
				Quit(true)
			end
		end
		
		-- if the player has lost all of their asteroids...
		if GetEmpire(1):GetNumOwnedAsteroids() == 0 and GetGameTime() > 30 then
			Quit(false)
		end

		-- run AI engine
		
		InfectedAIEngine()
		
		
		coroutine.yield()
	end



end


function DoStuff(i)
	-- first, generate the asteroid's radius
	roidradius[i] = math.random(minpossibleradius,maxpossibleradius)
	
	-- we'll need to record the previous asteroid's send distance because...
	if senddist ~= nil then
		oldsenddist = senddist --+ roidradius[i]
	end
	-- next, the new send distance will be generated based on asteroid radius...
	senddist = (roidradius[i] / maxpossibleradius) * sendscale
end


function GenerateLevel()

	asteroidneighbours = {}
	roidradius = {}
	roidx = {}
	roidy = {}
	
	-- first, how many roids shall there be?
	numberofasteroids = math.random(15,50)
	--numberofasteroids = 15
	
	-- ok, and what will the base radius of these asteroids be?
	baseradius = math.random(70,150)
	
	-- and how much will the radius vary per asteroid?
	radiusvariation = math.random(150,300)
	
	
	-- what sort of distances should there be between each of them?
	sendscale = math.random(3500,4500)
	
	
	
	-- so that means...
	maxpossibleradius = baseradius + radiusvariation
	minpossibleradius = baseradius
	Globals.G.MinAsteroidSeparation = 400
	Globals.G.MaxAsteroidNeighbourDist=sendscale
	Globals.Asteroids.SeedlingCap=2500 + numberofasteroids * 10
	

	
	-- generate the asteroids...
	
	for i = 0,numberofasteroids do
		
		
		
		
		
		
		-- now generate coords for the asteroid
		if i == 0 then
			
			DoStuff(i)
			-- if this is the first asteroid, place it at coordinates 0,0.
			roidx[i] = 0
			roidy[i] = 0
			
		else
		
			-- pick a previous asteroid to base our new coords on
			
			
			plot = false
			plotattempt = 0
			
			while plot == false do
				plotattempt = plotattempt + 1
				plot = true
				
				DoStuff(i)
				
				
				-- this is the current method, which goes for a 4-stem approach
				lowestx = 0
				lowestxroid = GetAsteroid(0)
				
				lowesty = 0
				lowestyroid = GetAsteroid(0)
				
				highestx = 0
				highestxroid = GetAsteroid(0)
				
				highesty = 0
				highestyroid = GetAsteroid(0)
				
				for f = 0,i-1 do
					if GetAsteroid(f).position.x >= highestx then
						highestx = GetAsteroid(f).position.x
						highestxroid = GetAsteroid(f)
					elseif GetAsteroid(f).position.x <= lowestx then
						lowestx = GetAsteroid(f).position.x
						lowestxroid = GetAsteroid(f)
					elseif GetAsteroid(f).position.y >= highesty then
						highesty = GetAsteroid(f).position.y
						highestyroid = GetAsteroid(f)
					elseif GetAsteroid(f).position.y <= lowesty then
						lowesty = GetAsteroid(f).position.y
						lowestyroid = GetAsteroid(f)
					end
				end
				
				stemdirection = math.random(1,4)
				
				if stemdirection == 1 then
					-- stem east
					comparisonroid = highestxroid
				elseif stemdirection == 2 then
					--stem west
					comparisonroid = lowestxroid
				elseif stemdirection == 3 then
					-- stem north
					comparisonroid = lowestyroid
				elseif stemdirection == 4 then
					-- stem south
					comparisonroid = highestyroid
				elseif stemdirection == 5 then
					-- stem random recent
					comparisonroid = GetAsteroid(math.random(math.floor(i - math.sqrt(i)),i-1))
				else
					-- stem random
					comparisonroid = GetRandomAsteroid()
				end
				
				
				-- this was the old method - single stem growth.
				--comparisonroid = GetAsteroid(i-1)
				
				-- this was another, even older method, which tried to stem from only recently created asteroids.
				--comparisonroid = GetAsteroid(math.random(i - math.sqrt(i),i-1))
				
				-- record the coordinates of the previous asteroid
				comparex = roidx[comparisonroid.ID]
				comparey = roidy[comparisonroid.ID]
				
				-- generate new coordinates - it can be anywhere within the previous asteroid's send distance.
				-- first, generate a direction..
				dx = math.sin(math.random(0,10000) / 100)
				dy = math.sin(math.random(0,10000) / 100)
				
				-- move a minimum distance away
				mindist = 0.0
				dx = dx * (1 - mindist)
				dy = dy * (1 - mindist)
				if dx > 0 then
					dx = dx + mindist
				elseif dx < 0 then
					dx = dx - mindist
				end
				if dy > 0 then
					dy = dy + mindist
				elseif dy < 0 then
					dy = dy - mindist
				end
				
				-- calculate the length of this vector
				vlength = math.sqrt(dx^2 + dy^2)
				
				-- divide the vectors by their length to normalise them
				dx = dx / vlength
				dy = dy / vlength
				
				--if senddist < oldsenddist then
					oldsenddist = senddist
				--end
				
				-- now walk forward by the send distance of the previous asteroid...
				dx = dx * oldsenddist * vlength
				dy = dy * oldsenddist * vlength
				
				-- does this intersect with another asteroid?
				-- if so, don't plot this asteroid.
				for j = 0,i-1 do
				
					if i ~= j then
						testx = comparex + dx
						testy = comparey + dy
						
						checkx = GetAsteroid(j).position.x - testx
						checky = GetAsteroid(j).position.y - testy
						comboradius = (roidradius[i] + GetAsteroid(j).radius) * 2
						
						distance = math.sqrt(checkx^2 + checky^2)
						
						if comboradius * 2 > distance then
							plot = false
						end
					end
				end
				
				if plotattempt >= 20 then
					plot = true
				end
				
			end
			
			-- plot the new asteroid
			roidx[i] = comparex + dx
			roidy[i] = comparey + dy
			
			
			
			
			-- now to check the new asteroid can also return-path to the comparison asteroid
			
			
			--if senddist + comparisonroid.radius < comparisonroid.SendDistance then
			--	senddist = comparisonroid.SendDistance + comparisonroid.radius
			--end
			
			
			
			-- check for overlapping / too close together asteroids
			overlap = false
			
			for j = 0,i do
				xdiff = roidx[i] - roidx[j]
				ydiff = roidy[i] - roidy[j]
				
				distance = math.sqrt(xdiff^2 + ydiff^2)
				if distance < roidradius[i] + roidradius[j] + Globals.G.MinAsteroidSeparation and i ~= j then
					-- overlap
					overlap = true
				end
			end
		end

		
		

		
		-- generate energy, strength and speed attributes based on the size
		energy = 0.1
		str = 0.1
		speed = 0.1
		
		-- first, how big is this asteroid compared to average?
		attributescore = (roidradius[i] - minpossibleradius) / maxpossibleradius
		
		-- now attribute score is a value between 0 and 1, representing the quality of this asteroid.
		-- lets say that a perfect score of  1 would give you 30 "points"
		points = math.ceil(attributescore * 30) - 3
		
		-- and now, lets spend our points at random on the different stats
		for i = 0,points do
			choice = math.random(1,3)
			
			if choice == 1 and energy < 1 then
				energy = energy + 0.1
			elseif choice == 2 and str < 1 then
				str = str + 0.1
			elseif choice == 3 and speed < 1 then
				speed = speed + 0.1
			end
		end
		
		
		totalstats = energy + str + speed
		
		
		
		a = AddAsteroidWithAttribs(roidx[i],roidy[i],energy,str,speed)
		a.radius = roidradius[i]
		a.Owner = 0
		scale = roidradius[i] / maxpossibleradius
		scale = scale * 4
		cap = math.floor(scale) + 1
		a.TreeCap = cap
		
		a.SendDistance = senddist
		--a.Name = a.SendDistance

		-- if the asteroids overlap, make them moveable.  otherwise don't.
		if overlap == true then
			a.Moveable = true
		else
			a.Moveable = false
		end
		
		
		
		--a:AddDefenseTree()
		--a:Reveal(1)
		--a.Name = (totalstats)
		
		
		
		
	
	end

	
	numberofempires = math.random(3,9)
	if numberofempires > numberofasteroids then
		numberofempires = numberofasteroids
	end
	
	startingseeds = math.random(40,140)
	playerstartingseeds = startingseeds * 0.75
	stat = math.random(30,70) / 100
	
	
	-- add the empires
	for empirenumber = 1,numberofempires do
	
		-- how many asteroids are taken, so far?
		numbertaken = empirenumber - 1
	
		
		-- if no asteroids have been taken yet, then..
		if numbertaken == 0 then
			-- Get a random asteroid.  Grats player 1, this is yours.
			playerasteroid = GetRandomEmptyAsteroid()
			playerasteroid.owner = 1
			playerasteroid:AddSeedlings(playerstartingseeds,empirenumber,stat,stat,stat)
			playerasteroid:Reveal(1)
			playerasteroid.Name = "Fluffykins"
		
			-- but if some of the asteroids HAVE been taken..
		else
		
			longestroid = GetAsteroid(0)
			furthestaway = 0
			
			-- run a For loop, to check each of the asteroids in turn to find the most suitable one to deploy on.
			for checked = 0,numberofasteroids do
		
				if GetAsteroid(checked).owner == 0 then
		
					shortestdistance = nil
			
					-- run a For loop to check the distance against all other asteroids that have owners
					for distant = 0,numberofasteroids do
					
						-- Does checked belong to empire 0?  Check that distant DOESN'T belong to empire 0 - we're looking for the distance to the nearest empire remember!
						if GetAsteroid(distant).owner ~= 0 then
							-- what is the distance between checked and distant?
							
							dx = GetAsteroid(checked).position.x - GetAsteroid(distant).position.x
							dy = GetAsteroid(checked).position.y - GetAsteroid(distant).position.y
							distance = math.sqrt(dx^2 + dy^2)
							
							if shortestdistance == nil then
								shortestdistance = distance
							end
							
							if distance < shortestdistance then
								shortestdistance = distance
							end
							
							
						end
					
					end
					
					if shortestdistance > furthestaway then
						furthestaway = shortestdistance
						longestroid = GetAsteroid(checked)
					end
				end
			end

			longestroid:AddSeedlings(startingseeds,empirenumber,stat,stat,stat)
			longestroid.owner = empirenumber
			
			

		end
		

	end
	
	
	

	
	
	SetCameraPositionToAsteroidID(playerasteroid.id)
	
	--[[
	GetAsteroid(5).owner = 3
	s = GetAsteroid(5):AddDefenseTree()
	s:LevelUp()
	GetAsteroid(5):AddSeedlings(startingseeds,3,stat,stat,stat)
	
	GetAsteroid(10).owner = 5
	s = GetAsteroid(10):AddDefenseTree()
	s:LevelUp()
	GetAsteroid(10):AddSeedlings(startingseeds,5,stat,stat,stat)
	
	GetAsteroid(15).owner = 7
	s = GetAsteroid(15):AddDefenseTree()
	s:LevelUp()
	GetAsteroid(15):AddSeedlings(startingseeds,7,stat,stat,stat)
	
	GetAsteroid(20).owner = 9
	s = GetAsteroid(20):AddDefenseTree()
	s:LevelUp()
	GetAsteroid(20):AddSeedlings(startingseeds,9,stat,stat,stat)--]]
	

	
end


function UpdateAttribs()


	
	-- We must increase the size and attributes of any asteroids that
	-- artificially had their send distances increased due to distance.
	for i = 0,numberofasteroids do
		senddist = (roidradius[i] / maxpossibleradius) * sendscale
		
		-- check in case this will cause an overlap!
		overlapping = false
		for j = 0,numberofasteroids do
			if i ~= j then
				comboradius = GetAsteroid(i).radius + GetAsteroid(j).radius
				xdiff = GetAsteroid(i).position.x - GetAsteroid(j).position.x
				if xdiff^2 + comboradius < comboradius^2 then
					-- we have a horizontal overlap.  check vertical
					ydiff = GetAsteroid(i).position.y - GetAsteroid(j).position.y
					if ydiff^2 + comboradius < comboradius^2 then
						--bounding box overlap.  That's close enough!  don't do it.
						overlapping = true
						
					end
				end
			end
		end
		
		
		if senddist < GetAsteroid(i).SendDistance and overlapping == false then
			--GetAsteroid(i).Name = "Modified"
			-- we've found an asteroid that needs a radius and stats adjustment
			-- increase the radius to the right size for this send distance
			GetAsteroid(i).radius = (GetAsteroid(i).SendDistance / sendscale) * maxpossibleradius
			roidradius[i] = GetAsteroid(i).radius
			-- now calculate the new energy, strength and speed for the asteroid based on this new radius
			energy = 0.1
			str = 0.1
			speed = 0.1
			attributescore = (roidradius[i] - minpossibleradius) / maxpossibleradius
			points = math.ceil(attributescore * 30) - 3
			for i = 0,points do
				choice = math.random(1,3)
				if choice == 1 and energy < 1 then
					energy = energy + 0.1
				elseif choice == 2 and str < 1 then
					str = str + 0.1
				elseif choice == 3 and speed < 1 then
					speed = speed + 0.1
				end
			end
			GetAsteroid(i).Attribs.Energy = energy
			GetAsteroid(i).Attribs.Strength = str
			GetAsteroid(i).Attribs.Speed = speed
			-- now calculate the new treecap for this asteroid based on its radius
			scale = roidradius[i] / maxpossibleradius
			scale = scale * 4
			cap = math.floor(scale) + 1
			GetAsteroid(i).TreeCap = cap
		end
	end
end


function AIinit()
	-- *** INFECTED AI V2.3 : INIT ***
	-- *** AUTHOR: ANNIKK.EXE ***
	-- *** EMAIL: annikk [dot] exe [at] gmail [dot] com ***
	
	Globals.AI.GraceTimer=(99999)
	
	-- Number of times the engine is run per While loop:
	numberofiterations = 0
	-- Set to 0 for very large maps. (50 asteroids+)
	-- Set to 2-4 for small maps for quicker AI response.
	
	metric = {}
	currentowner = {}
	
	for i = 0,300 do
		metric[i] = 500
	end
	

	-- *** END INFECTED AI : INIT ***
end


function InfectedAIEngine()
	-- *** INFECTED AI V2.3 : ENGINE ***
	-- Author: ANNIKK.EXE [at] GMAIL [dot] COM
	numberofasteroids = -1
	neighbours = {}

	for i = 0, 300 do
		if GetAsteroid(i) ~= nil then
			if GetAsteroid(i).radius > 10 then
				numberofasteroids = numberofasteroids + 1
			end
		end
	end

	-- now the variable called "numberofasteroids" accurately represents the number of playable asteroids on the field.

	for iterations = 0,numberofiterations do
	
		-- Select an asteroid for checking.
		checkedroid = GetAsteroid(math.random(0,numberofasteroids))

		-- Record the current asteroid owner
		changedowner = false
		
		if currentowner[checkedroid.id] ~= nil then
			if currentowner[checkedroid.id] ~= checkedroid.owner then
				currentowner[checkedroid.id] = checkedroid.owner
				changedowner = true
			end
		else
			currentowner[checkedroid.id] = checkedroid.owner
		end
	
		tree = nil
		flower = nil
	
		-- flower check !
		tree = checkedroid:GetRandomDysonTree()
		
		if tree ~= nil then
			flower = tree:GetSuperSeedling()
		end
		
		if checkedroid.owner > 1 and flower ~= nil then
			flower:Pluck()
		end
		
		flower = checkedroid:GetFlower(checkedroid.owner)
		
		if checkedroid.owner > 1 and flower ~= nil then
			flower:PlantOnRandomDysonTree()
		end

		-- calculate which asteroids are a neighbour to checkedroid
		numberofneighbours = -1

		for i = 0,numberofasteroids do
			
			length = GetAsteroid(i).position.x - checkedroid.position.x
			height = GetAsteroid(i).position.y - checkedroid.position.y
			
			distancetoroid = math.sqrt((length * length) + (height * height))
			distancetoroid = distancetoroid - GetAsteroid(i).Radius
			
			if distancetoroid < checkedroid.SendDistance then
				-- this asteroid is in range.  Add it to the neighbours list, and increment the neighbour count by one.  ALSO ADDS SELF AS NEIGHBOUR!  But we trap for this in the Metric Update section.
				numberofneighbours = numberofneighbours + 1
				neighbours[numberofneighbours] = GetAsteroid(i)
			end
		end

		-- Metric update
		-- did we update from our own status?
		updated = false

		-- are we under attack?  if so set metric 0
		if checkedroid.owner ~= 1 and checkedroid.owner ~= 0 then
			
			if (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner)) > (checkedroid:GetNumTrees() * 5) or checkedroid:GetNumMines(1) > 0 then
				
				-- ok well we own this asteroid, and there are more enemy seeds here than our seeds (or there's a player mine here).  Now, we DO have at least 1 tree worth defending here, right?
				if checkedroid:GetNumTrees() > 0 then
					-- ok, we're under attack!  METRIC 0!
					metric[checkedroid.ID] = 0
					updated = true
				
				end
			end
		end
		
		-- are we maxed on trees?  if not, set metric 100
		-- (make sure we don't run this if we are under attack!)
		if updated == false then

			if checkedroid:GetNumTrees() < checkedroid.TreeCap then
				-- we don't have max trees here yet.  Metric 100!
				metric[checkedroid.ID] = 100
				updated = true
			end
			
		end
		-- Not under attack, maxed on trees, and ready to contribute to the empire.
		-- Check the status of our neighbours first before trying to become a gather point.
		-- only run this part of the code if we didn't get our metric from our own status
		if updated == false then
			-- are we a suitable gather point?
			
			enemydetected = false
			frienddetected = false
			gatherpointdetected = false
			lowermetricsnearby = false
		
			for i = 0, numberofneighbours do
			
				-- check that we're not examining ourself.
				if neighbours[i] ~= checkedroid then
		
					if neighbours[i].owner == checkedroid.owner then
						-- this asteroid is friendly to us
						frienddetected = true
					end
				
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i].owner ~= 0 and neighbours[i]:GetNumTrees() > 0 then
						-- this asteroid doesn't belong to us or player 0, and has at least 1 tree.  It must be an enemy roid.
						enemydetected = true
					end
					
					numberofenemies = neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)
				
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumTrees() == 0 and numberofenemies > 0 then
						-- this asteroid doesn't belong to us, has no trees on it, but has enemy seedlings on it.  Treat it as enemy.
						enemydetected = true
					end
					
					if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].ID] == 200 then
						-- this asteroid is friendly to us, and is a gather point.
						gatherpointdetected = true
					end
				
					if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] < 200 then
						-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
						lowermetricsnearby = true
					end
					if neighbours[i].owner == 0 and metric[neighbours[i].id] < 200 then
						-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
						lowermetricsnearby = true
					end	
				end
			
			end
			
			if enemydetected == true and frienddetected == true and gatherpointdetected == false and lowermetricsnearby == false then
				-- the conditions are right for me to become a gather point.
				metric[checkedroid.id] = 200
			elseif changedowner == true then
				-- the asteroid just became mine.  insta-gather point please!
				metric[checkedroid.id] = 200
			end

			-- Find the lowest metric among my neighbours
			lowestmetric = metric[checkedroid.ID]
			
			for i = 0, numberofneighbours do
				
				-- check that we're not examining ourself.
				if neighbours[i].id ~= checkedroid.id then
			
					if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
						-- this asteroid belongs to our empire, or it doesn't belong to anyone (and we should therefore follow its metrics)
						
						-- is this neighbour's metric less than mine?  (also, have we just taken this asteroid..?)
						if metric[neighbours[i].ID] < lowestmetric and changedowner == false then
							-- yes it's lower.
							lowestmetric = metric[neighbours[i].ID]
						end
					
					end
				
				end
			end
		
			-- now we've established what the lowest metric is.  If it's lower than ours, set ours to that +1.  If the lowest metric of a neighbour is the same as our metric, increase ours by 1.
			-- UNLESS we are a gather point
			if metric[checkedroid.ID] > lowestmetric and metric[checkedroid.ID] ~= 200 and metric[checkedroid.ID] ~= 100 then
				metric[checkedroid.ID] = lowestmetric + 5
			end
			
			if metric[checkedroid.ID] == lowestmetric and metric[checkedroid.ID] ~= 200 and metric[checkedroid.ID] ~= 100 then
				-- if my metric is the same as the lowest metric of my neighbours, i must be 1 step further away than they are.
				metric[checkedroid.ID] = metric[checkedroid.ID] + 5
			end
			
			-- check for errors, reset metric if necessary
			
			if metric[checkedroid.id] > 500 then
				metric[checkedroid.id] = 200
			end
			
			if metric[checkedroid.ID] > 0 and metric[checkedroid.ID] < 99 then
				stillinneed = false
				
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner and metric[i] == 0 then
						stillinneed = true
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 0 and metric[i] < 99 then
							metric[i] = 500
						end
					end
				end
			
			end
			
			if metric[checkedroid.ID] > 100 and metric[checkedroid.ID] < 199 then
				stillinneed = false
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner or GetAsteroid(i).owner == 0 then
						if metric[i] == 100 then
							stillinneed = true
						end
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 100 and metric[i] < 199 then
							metric[i] = 500
						end
					end
				end
			end
			
			if metric[checkedroid.ID] > 200 and metric[checkedroid.ID] < 299 then
				stillinneed = false
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner and metric[i] == 200 then
						stillinneed = true
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 200 and metric[i] < 299 then
							metric[i] = 500
						end
					end
				end
			end
			
		end

		-- Now to check that if we have metric 0, 100 or 200, we still require that status.
		
		if metric[checkedroid.id] == 0 then
			-- ok.  Am I REALLY still under attack?
			if checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner) > 1 or checkedroid:GetNumMines(1) > 0 then
				-- the enemy outnumber us, or there's a player mine here.  Yes, we're really under attack...
			else
				-- we're not really under attack anymore.  lets reset the metric.
				for i = 0, numberofasteroids do
					if GetAsteroid(i).owner == checkedroid.owner then
						metric[i] = 500
					end
				
				end
				metric[checkedroid.id] = 200
			end
		end
		
		if metric[checkedroid.id] == 100 then
			-- ok.  Am I REALLY still under construction?
			if checkedroid:GetNumTrees() < checkedroid.TreeCap then
				-- we do indeed have less trees than the treecap, so we still need seeds.
			else
				-- we're not really under construction anymore.  lets reset the metric.
				metric[checkedroid.id] = 200
			end
		end

		enemydetected = false
		frienddetected = false
		gatherpointdetected = false	
		lowermetricsnearby = false

		-- ok.  Am I REALLY still a suitable gather point?
		for i = 0, numberofneighbours do
			-- check that we're not examining ourself.
			if metric[checkedroid.ID] == 200 and neighbours[i].ID ~= checkedroid.id and changedowner == false then
				if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
					-- this asteroid is friendly or neutral to us
					frienddetected = true
				end
			
				if neighbours[i].owner ~= checkedroid.owner and neighbours[i].owner ~= 0 and neighbours[i]:GetNumTrees() > 0 then
					-- this asteroid doesn't belong to us or player 0, and has at least 1 tree.  It must be an enemy roid.
					enemydetected = true
				end
				
				numberofenemies = neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)
				
				if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumTrees() == 0 and numberofenemies > 9 then
					-- this asteroid doesn't belong to us, has no trees on it, but has enemy seedlings on it.  Treat it as enemy.
					enemydetected = true
				end
				
				if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].ID] == 200 then
					-- this asteroid is friendly to us, and is a gather point.
					gatherpointdetected = true
				end
				
				if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] < 200 then
					-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
					lowermetricsnearby = true
				end			
				if neighbours[i].owner == 0 and metric[neighbours[i].id] < 200 then
					-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
					lowermetricsnearby = true
				end	
			end
		
		end
		
		if metric[checkedroid.id] == 200 and changedowner == false then
			
			if enemydetected == true and gatherpointdetected == false and lowermetricsnearby == false then
				-- the conditions are right for me to continue as a gather point.

			else
				-- the conditions are no longer right.  Best to reset the metric.
				metric[checkedroid.id] = 500
			end
			
		end
	
		if frienddetected == false and enemydetected == true and checkedroid:GetNumTrees() == checkedroid.TreeCap then
			-- we're an orphan with max trees!  lets become a gather point.
			metric[checkedroid.id] = 200
		end
	
		-- Actions
		
		-- There are 3 different action types.  We must make sure not to use any actions for players 0 and 1!
		-- 1.  Plant trees
		
		-- trap for player 0, exclude player 1
		if checkedroid.owner == 0 or checkedroid.owner > 1 then
			-- so plant one :>
			for i = 2,10 do		
				
				if metric[checkedroid.id] == 100 and (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(i)) < 5 and checkedroid:GetNumSeedlings(i) > 9 then
					-- this asteroid isn't owned by greys or player, the enemy only has a bit of seedlings here
					-- its metric is 100
					-- and it has enough seedlings belonging to the asteroid's empire to plant a tree
					a = checkedroid:PlantDysonTree(i)
				end
			end
		end

		-- 2.  Send seedlings to the next lowest metric
		
		if metric[checkedroid.id] ~= 0 and metric[checkedroid.id] ~= 100 and metric[checkedroid.id] ~= 500 and checkedroid.owner > 1 then
		
			-- we're not under attack or construction.
			numberofdestinations = 0
			
			for i = 0,numberofneighbours do
				if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
					-- this neighbour is one of our asteroids, or it's a blank asteroid

					if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
						if metric[neighbours[i].ID] < metric[checkedroid.ID] then
							-- we've found a friendly neighbour with a metric lower than ours!
							-- add it to the destinations list
							numberofdestinations = numberofdestinations + 1
						end
					end

				end
			end
			
			if numberofdestinations > 0 then
			
				-- we've found some destinations to send seeds to.  Lets send some.
				numberofseedsleft = checkedroid:GetNumSeedlings(checkedroid.owner) - (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner))
				numberperdestination = numberofseedsleft / numberofdestinations
				
				for i = 0,numberofneighbours do
					if neighbours[i] ~= checkedroid then
						if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
							if metric[neighbours[i].ID] < metric[checkedroid.ID] then
								-- this destination has less than our metric.  This is one of the valid destinations.  Send a proportional amount of seeds to it.
								if neighbours[i].owner == 0 and numberofseedsleft < 10 then
									-- don't bother sending.
								
								elseif neighbours[i].owner == 0 and neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner) > 0 and numberofseedsleft > 9 + (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) then
									-- attack the greys!  (or whoever is camping the roid!)
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, checkedroid:GetNumSeedlings(checkedroid.owner), neighbours[i])
									numberofseedsleft = 0
								
								elseif neighbours[i].owner == 0 and numberofseedsleft > 9 and (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) == 0 then
									-- this is the last we can manage.  Send all 10.
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, 10, neighbours[i])
									numberofseedsleft = numberofseedsleft - 10
								
								elseif neighbours[i].owner == checkedroid.owner then
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, numberperdestination, neighbours[i])
									numberofseedsleft = numberofseedsleft - numberperdestination
								end
							end
						end
					end
				end
			end

			-- 3.  Attack the weakest nearby asteroid
			
			-- Are we a gather point?  Only gather points are allowed to attack.
			
			if metric[checkedroid.id] == 200 then

				totalenemies = 0
				totalfriendlies = checkedroid:GetNumSeedlings(checkedroid.owner)
				weakestamount = 10000
				weakestroid = checkedroid
				attack = false
				orphan = true
				numberofenemyroids = 0
				
				for i = 0,numberofneighbours do
					
					if neighbours[i].owner == checkedroid.owner and neighbours[i] ~= checkedroid then
						orphan = false
					end
					
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner) > 5 then
						-- found an attack path
						numberofenemyroids = numberofenemyroids + 1
					end
					
					for j = 0,10 do
						if checkedroid.owner ~= j then
							totalenemies = totalenemies + neighbours[i]:GetNumSeedlings(j)
							
							if weakestamount > neighbours[i]:GetNumSeedlings(j) and neighbours[i].owner == j then
								-- the owner of this asteroid has a smaller number of seeds than we've seen before...
								weakestamount = neighbours[i]:GetNumSeedlings(j)
								weakestroid = neighbours[i]
							end
						
						end
					end
					
					if neighbours[i] ~= checkedroid and neighbours[i].owner ~= checkedroid.owner then
						if neighbours[i]:GetNumSeedlings(checkedroid.owner) > (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) then
							-- already attacking, and winning.  send reinforcements.
							checkedroid:SendSeedlingsToTarget(checkedroid.owner, checkedroid:GetNumSeedlings(checkedroid.owner), neighbours[i])
						end
					end
				end
				
				-- in the first case, we have more seedlings than all the neighbouring asteroids put together.
				if totalfriendlies > totalenemies + (weakestroid:GetNumTrees() * 10) then
					attack = true
				end
				
				split = false
				
				-- in the second case, we have more than 150 seedlings on this roid, and it's time to move out!
				if totalfriendlies > 150 then
					attack = true
					split = true
				end
				
				if totalfriendlies >= Globals.Asteroids.SpawnCap and orphan == true then
					attack = true
				end
				
				if attack == true and checkedroid.owner > 1 and split == false then
					-- ok so we're a gather point, we're ready to attack, and we aren't a player or greys asteroid.
					-- lets move out.
					checkedroid:SendSeedlingsToTarget(checkedroid.owner, totalfriendlies, weakestroid)
				elseif attack == true and checkedroid.owner > 1 and split == true then
				
					for i = 0,numberofneighbours do
						if neighbours[i].owner ~= checkedroid.owner then
							-- attackable path - send proportional amount of seeds.
							checkedroid:SendSeedlingsToTarget(checkedroid.owner, totalfriendlies / numberofenemyroids, neighbours[i])
						end
					end
				end
			end
		end
		-- Set asteroid names to whatever their metric is.  Uncomment the
		-- line below for testing purposes if the AI shows unexpected behaviours.
		-- checkedroid.Name = metric[checkedroid.ID]
	end
	-- *** END INFECTED AI : ENGINE ***
end


function StarfieldInit()
	-- *** 3D STARFIELD : INIT ***
	-- *** AUTHOR: ANNIKK.EXE ***
	-- *** EMAIL: annikk [dot] exe [at] gmail [dot] com ***
	
	-- initialise arrays
	starX = {}
	starY = {}
	SetStarX = {}
	SetStarY = {}
	SetStarZ = {}
	starsize = {}
	SetStarSize = {}
	red = {}
	green = {}
	blue = {}
	threshold = {}

	
	starfieldsizemultiplier = 4

	
	if bw == 255 then
		-- the background is white
		-- a small number of large-ish, black, semi-transparent stars with occasional twinkle (size briefly increases)
		numberofstars = 150

		-- calculate width of starfield
		highx = 0
		highxroid = GetAsteroid(0)
		lowx = 0
		lowxroid = GetAsteroid(0)
		highy = 0
		highyroid = GetAsteroid(0)
		lowy = 0
		lowyroid = GetAsteroid(0)
		for i = 0,numberofasteroids do
			if GetAsteroid(i).position.x < lowx then
				lowx = GetAsteroid(i).position.x
				lowxroid = GetAsteroid(i)
			end
			if GetAsteroid(i).position.x > highx then
				highx = GetAsteroid(i).position.x
				highxroid = GetAsteroid(i)
			end
			if GetAsteroid(i).position.y < lowy then
				lowy = GetAsteroid(i).position.y
				lowyroid = GetAsteroid(i)
			end
			if GetAsteroid(i).position.y > highy then
				highy = GetAsteroid(i).position.y
				highyroid = GetAsteroid(i)
			end
		end
		widthofstarfield = (math.sqrt(lowx^2) + math.sqrt(highx^2)) * starfieldsizemultiplier * 3
		heightofstarfield = (math.sqrt(lowy^2) + math.sqrt(highy^2)) * starfieldsizemultiplier * 3
		
		stoprenderingbelow = 0.01
		
		zscalefactor = 1200
		starscalefactor = 0.00005
		
		spriteindex = 1
		
		maxasteroids = 200
		radiusignorethreshold = 10

		for i = 0,numberofstars do
			-- generate stars
			
			SetStarX[i] = math.random(0,widthofstarfield) - (widthofstarfield / 2)
			SetStarY[i] = math.random(0,heightofstarfield) - (heightofstarfield / 2)
			SetStarZ[i] = math.random(3000,180000)
			
			red[i] = math.random(0,20) / 100
			green[i] = red[i]
			blue[i] = red[i]
			
			SetStarSize[i] = 1200000
			starsize[i] = SetStarSize[i]
			threshsetting = 5.5
			threshold[i] = (numberofasteroids / (10000000 * threshsetting)) * SetStarZ[i]
		end
		
		
		
		
		defaultsize = 1200000
		
		starscroll = false
		twinkle = true
		selectnext = true
		twinklestar = 1
		oldblue = 0.1
		oldred = 0.1
		oldgreen = 0.1
		starchasers = false
		
		
	else
		-- the background is black
		-- a larger number of small multicoloured stars, occasionally twinkling.  some shooting stars.
		numberofstars = 420 - ((50 - numberofasteroids) * 3)

		-- calculate width of starfield
		highx = 0
		highxroid = GetAsteroid(0)
		lowx = 0
		lowxroid = GetAsteroid(0)
		highy = 0
		highyroid = GetAsteroid(0)
		lowy = 0
		lowyroid = GetAsteroid(0)
		for i = 0,numberofasteroids do
			if GetAsteroid(i).position.x < lowx then
				lowx = GetAsteroid(i).position.x
				lowxroid = GetAsteroid(i)
			end
			if GetAsteroid(i).position.x > highx then
				highx = GetAsteroid(i).position.x
				highxroid = GetAsteroid(i)
			end
			if GetAsteroid(i).position.y < lowy then
				lowy = GetAsteroid(i).position.y
				lowyroid = GetAsteroid(i)
			end
			if GetAsteroid(i).position.y > highy then
				highy = GetAsteroid(i).position.y
				highyroid = GetAsteroid(i)
			end
		end
		widthofstarfield = 35000 + ((math.sqrt(lowx^2) + math.sqrt(highx^2)) * starfieldsizemultiplier)
		heightofstarfield = 35000 + ((math.sqrt(lowy^2) + math.sqrt(highy^2)) * starfieldsizemultiplier)
		
		stoprenderingbelow = 0.01
		
		zscalefactor = 1200
		starscalefactor = 0.00005
		
		spriteindex = 0
		
		maxasteroids = 200
		radiusignorethreshold = 10

		for i = 0,numberofstars do
			-- generate stars
			
			SetStarX[i] = math.random(0,widthofstarfield) - (widthofstarfield / 2)
			SetStarY[i] = math.random(0,heightofstarfield) - (heightofstarfield / 2)
			SetStarZ[i] = math.random(7500,46000 + ((50 - numberofasteroids) * 850))
			
			red[i] = math.random(20,100) / 100
			green[i] = math.random(20,100) / 100
			blue[i] = math.random(20,100) / 100
			
			SetStarSize[i] = 700000
			starsize[i] = SetStarSize[i]
			thresholdsetting = 52
			threshold[i] = (17500 / (thresholdsetting * 100000000)) * SetStarZ[i]
		end
		
		SetStarSize[0] = 50
		SetStarSize[1] = 50
		SetStarSize[2] = 50
		SetStarSize[3] = 50
		SetStarSize[4] = 50
		SetStarSize[5] = 50
		
		starscroll = false
		if numberofasteroids < 28 then
			starscroll = true
			scrollx = math.random(-10,10)
			scrolly = math.random(-10,10)
		end
		
		defaultsize = 700000
		
		starchasers = true
		twinkle = true
		selectnext = true
		twinklestar = 1
		oldblue = 0.1
		oldred = 0.1
		oldgreen = 0.1
	end
	
	
	
	
	-- *** END OF USER-CHANGEABLE PARALLAX VARIABLES

	
	numberofasteroids = -1
	
	for i = 0, maxasteroids do
		if GetAsteroid(i) ~= nil then
			if GetAsteroid(i).radius > radiusignorethreshold then
				numberofasteroids = numberofasteroids + 1
			end
		end
	end

	

	-- now the variable called "numberofasteroids" accurately represents the number of playable asteroids on the field.
	-- *** END 3D STARFIELD : INIT **
end


function StarfieldEngine()
	-- *** 3D STARFIELD : ENGINE ***

	-- calculate which asteroids are visible
	local visible = {}
	local NumberOfVisibleRoids = -1
	
	for i = 0,numberofasteroids do
		if GetAsteroid(i)~= nil then
			if IsOnScreen(GetAsteroid(i).position.x,GetAsteroid(i).position.y,GetAsteroid(i).radius) == true then
				NumberOfVisibleRoids = NumberOfVisibleRoids + 1
				visible[NumberOfVisibleRoids] = GetAsteroid(i)
			end
		end
	end
	
	
	-- now calculate the current Z-position of the camera
	local CameraZ = (-1 / GetCameraScale()) * zscalefactor

	
	-- for each star...
	for i = 0, numberofstars do
		-- calculate X and Y drawn positions

		StarScroll(i)
		
		local slopeX = (GetCameraX() - SetStarX[i]) / (CameraZ - SetStarZ[i])
		local slopeY = (GetCameraY() - SetStarY[i]) / (CameraZ - SetStarZ[i])
		starX[i] = SetStarX[i] - (slopeX * SetStarZ[i])
		starY[i] = SetStarY[i] - (slopeY * SetStarZ[i])
		
		-- if this star is on the screen then...
		if IsOnScreen(starX[i],starY[i],starsize[i]) == true and SetStarZ[i] > CameraZ then
			local draw = true
			-- calculate alpha
			local alpha = 1 - ((1 / GetCameraScale()) * threshold[i])
		
			-- if the alpha is such that the star needs to be rendered...
			if alpha > stoprenderingbelow then
				-- if this star is in the background (rather than in front of asteroids) then...
				if SetStarZ[i] > 0 then
					-- for each visible asteroid
					for j = 0,NumberOfVisibleRoids do
						-- check for 1D x-dimension overlap
						local singleDXcheck = starX[i] - visible[j].position.x
						-- if there's a X overlap, then
						if singleDXcheck > -visible[j].radius and singleDXcheck < visible[j].radius then
							--check for 1D y-dimension overlap
							local singleDYcheck = starY[i] - visible[j].position.y
							-- if we have a bounding box overlap, then...
							if singleDYcheck > -visible[j].radius and singleDYcheck < visible[j].radius then
								-- there's a bounding box overlap.  check it in proper 2D now.
								if (starX[i] - visible[j].position.x)^2 + (starY[i] - visible[j].position.y)^2 < visible[j].radius^2 then
									-- Obscured behind an asteroid.  Don't render this star!
									draw = false
									break
								end
							end
						end
					end
				end
				
				-- if the star is on the screen and its alpha is above the rendering threshold...
				if draw == true then
					-- calculate the distance between the camera and the star
					local distance2d = ((GetCameraX() ) - (SetStarX[i]))^2 + ((GetCameraY()) - (SetStarY[i]))^2
					local distance3d = math.sqrt((CameraZ - SetStarZ[i])^2 + distance2d)
					
					-- set the size for this star.. we can't localise this one as we need to refer to it in levellogic
					starsize[i] = SetStarSize[i] / distance3d
					
					-- finally, convert the stars to ScreenDraw coordinates
					starX[i] = (starX[i] * GetCameraScale()) - (GetCameraX() * GetCameraScale()) + (GetScreenWidth() - (GetScreenWidth() / 2))
					starY[i] = (starY[i] * GetCameraScale()) - (GetCameraY() * GetCameraScale()) + (GetScreenHeight() - (GetScreenHeight() / 2))
					
					-- draw star
					DrawSprite(spriteindex, starX[i],starY[i], red[i],green[i],blue[i],alpha, starsize[i])
				end
			end
		end
	end

	-- *** END 3D STARFIELD : ENGINE ***
end


function StarScroll(i)
	if starscroll == true then
		
		SetStarX[i] = SetStarX[i] + scrollx
		SetStarY[i] = SetStarY[i] + scrolly

		if SetStarX[i] > widthofstarfield / 2 then
			SetStarX[i] = SetStarX[i] - widthofstarfield
		elseif SetStarX[i] < -widthofstarfield / 2 then
			SetStarX[i] = SetStarX[i] + widthofstarfield
		elseif SetStarY[i] > heightofstarfield / 2 then
			SetStarY[i] = SetStarY[i] - heightofstarfield
		elseif SetStarY[i] < -heightofstarfield / 2 then
			SetStarY[i] = SetStarY[i] + heightofstarfield
		end
	
	
	end
end


function StarChasers(roid,speed,star0,star1,star2,star3,star4,star5)
	-- star chasers
	-- this function expects an asteroid. (NOT AN ID NUMBER!)
	-- then it expects a speed, which will be used as a multiplier.
	-- Then it expects 6 numbers.  The numbers correspond
	-- to the Star ID's you wish to use as chasers.
	
	orbit = roid.radius * 1.5
	sine = math.sin(GetGameTime() * speed)
	cosine = math.cos(GetGameTime() * speed)
	
	threshold[star0] = 0.01
	threshold[star1] = 0.01
	threshold[star2] = 0.01
	threshold[star3] = 0.01
	threshold[star4] = 0.01
	threshold[star5] = 0.01
	
	SetStarSize[star0] = 200000
	SetStarSize[star1] = 200000
	SetStarSize[star2] = 200000
	SetStarSize[star3] = 200000
	SetStarSize[star4] = 200000
	SetStarSize[star5] = 200000
	
	
	-- Z and Y
	SetStarX[star0] = roid.position.x
	SetStarY[star0] = roid.position.y + (sine * orbit)
	SetStarZ[star0] = cosine * orbit
	
	SetStarX[star1] = roid.position.x
	SetStarY[star1] = roid.position.y + (sine * -orbit)
	SetStarZ[star1] = cosine * -orbit
	
	-- Z and X
	SetStarX[star2] = roid.position.x + (sine * orbit)
	SetStarY[star2] = roid.position.y
	SetStarZ[star2] = cosine * orbit
	
	SetStarX[star3] = roid.position.x + (sine * -orbit)
	SetStarY[star3] = roid.position.y
	SetStarZ[star3] = cosine * -orbit
	
	-- X and Y
	SetStarX[star4] = roid.position.x + (sine * orbit)
	SetStarY[star4] = roid.position.y + (cosine * orbit)
	SetStarZ[star4] = 0
	
	SetStarX[star5] = roid.position.x + (sine * -orbit)
	SetStarY[star5] = roid.position.y + (cosine * -orbit)
	SetStarZ[star5] = 0
end

--level end