function LevelSetup()



	-- ** None of these are strictly necessary for Gravity... change as you like. **
	SetBackdropColour(0,0,0)

	Globals.Agents.MaxSpeed=1100
	Globals.Agents.MinSpeed=800
	
	Globals.Structures.MinHealth=400
	Globals.Structures.MaxHealth=400

	Globals.Mines.MinSpeed=1200
	Globals.Mines.MaxSpeed=1200
	Globals.Mines.MinHealth=2000
	Globals.Mines.MaxHealth=2000
	
	Globals.Asteroids.MaxTrees=3
	Globals.Asteroids.MinRadius=125
	Globals.Asteroids.MaxRadius=725
	Globals.Asteroids.RadiusPowerRule=1.5
	Globals.Asteroids.MinCoreHealth=50
	Globals.Asteroids.MaxCoreHealth=900
	Globals.Asteroids.CoreHealthPower=1
	Globals.Asteroids.MinSendDistance=80000
	Globals.Asteroids.MaxSendDistance=80000
	Globals.Asteroids.SendPowerRule=1.4
	Globals.Asteroids.SpawnCap=100
	Globals.Asteroids.SeedlingCap=10000
	Globals.G.Asteroids=(0)

	Globals.AI.GraceTimer=(99999)

	Globals.G.EnemyFactionsMin=(0)
	Globals.G.EnemyFactionsMax=(0)
	Globals.G.MinAsteroidSeparation=100
	Globals.G.MaxAsteroidNeighbourDist=80000
	Globals.G.GreysProbability=0

	Globals.Structures.FlowerProbability=(0)
	
	SetVignetteAlpha(0)
	-- **
	
	
	
	
	
	-- ** Initialise Gravity Variables.  No need to change anything here.
	
	AccelerationX = {}
	AccelerationY = {}
	MomentumX = {}
	MomentumY = {}
	density = {}
	CoordX = {}
	CoordY = {}
	roidradius = {}
	Timer = 0

	-- **
	
	
	
	
	
	-- ** G is the gravitational constant.  Affects how powerful gravity is in the entire map.  Change this as you like. **
	
	G = 0.001
	
	-- **
	
	
	
	
	
	
	-- ****************************************
	-- **********Asteroid Creation*************
	-- ****************************************
	--
	sundensity = 0.606709620171838
	
	-- ***
	-- 1.  THE BELOW ASTEROIDS HAVE A GRAVITY WELL BUT DO NOT THEMSELVES MOVE
	-- ***
	
	
	-- Asteroid 0
	-- gravity variables
	roid = 0
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = sundensity
	CoordX[roid] = 30000
	CoordY[roid] = 30000
	roidradius[roid] = 2000
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],1,1,1)
	a.Owner = 2
	a.TreeCap = 0
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	


	-- Asteroid 1
	-- gravity variables
	roid = 1
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = sundensity
	CoordX[roid] = -30000
	CoordY[roid] = 30000
	roidradius[roid] = 2000
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],1,1,1)
	a.Owner = 2
	a.TreeCap = 0
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False

	
	-- Asteroid 2
	-- gravity variables
	roid = 2
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = sundensity
	CoordX[roid] = 30000
	CoordY[roid] = -30000
	roidradius[roid] = 2000
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],1,1,1)
	a.Owner = 2
	a.TreeCap = 0
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	


	-- Asteroid 3
	-- gravity variables
	roid = 3
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = sundensity
	CoordX[roid] = -30000
	CoordY[roid] = -30000
	roidradius[roid] = 2000
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],1,1,1)
	a.Owner = 2
	a.TreeCap = 0
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	a.MaxCoreHealth = 50000

	
	
	
	-- ** counter for gravity behaviour divisions, do not remove **
	wellonlythreshold = roid + 1
	-- **
	
	-- ***
	-- 2.  THE BELOW ASTEROIDS HAVE A GRAVITY WELL, AND MOVE
	-- ***
	
	
	
	
	-- Asteroid 4
	-- gravity variables
	roid = 4
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 15
	MomentumY[roid] = 15
	density[roid] = 17.8
	CoordX[roid] = -3000
	CoordY[roid] = -1800
	roidradius[roid] = 300
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],1,1,1)
	a.Owner = 4
	a.TreeCap = 0
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False

	
	
	
	
	-- Asteroid 5
	-- gravity variables
	roid = 5
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = -15
	MomentumY[roid] = -15
	density[roid] = 17.8
	CoordX[roid] = 3000
	CoordY[roid] = 1800
	roidradius[roid] = 300
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],1,1,1)
	a.Owner = 5
	a.TreeCap = 0
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	
	
	
	
	-- ** counter for gravity behaviour divisions, do not remove **
	gravroidsthreshold = roid
	-- **
	
	-- 3.  THE BELOW ASTEROIDS DO NOT MOVE AND DO NOT HAVE A GRAVITY WELL

	
	
	
	
	-- *** FIRST GALAXY ***
	
	-- Asteroid 6
	-- gravity variables
	roid = 6
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[0] + 4500
	CoordY[roid] = CoordY[0] + 10700
	roidradius[roid] = 875
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(30,70) / 100))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	--a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(17, 2, 1, 1, 1)
	
	
	-- Asteroid 7
	-- gravity variables
	roid = 7
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[0] + 9500
	CoordY[roid] = CoordY[0] + 12250
	roidradius[roid] = 525
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(30,70) / 100))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	--a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(18, 2, 1, 1, 1)
	
	
	
	
	-- Asteroid 8
	-- gravity variables
	roid = 8
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[0] + 2500
	CoordY[roid] = CoordY[0] + 16250
	roidradius[roid] = 650
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(30,70) / 100))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	--a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(19, 2, 1, 1, 1)


	
	
	-- Asteroid 9
	-- gravity variables
	roid = 9
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[0] + 14250
	CoordY[roid] = CoordY[0] + 17500
	roidradius[roid] = 515
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(30,70) / 100))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	--a:Reveal(1)
	a.Moveable = False
	
	
	
	-- Asteroid 10
	-- gravity variables
	roid = 10
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[0] + 7250
	CoordY[roid] = CoordY[0] + 23500
	roidradius[roid] = 750
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(30,70) / 100))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	--a:Reveal(1)
	a.Moveable = False
	
	
	
	-- Asteroid 11
	-- gravity variables
	roid = 11
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[0] + 23500
	CoordY[roid] = CoordY[0] + 20250
	roidradius[roid] = 1075
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(45,90) / 100),(math.random(45,85) / 100),(math.random(30,70) / 100))
	a.Owner = 1
	a.TreeCap = 4
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	s = a:AddDysonTree()
	s = a:AddDysonTree()
	s = a:AddDysonTree()
	a:AddSeedlings(62,1,0.25,0.01,0.01)
	
	
	-- Asteroid 12
	-- gravity variables
	roid = 12
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[0] - 1850
	CoordY[roid] = CoordY[0] + 20750
	roidradius[roid] = 450
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(6,10) / 10),(math.random(6,10) / 10),(math.random(4,10) / 10))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	--a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(18, 2, 1, 1, 1)
	
	
	
	
	
	
	
	
	-- *** SECOND GALAXY ***
	
	
	-- Asteroid 13
	-- gravity variables
	roid = 13
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[1] - 4500
	CoordY[roid] = CoordY[1] + 10700
	roidradius[roid] = 875
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(5,10) / 10),(math.random(5,10) / 10),(math.random(5,10) / 10))
	a.Owner = 2
	a.TreeCap = 5
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	s = a:AddDefenseTree()

	
	
	-- Asteroid 14
	-- gravity variables
	roid = 14
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[1] - 9500
	CoordY[roid] = CoordY[1] + 12250
	roidradius[roid] = 525
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 5
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	s = a:AddDefenseTree()
	s = a:AddDefenseTree()
	s = a:AddDefenseTree()
	
	
	
	
	-- Asteroid 15
	-- gravity variables
	roid = 15
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[1] - 2500
	CoordY[roid] = CoordY[1] + 16250
	roidradius[roid] = 650
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 5
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	s = a:AddDefenseTree()
	s = a:AddDefenseTree()
	s = a:AddDefenseTree()


	
	
	-- Asteroid 16
	-- gravity variables
	roid = 16
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[1] - 14250
	CoordY[roid] = CoordY[1] + 17500
	roidradius[roid] = 515
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 5
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	
	
	
	
	-- Asteroid 17
	-- gravity variables
	roid = 17
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[1] - 7250
	CoordY[roid] = CoordY[1] + 23500
	roidradius[roid] = 750
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	
	
	
	-- Asteroid 18
	-- gravity variables
	roid = 18
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[1] - 23500
	CoordY[roid] = CoordY[1] + 20250
	roidradius[roid] = 1075
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(4,10) / 10),(math.random(4,10) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 5
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	
	
	
	-- Asteroid 19
	-- gravity variables
	roid = 19
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[1] + 1850
	CoordY[roid] = CoordY[1] + 20750
	roidradius[roid] = 450
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(4,10) / 10),(math.random(4,10) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	
	
	
	
	
	
	
	-- *** THIRD GALAXY ***


	-- Asteroid 20
	-- gravity variables
	roid = 20
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[2] + 4500
	CoordY[roid] = CoordY[2] - 10700
	roidradius[roid] = 875
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(4,9) / 10),(math.random(5,8) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(1)
	
	
	-- Asteroid 21
	-- gravity variables
	roid = 21
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[2] + 9500
	CoordY[roid] = CoordY[2] - 12250
	roidradius[roid] = 525
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(1,5) / 10),(math.random(3,6) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 2
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(1)
	
	
	
	
	-- Asteroid 22
	-- gravity variables
	roid = 22
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[2] + 2500
	CoordY[roid] = CoordY[2] - 16250
	roidradius[roid] = 650
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(1)


	
	
	-- Asteroid 23
	-- gravity variables
	roid = 23
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[2] + 14250
	CoordY[roid] = CoordY[2] - 17500
	roidradius[roid] = 515
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(1,7) / 10),(math.random(1,8) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 2
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(20)
	
	
	
	-- Asteroid 24
	-- gravity variables
	roid = 24
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[2] + 7250
	CoordY[roid] = CoordY[2] - 23500
	roidradius[roid] = 750
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(1,7) / 10),(math.random(1,8) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(30)
	
	
	-- Asteroid 25
	-- gravity variables
	roid = 25
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[2] + 23500
	CoordY[roid] = CoordY[2] - 20250
	roidradius[roid] = 1075
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(1,7) / 10),(math.random(1,8) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(30)
	
	
	-- Asteroid 26
	-- gravity variables
	roid = 26
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[2] - 1850
	CoordY[roid] = CoordY[2] - 20750
	roidradius[roid] = 450
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(1,7) / 10),(math.random(1,8) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(30)
	
	
	
	
	
	
	
	
	-- *** FOURTH GALAXY ***
	
	
	
	
	-- Asteroid 27
	-- gravity variables
	roid = 27
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[3] - 4500
	CoordY[roid] = CoordY[3] - 10700
	roidradius[roid] = 875
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	
	
	-- Asteroid 28
	-- gravity variables
	roid = 28
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[3] - 9500
	CoordY[roid] = CoordY[3] - 12250
	roidradius[roid] = 525
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,10) / 10),(math.random(2,10) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	
	
	
	
	-- Asteroid 29
	-- gravity variables
	roid = 29
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[3] - 2500
	CoordY[roid] = CoordY[3] - 16250
	roidradius[roid] = 650
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,8) / 10),(math.random(2,9) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 7
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False


	
	
	-- Asteroid 30
	-- gravity variables
	roid = 30
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[3] - 14250
	CoordY[roid] = CoordY[3] - 17500
	roidradius[roid] = 515
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,8) / 10),(math.random(2,9) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 8
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	
	
	
	-- Asteroid 31
	-- gravity variables
	roid = 31
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[3] - 7250
	CoordY[roid] = CoordY[3] - 23500
	roidradius[roid] = 750
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,8) / 10),(math.random(2,9) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	
	
	
	-- Asteroid 32
	-- gravity variables
	roid = 32
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[3] - 23500
	CoordY[roid] = CoordY[3] - 20250
	roidradius[roid] = 1075
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,8) / 10),(math.random(2,9) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 6
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(20)
	
	
	
	
	-- Asteroid 33
	-- gravity variables
	roid = 33
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.75
	CoordX[roid] = CoordX[3] + 1850
	CoordY[roid] = CoordY[3] - 20750
	roidradius[roid] = 450
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],(math.random(2,8) / 10),(math.random(2,9) / 10),(math.random(3,10) / 10))
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False	
	
	
	
	

	
	
	
	
	
	-- spacer asteroid, used to make sure the level is big enough for asteroids to wander about on long, eliptical orbits.  Change to taste.
	a = AddAsteroidWithAttribs(65000,5000,0.5,0.5,0.5)
	a.Owner = 0
	a.TreeCap = 4
	a:SetRadius(1)
	a.Moveable = False
	a:Hide(2)
	
	
	
	roidnumber = roid
	
	
	-- END ASTEROID CREATION
	
	
	
	-- START AI ENGINE INITIALISATION
	
	rcolour = 0
	
	endfinal = false

	finality = false
	
	dangertimer = {}
	
	purgetimer = 0

	
	
	
	for dset = 0,roidnumber do
		dangertimer[dset] = GetGameTime() - 90
	end
	
	danger = {}
	
	torchlit = {}	
	
	constructionmetric = {}

	
	gathermetric = {}
	
	gatherexists = 0
	
	
	gatherpoint = GetAsteroid(33)
	
	
	
	
	-- END AI ENGINE INITIALISATION
	
	
	timeoff = false

	

end



function LevelLogic()
	

	-- Zoom the camera
	SetCameraZoom(10)
	SetCameraPosition(CoordX[11] * -1,CoordY[11] * -1)
	
	
	-- *** Set the send distances you want for each asteroid here.
	-- *** I know you normally do it in Level Setup but in gravityland we do it here.
	
	GetAsteroid(0).SendDistance = 13800
	GetAsteroid(1).SendDistance = 13800
	GetAsteroid(2).SendDistance = 13800
	GetAsteroid(3).SendDistance = 13800
	GetAsteroid(4).SendDistance = 9500
	GetAsteroid(5).SendDistance = 9500
	
	GetAsteroid(6).SendDistance = 10200
	GetAsteroid(7).SendDistance = 7200
	GetAsteroid(8).SendDistance = 7400
	GetAsteroid(9).SendDistance = 8750
	GetAsteroid(10).SendDistance = 9500
	GetAsteroid(11).SendDistance = 11500
	GetAsteroid(12).SendDistance = 6900
	
	GetAsteroid(13).SendDistance = 10200
	GetAsteroid(14).SendDistance = 7200
	GetAsteroid(15).SendDistance = 7400
	GetAsteroid(16).SendDistance = 8750
	GetAsteroid(17).SendDistance = 9500
	GetAsteroid(18).SendDistance = 11500
	GetAsteroid(19).SendDistance = 6900
	
	GetAsteroid(20).SendDistance = 10200
	GetAsteroid(21).SendDistance = 7200
	GetAsteroid(22).SendDistance = 7400
	GetAsteroid(23).SendDistance = 8750
	GetAsteroid(24).SendDistance = 9500
	GetAsteroid(25).SendDistance = 11500
	GetAsteroid(26).SendDistance = 6900
	
	GetAsteroid(27).SendDistance = 10200
	GetAsteroid(28).SendDistance = 7200
	GetAsteroid(29).SendDistance = 7400
	GetAsteroid(30).SendDistance = 8750
	GetAsteroid(31).SendDistance = 9500
	GetAsteroid(32).SendDistance = 11500
	GetAsteroid(33).SendDistance = 6900
	
	GetAsteroid(34).SendDistance = 200
	
	
	for aisee = 0,33 do
		GetAsteroid(aisee):Reveal(2)
	end
	
	
	-- *** End setting of send distances
	
	flag = 0
	interaction = 0
	won = false
	lost = false
	wintimer = 0
	runonce = false
	colourtimer = 0
	
	while GameRunning() do

		-- *** YOUR LOOPED COMMANDS GO HERE *** --
		
		
		cometdistance = math.sqrt((CoordX[4] * CoordX[4]) + (CoordY[4] * CoordY[4]))
		cometdistance = cometdistance / 10
		cometdistance = cometdistance - 34
		--GetAsteroid(6).CoreHealth = cometdistance
		
		-- GetAsteroid(3).CoreHealth = GetGameTime()
		
		
		
		
		
		if cometdistance < 30 and flag == 0 then
		
			flag = 1
			interaction = interaction + 1
			
			if interaction == 3 then
				-- store the comet variables
				
				sMomentumXa = MomentumX[4]
				sMomentumXb = MomentumX[5]
				sMomentumYa = MomentumY[4]
				sMomentumYb = MomentumY[5]
				
				sAccelerationXa = AccelerationX[4]
				sAccelerationXb = AccelerationX[5]
				sAccelerationYa = AccelerationY[4]
				sAccelerationYb = AccelerationY[5]
				
				sCoordXa = CoordX[4]
				sCoordXb = CoordX[5]
				sCoordYa = CoordY[4]
				sCoordYb = CoordY[5]
				
				
			end
			
			
			
			
			if interaction == 5 and won == false then
				-- replace the existing comet variables on this, interaction 5, with those from interaction 3	
				
				interaction = 3
				
				MomentumX[4] = sMomentumXa
				MomentumX[5] = sMomentumXb
				MomentumY[4] = sMomentumYa
				MomentumY[5] = sMomentumYb
				
				AccelerationX[4] = sAccelerationXa
				AccelerationX[5] = sAccelerationXb
				AccelerationY[4] = sAccelerationYa
				AccelerationY[5] = sAccelerationYb
				
				CoordX[4] = sCoordXa
				CoordX[5] = sCoordXb
				CoordY[4] = sCoordYa
				CoordY[5] = sCoordYb
				
			
			end
			
			
		end
		
		if cometdistance > 30 and flag == 1 then
			flag = 0
		end
		
		--GetAsteroid(1).CoreHealth = interaction
		
		
		-- have we won?
		
		if won == true and cometdistance > 300 and runonce == false then
		
			MessageBox("VICTORY!!  The game will end in 3 minutes.  Enjoy the show...")
		
			runonce = true
			wellonlythreshold = 0
			gravroidsthreshold = roidnumber
			G = 0.015
			density[0] = 4
			MomentumX[0] = -10
			MomentumY[0] = 10
			
			density[1] = 4
			MomentumY[1] = -10
			MomentumX[1] = -10
			
			density[2] = 4
			MomentumY[2] = 10
			MomentumX[2] = 10
			
			
			density[3] = 4
			MomentumX[3] = 10
			MomentumY[3] = -10
			
			density[4] = 7
			density[5] = 7
			
			
			
			for i = 6,33 do
			
				MomentumX[i] = math.random(1,20) - 10
				MomentumY[i] = math.random(1,20) - 10
				
			end
			
			wintimer = GetGameTime() + 180
		
		end
		
		if won == true and wintimer < GetGameTime() then
		
			Quit(true)
		
		end
		
		
		
		if lost == true and runonce == false then
		
			runonce = true
			G = 5 * math.sin(GetGameTime() * 100)
			wintimer = GetGameTime() + 25
			MessageBox("You lose.  :<  Bye bye universe.")
			
			wellonlythreshold = 0
			gravroidsthreshold = roidnumber
			
			density[0] = 4
			MomentumX[0] = -10
			MomentumY[0] = 10
			
			density[1] = 4
			MomentumY[1] = -10
			MomentumX[1] = -10
			
			density[2] = 4
			MomentumY[2] = 10
			MomentumX[2] = 10
			
			
			density[3] = 4
			MomentumX[3] = 10
			MomentumY[3] = -10
			
			density[4] = 7
			density[5] = 7
			
			
			
			for i = 6,33 do
			
				MomentumX[i] = math.random(1,100) - 50
				MomentumY[i] = math.random(1,100) - 50
				
			end
			
			
		end
		
		
		if lost == true and wintimer < GetGameTime() then
		
			Quit(false)
			
		end
		
		
		-- hide any asteroids that have flown off the screen.
		for hidedistant = 0,33 do
			
			if math.sqrt((CoordX[hidedistant] * CoordX[hidedistant]) + (CoordY[hidedistant] * CoordY[hidedistant])) > 80000 then
				GetAsteroid(hidedistant):Hide(1)
				GetAsteroid(hidedistant):SetRadius(0)
				GetAsteroid(hidedistant):RemoveSeedlings(1,GetAsteroid(hidedistant):GetNumSeedlings(1))
				GetAsteroid(hidedistant):RemoveSeedlings(2,GetAsteroid(hidedistant):GetNumSeedlings(2))
			end
		
		end
		
		
		if colourtimer < GetGameTime() then
			colourtimer = GetGameTime() + (5.454545 / 2)
			
			-- who has the most seeds on here?
			if GetAsteroid(4):GetNumSeedlings(1) > 0 or GetAsteroid(4):GetNumSeedlings(2) > 0 then
			
				if GetAsteroid(4):GetNumSeedlings(1) > GetAsteroid(4):GetNumSeedlings(2) then
			
					GetAsteroid(4).Owner = 1
					
				else
					
					GetAsteroid(4).Owner = 2
				
				end
			
			else
			
				GetAsteroid(4).Owner = math.random(3,8)
			
			end
		
			if GetAsteroid(5):GetNumSeedlings(1) > 0 or GetAsteroid(5):GetNumSeedlings(2) > 0 then
			
				if GetAsteroid(5):GetNumSeedlings(1) > GetAsteroid(5):GetNumSeedlings(2) then
			
					GetAsteroid(5).Owner = 1
					
				else
					
					GetAsteroid(5).Owner = 2
				
				end
			
			else
			
				GetAsteroid(5).Owner = math.random(3,8)
			
			end
		
		
		
		end
		
		
		
		
		
		-- give sun 1 to whoever owns all the asteroids...otherwise give it to nobody
		
		sunone = 0
		
		for suncheck = 6,12 do
			
			if GetEmpire(1):OwnsAsteroidID(suncheck) or GetAsteroid(0):GetNumSeedlings(1) > 0 then
				sunone = sunone + 1
			elseif GetEmpire(2):OwnsAsteroidID(suncheck) then
				sunone = sunone + 10
			end
			
		end
		
		if sunone == 7 then
			GetAsteroid(0).Owner = 1
		elseif sunone == 70 then
			GetAsteroid(0).Owner = 2
		else
			GetAsteroid(0).Owner = 0
		end

		
		
		
		
		
		-- give sun 2 to whoever owns all the asteroids...otherwise give it to nobody
		
		sunone = 0
		
		for suncheck = 13,19 do
			
			if GetEmpire(1):OwnsAsteroidID(suncheck) or GetAsteroid(1):GetNumSeedlings(1) > 0 then
				sunone = sunone + 1
			elseif GetEmpire(2):OwnsAsteroidID(suncheck) then
				sunone = sunone + 10
			end
			
		end
		
		if sunone == 7 then
			GetAsteroid(1).Owner = 1
		elseif sunone == 70 then
			GetAsteroid(1).Owner = 2
		else
			GetAsteroid(1).Owner = 0
		end
		
		
		
		-- give sun 3 to whoever owns all the asteroids...otherwise give it to nobody
		
		sunone = 0
		
		for suncheck = 20,26 do
			
			if GetEmpire(1):OwnsAsteroidID(suncheck) or GetAsteroid(2):GetNumSeedlings(1) > 0 then
				sunone = sunone + 1
			elseif GetEmpire(2):OwnsAsteroidID(suncheck) then
				sunone = sunone + 10
			end
			
		end
		
		if sunone == 7 then
			GetAsteroid(2).Owner = 1
		elseif sunone == 70 then
			GetAsteroid(2).Owner = 2
		else
			GetAsteroid(2).Owner = 0
		end	
		
		
		
		
		-- give sun 4 to whoever owns all the asteroids...otherwise give it to nobody
		
		sunone = 0
		
		for suncheck = 27,33 do
			
			if GetEmpire(1):OwnsAsteroidID(suncheck) or GetAsteroid(3):GetNumSeedlings(1) > 0 then
				sunone = sunone + 1
			elseif GetEmpire(2):OwnsAsteroidID(suncheck) then
				sunone = sunone + 10
			end
			
		end
		
		if sunone == 7 then
			GetAsteroid(3).Owner = 1
		elseif sunone == 70 then
			GetAsteroid(3).Owner = 2
		else
			GetAsteroid(3).Owner = 0
		end	
		
		
		
		if GetGameTime() > 300 and timeoff == false then
		
			GetAsteroid(15):AddSeedlings(10,2,0.01,0.01,0.01)
			timeoff = true
			
		end
		
		
		
		
		
		
		
		-- *** YOUR LOOPED COMMANDS END HERE *** ---


		
		
		
		
		
		
		
		
		


		-- *** START INFECTED AI ENGINE *** --

		if GetEmpire(2):GetNumOwnedAsteroids() == 0 then
		

			won = true
		
		end
	
		
		lost = true
		
		for mewh = 4,roidnumber do
		
			if GetEmpire(1):OwnsAsteroidID(mewh) == true then
		
				lost = false
			end

		end
		
		
if won == false and lost == false then		
		if rcolour > 0 then
			rcolour = rcolour - 1
		end
		
		--SetBackdropColour(rcolour,0,0)
	

		
		--AI
	
		checkedroid = GetAI(2):GetRandomAsteroid()
		

	

		
		
		
		if GetGameTime() > purgetimer + 35 then
			purgetimer = 0
		end
		
		
	
		-- First, find out which asteroids are close enough to travel in 1 jump, and 
	
		traversable = {}
		pathsavailable = 0
		
		attackable = {}
		attackpaths = 0

		actiontaken = 0
		
		increasemetricvote = 1
		increasegathermetricvote = 1
		confirmedzero = 0
		confirmedgatherpoint = 0

		
		gathermetric[4] = 99
		gathermetric[5] = 99
		

		if GetEmpire(2):OwnsAsteroidID(checkedroid.ID) then
		
			-- MINE CHECK NOT REQUIRED IN THIS MAP
		
			--if checkedroid:GetNumSeedlings(1) == 0 and checkedroid:GetNumSeedlings(2) > 5 then
			--	for minecheck = 0,roidnumber do
				
			--		if GetEmpire(2):OwnsAsteroidID(minecheck) == true and GetAsteroid(minecheck):GetNumMines(1) > 0 and checkedroid:GetNumMines(1) == 0 then
			--			checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),GetAsteroid(minecheck))
			--		end
				
			--	end
		
			--end
		
			for u = 4,roidnumber do

				if GetAsteroid(u) ~= checkedroid then
					-- only learn about this asteroid if it's not the one being checked
					-- can we send seeds to this roid from the checked one?

					if (GetAsteroid(checkedroid.ID):GetSendDistance() + roidradius[u]) > math.sqrt(((CoordX[u] - CoordX[checkedroid.ID])^2) + ((CoordY[u] - CoordY[checkedroid.ID])^2)) then
						-- we can !  Now is this a friendly path or an attackable path?
						if GetEmpire(2):OwnsAsteroidID(u) == false then
							
							if u == 4 or u == 5 then
								
								traversable[pathsavailable] = GetAsteroid(u)
								pathsavailable = pathsavailable + 1
								gathermetric[u] = 99
								--gathermetric[checkedroid.ID] = 100
								
								
							else
								
								attackable[attackpaths] = GetAsteroid(u)
								attackpaths = attackpaths + 1
							
								-- moar aggression ! advantage pressing, etc
								if checkedroid:GetNumSeedlings(2) > 120 and GetAsteroid(u):GetNumSeedlings(1) < (checkedroid:GetNumSeedlings(2) / 2) and checkedroid:GetNumSeedlings(1) < 10 then
									checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),GetAsteroid(u))
									if rcolour < 105 then
										rcolour = rcolour + 150
									end
									
									
								end
							
							end
							
						elseif GetAI(2):OwnsAsteroidID(u) == true then

							traversable[pathsavailable] = GetAsteroid(u)
							pathsavailable = pathsavailable + 1
						else

						end
				
					end

					-- ok, this roid is not in range for us.



			
			
			
				end
				-- ok, we were trying to check ourselves.

			
	
	
	
			end
			-- end of neighbour-checking sequence

	
			
		
		

		
		
		
			-- end of metric checking sequence
	
		else
	
			torchlit[checkedroid.ID] = nil
			constructionmetric[checkedroid.ID] = nil
			
			if checkedroid.ID ~= 4 or checkedroid.ID ~= 5 then
				gathermetric[checkedroid.ID] = nil
			end
	
		end
	
	
	
	
	
	
	
	
	
	
	
	
	
		-- we have selected "checkedroid" for checking.  We must find out all we can about the asteroid and it's surroundings, and act appropriately.
		if GetAI(2):OwnsAsteroidID(checkedroid.ID) == true and checkedroid:GetNumMines(1) > 0 then
		
			-- do buggerysquat.
		

		elseif GetAI(2):OwnsAsteroidID(checkedroid.ID) == true then
			-- this roid is ours ! :>
			
			
			
			
--			if pathsavailable == 0 then
				-- Orphan Control
--				boltfriendly = GetEmpire(2):GetRandomAsteroid()
--				letsgo = 0
				
--				for iii = 0,attackpaths do
					
--					if attackable[iii] ~= nil then
--						letsgo = letsgo + (attackable[iii]:GetNumSeedlings(1))
--					end
				
--				end
				
--				if letsgo > checkedroid:GetNumSeedlings(2) and checkedroid:GetNumSeedlings(2) > 10 and checkedroid:GetNumSeedlings(2) < 39 then
				
--					checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),boltfriendly)
					
					
--				elseif letsgo < checkedroid:GetNumSeedlings(2) and checkedroid:GetNumSeedlings(2) > (39 + (attackable[0]:GetNumDysonTrees() * 5) + (attackable[0]:GetNumDefenseTrees() * 15)) then
				
--					checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),attackable[0])
--					if rcolour < 105 then
--						rcolour = rcolour + 150
--					end

				
--				elseif attackable[0]:GetNumSeedlings(2) > 5 then
				
--					checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),attackable[0])
	
					
--				end
				
				
--			end
			-- how many player seedlings are here?

			-- more than what we have, and enough to be dangerous.  Also, we do have at least 1 tree here, right?
			if checkedroid:GetNumSeedlings(2) < checkedroid:GetNumSeedlings(1) and checkedroid:GetNumSeedlings(1) > 10 and checkedroid:GetNumTrees() > 0 then
				-- *** WE OWN THIS ASTEROID, THE ENEMY OUTNUMBER US.  WE HAVE AT LEAST ONE TREE HERE.  We are under attack.  torchmetric 0! ***
				torchlit[checkedroid.ID] = 0
				-- ***
			
		--	elseif checkedroid:GetNumSeedlings(2) < checkedroid:GetNumSeedlings(1) and checkedroid:GetNumSeedlings(1) > 10 and checkedroid:GetNumTrees() == 0 then
				-- *** ITS A FALSE ALARM....but dont try to build here unless the player leaves. ***
				--torchlit[checkedroid.ID] = nil
				--constructionmetric[checkedroid.ID] = nil				
				-- but once we get a bit more powerful, we can have a crack at it :>
				
				
			--		if purgetimer == 0 then
			--			purgetimer = GetGameTime() + 30
			--		end
					
			--		if GetGameTime() > purgetimer then
						
						
			--			torchlit[checkedroid.ID] = 0
						
						--for purge = 0,roidnumber do
						--	if GetEmpire(2):OwnsAsteroidID(purge) == true and torchlit[purge] == nil and GetGameTime() > purgetimer + 45 then
						
						--GetAsteroid(purge):SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(1),checkedroid)
						
						
						--	if rcolour < 105 then
						--			rcolour = rcolour + 150
						--			end
						--	end
						
						--	end
						
			--			purgetimer = 0
						
			--		end
				
				-- ***
			
	
			
			--  more than zero but less than what we have
			elseif checkedroid:GetNumSeedlings(1) > 0 and checkedroid:GetNumSeedlings(2) > checkedroid:GetNumSeedlings(1) then
				-- *** WE OWN THIS ASTEROID, THERE ARE ENEMIES BUT WE OUTNUMBER THEM.  Not elligible for sending reinforcements to other asteroids, but not in serious danger either. ***
				-- ***
			
			
			-- No enemies here at all.
			elseif checkedroid:GetNumSeedlings(1) < 1 then
			
				-- how many of our seedlings are here?
				if checkedroid:GetNumSeedlings(2) > 1 then
					-- 1 or more
		
		
					--how many trees are here?
					if checkedroid:GetNumTrees() < checkedroid.TreeCap and checkedroid:GetNumSeedlings(2) > 9 then
						-- less than four trees
						-- *** WE OWN THIS ASTEROID, THERE ARE NO ENEMIES HERE.  WE HAVE AT LEAST 10 SEEDLINGS AND LESS THAN 4 TREES.  Plant a tree. ***
						
						
						-- but... is the enemy building up a force nearby, ready to take our freshly built trees..?
						
						danger[checkedroid.ID] = false
						
						for ooo = 0,roidnumber do
							if GetEmpire(1):OwnsAsteroidID(ooo) and GetAsteroid(ooo):GetSendDistance() > math.sqrt(((CoordX[ooo] - CoordX[checkedroid.ID])^2) + ((CoordY[ooo] - CoordY[checkedroid.ID])^2)) then
						
								if GetAsteroid(ooo):GetNumSeedlings(1) > 35 then
								
									danger[checkedroid.ID] = true
									dangertimer[checkedroid.ID] = GetGameTime()
								
								end
							
							end
						end
						
						if danger[checkedroid.ID] == true and checkedroid:GetNumSeedlings(2) > 15 then
							
							checkedroid:PlantDysonTree(2)
						
						elseif danger[checkedroid.ID] == false and GetGameTime() > dangertimer[checkedroid.ID] + 30 then
						
							checkedroid:PlantDysonTree(2)
							
						end
						-- ***
					
					
					
					elseif checkedroid:GetNumTrees() == checkedroid.TreeCap then
						-- max trees.  ELLIGIBLE FOR SENDING REINFORCEMENTS!
						
						if constructionmetric[checkedroid.ID] == 0 then
							-- we just built the last tree.  now we should stop advertising to neighbours that we need more seedlings for construction.
							constructionmetric[checkedroid.ID] = nil
						end
						
						
						-- is my torch metric nil?
						
						if torchlit[checkedroid.ID] ~= nil then
							-- no, my torch metric is not Nil.
							
							-- is my torch metric 0?  Cause, like, I don't have any enemies orbiting me dudez...
							if torchlit[checkedroid.ID] == 0 then
								-- *** ok, so my torch metric is 0 but there are no enemies here.  Switch all torches off....if other roids are under attack they will just switch theirs on again straight away. ***
								-- *** this step is needed to prevent the rest of the torch metrics from spiralling upward out of control.  ***
								for g = 0,roidnumber do
									torchlit[g] = nil
								end									
								-- ***
							else
							
								-- so my torch IS lit, but it's value is NOT zero.  checkedroid is not nil and not 0.
							
								totm = true
							
								for ooo = 0,pathsavailable do
								
									if traversable[ooo] ~= nil then
								
										trav = traversable[ooo]
								
										hopIDint = trav.ID
									
										if torchlit[hopIDint] == 0 and GetGameTime() < 180 then
											
											for emerg = 0,roidnumber do
												if GetEmpire(2):OwnsAsteroidID(emerg) == true then
													GetAsteroid(emerg):SendSeedlingsToTarget(2,GetAsteroid(emerg):GetNumSeedlings(2),traversable[ooo])
												end
											end
										
											totm = false
									
									
										elseif torchlit[hopIDint] == 0 then
											-- *** WE HAVE FOUND A NEIGHBOUR THAT HAS A ROUTE TO AN ASTEROID IN NEED OF DEFENCE.  Send seedlings ***
											
											if GetAsteroid(hopIDint):GetNumSeedlings(1) < 10 then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
												
											elseif GetAsteroid(hopIDint):GetNumSeedlings(2) > GetAsteroid(hopIDint):GetNumSeedlings(1) * 0.6 then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
											
											
											elseif checkedroid:GetNumSeedlings(2) > (GetEmpire(2).NumSeedlings / 20) then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
											end
											
											totm = false
											torchlit[checkedroid.ID] = 1
									
											--				elseif torchlit[checkedroid.ID] == nil then
											
											--					totm = false
											--					torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
											--					shortestpath = hopIDint
											
											
										elseif torchlit[hopIDint] == nil then
										
											-- do nothing, maybe there's no more attack and the metric should be turned off.
											
											
											
											-- my torch metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
										elseif torchlit[hopIDint] < torchlit[checkedroid.ID] - 1 then
											totm = false
											torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
											shortestpath = hopIDint
											checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
											
											
										elseif torchlit[hopIDint] == torchlit[checkedroid.ID] - 1 then
										
											totm = false
											torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
											shortestpath = hopIDint
											checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
										
											
									
										end
							
									end
								end
							
							
							
							
							
							
							
								-- *** WE OWN THIS ASTEROID.  THERE ARE NO ENEMIES HERE.  WE HAVE AT LEAST 10 SEEDLINGS AND MAXIMUM TREES.  OUR TORCH METRIC INDICATES ***
								-- *** THAT A NEARBY ASTEROID REQUIRES SEEDLINGS FOR DEFENSE.  Find a neighbour with the lower metric and send 10 seedlings there.  ***
							

							
							end
							
							
						
						elseif torchlit[checkedroid.ID] == nil then
						
							-- yes my torch metric is nil, now lets see if any neighbours have a torch metric of 0..
							
							totm = true
							
							
							
							for ooo = 0,pathsavailable do
								
								if traversable[ooo] ~= nil then
								
									trav = traversable[ooo]
								
									hopIDint = trav.ID
									
									
							
									if torchlit[hopIDint] == 0 then
										-- *** WE HAVE FOUND A NEIGHBOUR THAT NEEDS MORE SEEDS TO DEFEND WITH.  Send 10 seedlings, or more if we have them available. ***
										checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[ooo])
										totm = false
										torchlit[checkedroid.ID] = 1
										
										
									
									elseif torchlit[hopIDint] ~= nil then
										if torchlit[hopIDint] > 0 then
											-- seedlings needed in this direction!
											
											-- my torch metric is nil at the moment, so set it to his + 1.
											if torchlit[checkedroid.ID] == nil then
												totm = false
												torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											-- my torch metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
											if torchlit[hopIDint] < torchlit[checkedroid.ID] - 1 then
												totm = false
												torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											
										
										end
										
									
									
									end
							
								end
							end

							-- send seeds along the shortest torch path
							if torchlit[checkedroid.ID] ~= nil then
								if torchlit[checkedroid.ID] > 1 then
								
									checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),GetAsteroid(shortestpath))
								end
							end
							
							if totm == true and torchlit[checkedroid.ID] ~= nil then
								torchlit[checkedroid.ID] = nil
							end
						
						
							-- check if we are still under attack on any asteroids
							stillattacked = false
							
							for o = 0,roidnumber do
								if GetAsteroid(o):GetNumTrees() > 0 and GetAI(2):OwnsAsteroidID(o) and GetAsteroid(o):GetNumSeedlings(1) > 1 then
									stillattacked = true
								end
							end
							
							if stillattacked == false then
								for l = 0,roidnumber do
									torchlit[l] = nil
								end
							end
							
							
							
							-- yes, my torch metric is Nil and so is all my neighbours' - check my construction metric next.
						
							-- turn off construction metric
							tocm = true
							
							for cc = 0,pathsavailable do
								
								if traversable[cc] ~= nil then
								
									trav = traversable[cc]
								
									hopIDint = trav.ID
							
									if constructionmetric[hopIDint] == 0 and GetAsteroid(hopIDint):GetNumSeedlings(1) < 8 then
										-- *** WE HAVE FOUND A NEIGHBOUR THAT NEEDS MORE SEEDS TO BUILD WITH.  Send 10 seedlings, or more if we have them available. ***
										checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[cc])
										tocm = false
										constructionmetric[checkedroid.ID] = 1
									
									
									elseif danger[checkedroid.ID] == true or GetGameTime() < (dangertimer[checkedroid.ID] + 90) then
									
										-- *** WAIT A BIT... THERE'S STILL A BIG FORCE NEARBY ***
										
										tocm = false
										constructionmetric[checkedroid.ID] = 1
									
									
									
									
									elseif constructionmetric[hopIDint] ~= nil then
										if constructionmetric[hopIDint] > 0 then
											-- seedlings needed in this direction!
											
											-- my construction metric is nil at the moment, so set it to his + 1.
											if constructionmetric[checkedroid.ID] == nil then
												tocm = false
												constructionmetric[checkedroid.ID] = constructionmetric[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											-- my construction metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
											if constructionmetric[hopIDint] < constructionmetric[checkedroid.ID] - 1 then
												tocm = false
												constructionmetric[checkedroid.ID] = constructionmetric[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											
										
										end
										
									
									
									end
							
								end
							end
						
							-- send seeds along the shortest construction path
							if constructionmetric[checkedroid.ID] ~= nil then
								if constructionmetric[checkedroid.ID] > 1 then
								
									checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),GetAsteroid(shortestpath))
								end
							end
							
							if tocm == true and constructionmetric[checkedroid.ID] ~= nil then
								constructionmetric[checkedroid.ID] = nil
							end
						
						
							-- check if we are finished building trees on all asteroids
							stillbuilding = false
							
							for o = 0,roidnumber do
								if GetAsteroid(o):GetNumTrees() < GetAsteroid(o).TreeCap and GetAI(2):OwnsAsteroidID(o) then
									stillbuilding = true
								end
							end
							
							if stillbuilding == false then
								for l = 0,roidnumber do
									constructionmetric[l] = nil
								end
							end
						
							
						end
						
						-- ok, we didn't hit on torch metric or construction metric.  So lets do some gathering instead.
						
						if torchlit[checkedroid.ID] == nil and constructionmetric[checkedroid.ID] == nil and GetGameTime() > 6 then
							-- is there already a gather point?
							-- gatherexists = 0
							gathertrue = false
							for h = 0,roidnumber do
								if gathermetric[h] == 0 then
									gatherexists = 1
									gathertrue = true
								end
							end
							
							if gathertrue == false then
								gatherexists = 0
							end
							
							
							-- there's no gather point at the moment.
							if gatherexists == 0 then
							
							
								-- ok, is there at least one player-owned asteroid and one traversable asteroid within my send distance?
								if pathsavailable > 0 and attackpaths > 0 then
									-- yep.
									-- *** THEN I'M THE NEW GATHER POINT!! Bringin all the seedlings to the yard, y0. ***
									gathermetric[checkedroid.ID] = 0
									gatherexists = 1
									
								--	MessageBox("new gather point")
									--MessageBox(checkedroid.ID)
									
								
								else
									-- nope.
							


									-- *** I CAN'T BE THE GATHER POINT because I am totally surrounded by either all friendly neighbours or all enemy asteroids. ***
								
								end
							
							
							
								if gathermetric[checkedroid.ID] ~= nil then
									-- no, my gather metric is not Nil.
									-- so my torch IS lit, but it's value is NOT zero.
						
									for ddd = 0,pathsavailable do
							
										if traversable[ddd] ~= nil then
							
											trav = traversable[ddd]
						
											hopIDint = trav.ID
						
											if gathermetric[hopIDint] == 0 then
												-- *** WE HAVE FOUND A NEIGHBOUR THAT HAS A ROUTE TO AN ASTEROID IN NEED OF SEEDS.  Send 10 seedlings, or more if we have them available. ***
												checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[ddd])
									
												gathermetric[checkedroid.ID] = 1
								
												electiontimer = GetGameTime()
							
							
							
											elseif gathermetric[hopIDint] ~= nil then
												if gathermetric[hopIDint] > 0 then
													-- both checkedroid and the neighbour we are looking at have a gather metric set.  Also, the neighbour has a metric of at least 1.
													-- seedlings needed in this direction!
											
										
													-- my gather metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
													if gathermetric[hopIDint] < gathermetric[checkedroid.ID] - 1 then
											
														gathermetric[checkedroid.ID] = gathermetric[hopIDint] + 1
														shortestpath = hopIDint


													elseif gathermetric[hopIDint] == gathermetric[checkedroid.ID] - 1 then
													
														if shortestpath == nil then
															shortestpath = hopIDint
														end
													
														if gathermetric[shortestpath] ~= nil then
															if gathermetric[hopIDint] < gathermetric[shortestpath] then
																shortestpath = hopIDint
															end
														end
													
													end
										
													
										
										
										
									
												end
									
								
								
											end
						
										end
									
									
									end

									if gathermetric[checkedroid.ID] ~= nil and gathermetric[shortestpath] ~= nil then

										if gathermetric[shortestpath] < gathermetric[checkedroid.ID] then
									
											checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),GetAsteroid(shortestpath))
	
										end

									end
											
						
									-- *** WE OWN THIS ASTEROID.  THERE ARE NO ENEMIES HERE.  WE HAVE AT LEAST 10 SEEDLINGS AND MAXIMUM TREES.  OUR TORCH METRIC INDICATES ***
									-- *** THAT A NEARBY ASTEROID REQUIRES SEEDLINGS FOR DEFENSE.  Find a neighbour with the lower metric and send 10 seedlings there.  ***
					
								elseif gathermetric[checkedroid.ID] == nil then
					
									-- yes my gather metric is nil, now lets see if any neighbours have a gather metric of 0..
						
						
						
									for ddd = 0,pathsavailable do
							
										if traversable[ddd] ~= nil then
							
											trav = traversable[ddd]
							
											hopIDint = trav.ID
						
											if gathermetric[hopIDint] == 0 then
												-- *** WE HAVE FOUND A NEIGHBOUR THAT IS A GATHER POINT.  Send 10 seedlings, or more if we have them available. ***
												checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[ddd])
						
												gathermetric[checkedroid.ID] = 1
								
											elseif gathermetric[hopIDint] ~= nil then
												if gathermetric[hopIDint] > 0 then
													-- seedlings needed in this direction!
										
													-- my gather metric is nil at the moment, so set it to his + 1.
												
													if shortestpath == nil then
														shortestpath = hopIDint
													end
													
													gathermetric[checkedroid.ID] = gathermetric[hopIDint] + 1
											
									
												end
									
								
								
											end
						
										end
									end

								
						
								end
							
							
							
								-- a gather point already exists.
							else
							
							
							
							
								
								-- Am I the gather point?
								
								if gathermetric[checkedroid.ID] == 0 then
									-- I AM the gather point! :>
									
									-- is there still at least 1 player asteroid and 1 friendly asteroid nearby?
									--validpath = 0
									--validattack = 0
									--for i = 0,pathsavailable do
									--	if traversable[i] ~= nil then
									--		travv = traversable[i]
									--		travvy = travv.ID
									
									--		if GetAI(2):OwnsAsteroidID(travvy) == true then
									-- there's at least one friendly asteroid nearby.
									--			validpath = 1
									--		end
									
									--		if GetAI(2):OwnsAsteroidID(travvy) == false then
									-- there's at least one player asteroid nearby.
									--			validattack = 1
									--		end
									--	end
									--end
									
									if attackpaths > 0 and pathsavailable > 0 then
										-- yes, there's at least 1 friendly and 1 enemy asteroid nearby.
										
										
										-- add up all the player seedlings in the nearby enemy systems.  Do I have at least that, plus 50?
										
										totalseeds = 50
										currentlowest = 9000
										attackpaths = attackpaths - 1
										for j = 0,attackpaths do
										
											totalseeds = totalseeds + attackable[j]:GetNumSeedlings(1)
											
											-- this bit checks which of the asteroids has the lowest number of seedlings.
											if attackable[j]:GetNumSeedlings(1) < currentlowest then
												currentlowest = attackable[j]:GetNumSeedlings(1)
												RAPETARGET = attackable[j]
											end
										

										
										end
										

										
										-- "if i have more seeds than the enemy does, then..."
										if checkedroid:GetNumSeedlings(2) > totalseeds + (RAPETARGET:GetNumDysonTrees() * 5) + (RAPETARGET:GetNumDefenseTrees() * 23) then
										
											if checkedroid:GetNumSeedlings(1) < 15 then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),RAPETARGET)
											
												if rcolour < 105 then
													rcolour = rcolour + 150
												end
											end

								
											--MessageBox("Rape time!")
											-- *** RAEP TIEM!!!"!"
										
										elseif checkedroid:GetNumSeedlings(2) > 1000 and checkedroid:GetNumSeedlings(1) == 0 then
											-- if i have silly numbers of seeds, just gogo anyway.
										
											if checkedroid:GetNumSeedlings(1) < 15 then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),RAPETARGET)
											
												if rcolour < 105 then
													rcolour = rcolour + 150
												end
											end
										
										else
											-- *** Hold, precious... we have not enough seeds yet to launch an attack... ***
											
											
											
											
											
											
											-- ***
										end

										-- this bit checks if we have a "Cold War" situation on our hands - if so, we'd be better off moving to a different gather point with less player defenses nearby.
										--				if totalseeds > 300 and totalseeds > checkedroid:GetNumSeedlings(2) and GetEmpire(1):GetNumOwnedAsteroids() > attackpaths + 1 then
										--					MessageBox("ColdWar Detected - reset gather point")
										--					for gathreset = 0,roidnumber do
										--						gathermetric[gathreset] = nil
										--					end
										--				gatherexists = 0
										--				end
										
									else
										-- *** I AM NO LONGER A SUITABLE GATHER POINT.  RESET ALL GATHER POINTS
										for r = 6,roidnumber do
											gathermetric[r] = nil
											
										end
										gatherexists = 0
										-- ***
									
									end
								
								else 
									-- I am not the gather point. :<
									-- so send some seedlings to whichever traversable asteroid has the lowest gather metric.
								
									-- ADD SOEM CODE HERE DRUIDS
									
									
								
									if gathermetric[checkedroid.ID] ~= nil then
										-- no, my gather metric is not Nil.
										-- so my torch IS lit, but it's value is NOT zero.
							
										for ddd = 0,pathsavailable do
								
											if traversable[ddd] ~= nil then
								
												trav = traversable[ddd]
							
												hopIDint = trav.ID
							
												if gathermetric[hopIDint] == 0 then
													-- *** WE HAVE FOUND A NEIGHBOUR THAT HAS A ROUTE TO AN ASTEROID IN NEED OF SEEDS.  Send 10 seedlings, or more if we have them available. ***
													checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[ddd])
										
													gathermetric[checkedroid.ID] = 1
									
													electiontimer = GetGameTime()
								
								
								
												elseif gathermetric[hopIDint] ~= nil then
													if gathermetric[hopIDint] > 0 then
														-- both checkedroid and the neighbour we are looking at have a gather metric set.  Also, the neighbour has a metric of at least 1.
														-- seedlings needed in this direction!
												
											
														-- my gather metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
														if gathermetric[hopIDint] < gathermetric[checkedroid.ID] - 1 then
												
															gathermetric[checkedroid.ID] = gathermetric[hopIDint] + 1
															shortestpath = hopIDint
															checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[ddd])

														elseif gathermetric[hopIDint] == gathermetric[checkedroid.ID] - 1 then
														
															if shortestpath == nil then
																shortestpath = hopIDint
															end
														
															if gathermetric[shortestpath] ~= nil then
																if gathermetric[hopIDint] < gathermetric[shortestpath] then
																	shortestpath = hopIDint
																end
															end
															
															checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[ddd])
															
														end
											
														
											
											
											
										
													end
										
									
									
												end
							
											end
										
										
										end
										
										checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),GetAsteroid(shortestpath))
							
							
										-- *** WE OWN THIS ASTEROID.  THERE ARE NO ENEMIES HERE.  WE HAVE AT LEAST 10 SEEDLINGS AND MAXIMUM TREES.  OUR TORCH METRIC INDICATES ***
										-- *** THAT A NEARBY ASTEROID REQUIRES SEEDLINGS FOR DEFENSE.  Find a neighbour with the lower metric and send 10 seedlings there.  ***
						
									elseif gathermetric[checkedroid.ID] == nil then
						
										-- yes my gather metric is nil, now lets see if any neighbours have a gather metric of 0..
							
							
							
										for ddd = 0,pathsavailable do
								
											if traversable[ddd] ~= nil then
								
												trav = traversable[ddd]
								
												hopIDint = trav.ID
							
												if gathermetric[hopIDint] == 0 then
													-- *** WE HAVE FOUND A NEIGHBOUR THAT IS A GATHER POINT.  Send 10 seedlings, or more if we have them available. ***
													checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[ddd])
							
													gathermetric[checkedroid.ID] = 1
									
												elseif gathermetric[hopIDint] ~= nil then
													if gathermetric[hopIDint] > 0 then
														-- seedlings needed in this direction!
											
														-- my gather metric is nil at the moment, so set it to his + 1.
													
														if shortestpath == nil then
															shortestpath = hopIDint
														end
														
														gathermetric[checkedroid.ID] = gathermetric[hopIDint] + 1
												
										
													end
										
									
									
												end
							
											end
										end

									
							
									end
								
								
								
								
								end
							
							end
							
							
						end

					end
				
				end
				
				
				
				
				
				-- how many of our seedlings are here?
				if checkedroid:GetNumSeedlings(2) < 10 then
					-- 9 or less
					
					-- how many trees are here?
					if checkedroid:GetNumTrees() < checkedroid.TreeCap then
						-- less than four trees
						
						-- *** WE OWN THIS ASTEROID, THERE ARE NO ENEMIES HERE.  WE HAVE LESS THAN 10 SEEDLINGS AND LESS THAN 4 TREES.  We need seedlings for more trees!  Advertise to neighbours that we need some.
						constructionmetric[checkedroid.ID] = 0
						
						-- ***
					end	
					
					
					
				end
			
			
			
			
			
			
			end
			
			

		
	
	
	
		else
			-- *** THIS ROID IS NOT OURS, it's a PLAYER asteroid!!  Do nothing with it.  :> ***
	
			-- ***
		end
	
		if GetEmpire(1):GetNumOwnedAsteroids() < 4 and GetEmpire(2).NumSeedlings > 800 and finality == false then
			finality = true
			for doom = 0,roidnumber do
				if GetEmpire(2):OwnsAsteroidID(doom) then
					GetAsteroid(doom):SendSeedlingsToTarget(2,GetAsteroid(doom):GetNumSeedlings(2),GetEmpire(1):GetRandomAsteroid())
				end
			end
		end
		
	
	
		if electiontimer ~= nil then
			if GetGameTime() > electiontimer + 45 then
				-- we haven't managed to send any seedlings to a gather point for 45 seconds now.  Lets try resetting all the gather metrics to trigger a new gather point election.
				for greset = 6,roidnumber do
					gathermetric[greset] = nil
					
				end
				--MessageBox("Due to low activity a new gather point election was held")
				-- lets see if this helps, and seeds now start moving towards the gather point.  if it doesn't, hold a new gather point election in 15 seconds.
				electiontimer = electiontimer + 45
				gatherexists = 0
				
			end
	
		end
		
		
		gatherzero = false
		
		for gatherzerocheck = 0,roidnumber do
			if gathermetric[gatherzerocheck] == 0 then
				gatherzero = true
			end
		end
		
		
		if gatherzero == false then
			gatherexists = 0
		end
		
		
		
		if GetEmpire(2).NumSeedlings > 8000 and GetEmpire(2):GetNumOwnedAsteroids() > roidnumber / 2 and endfinal == false then
			endfinal = true
			for final = 0,roidnumber do
			
				if GetEmpire(2):OwnsAsteroidID(final) then
				
					GetAsteroid(final):SendSeedlingsToTarget(2,GetAsteroid(final):GetNumSeedlings(2),GetEmpire(1):GetRandomAsteroid())
			
				end
			end
		end
		
end		
		
		if GetAsteroid(4).Owner ~= 2 then
			torchlit[4] = nil
			constructionmetric[4] = nil
		end
		
		if GetAsteroid(5).Owner ~= 2 then
			torchlit[5] = nil
			constructionmetric[5] = nil
		end
		
		
		
		-- *** END INFECTED AI ENGINE *** --


		
		
		
		
		
		
	
		-- START GRAVITY ENGINE
		-- change things below this line at your own peril!!
		-- Rate Limiter - necessary to pause gravity simulation if the game is paused.
		if GetGameTime() > Timer + 0.02 then
			Timer = GetGameTime()
			-- Get values for the the array
			for i = 0, gravroidsthreshold do
				for j = i + 1, gravroidsthreshold do
					-- calculate Fgx and Fgy between i and j, then...
					Fgx = (G * ((roidradius[i] * roidradius[i]) * math.pi * density[i]) * ((roidradius[j] * roidradius[j]) * math.pi * density[j])) / ((CoordX[j] - CoordX[i])^2 + (CoordY[j] - CoordY[i])^2)
					Fgy = (G * ((roidradius[i] * roidradius[i]) * math.pi * density[i]) * ((roidradius[j] * roidradius[j]) * math.pi * density[j])) / ((CoordX[j] - CoordX[i])^2 + (CoordY[j] - CoordY[i])^2)
					-- now we have the force of gravity x and y, as a scalar.  we must find the direction to point in:
					xdiff = CoordX[j] - CoordX[i]
					ydiff = CoordY[j] - CoordY[i]
					-- find the length of the vector..
					vectorlength = math.sqrt(xdiff^2 + ydiff^2)
					-- divide the vectors by the length to normalise
					NormalisedVectorX = xdiff / vectorlength
					NormalisedVectorY = ydiff / vectorlength
					-- these normalised vectors are values between 0 and 1 that give us a direction :>
					-- a^2 = b^2 + c^2.... i know b^2 and c^2...  SHIT im only getting the acceleration as a scalar :S  i need it as coordinates !  + or - ...
					-- ..add the appropriate amount of acceleration
					AccelerationX[i] = AccelerationX[i] + (NormalisedVectorX * Fgx / ((roidradius[i] * roidradius[i]) * math.pi) * density[i])
					AccelerationY[i] = AccelerationY[i] + (NormalisedVectorY * Fgy / ((roidradius[i] * roidradius[i]) * math.pi) * density[i])
					xdiff = CoordX[i] - CoordX[j]
					ydiff = CoordY[i] - CoordY[j]
					NormalisedVectorX = xdiff / vectorlength
					NormalisedVectorY = ydiff / vectorlength
					AccelerationX[j] = AccelerationX[j] + (NormalisedVectorX * Fgx / ((roidradius[j] * roidradius[j]) * math.pi) * density[j])
					AccelerationY[j] = AccelerationY[j] + (NormalisedVectorY * Fgy / ((roidradius[j] * roidradius[j]) * math.pi) * density[j])
				end
			end
			for pass = wellonlythreshold,gravroidsthreshold do
				MomentumX[pass] = MomentumX[pass] + AccelerationX[pass]
				MomentumY[pass] = MomentumY[pass] + AccelerationY[pass]
				-- MOVE GETASTEROID(PASS) by MomentumX and MomentumY
				CoordX[pass] = CoordX[pass] + MomentumX[pass]
				CoordY[pass] = CoordY[pass] + MomentumY[pass]
				GetAsteroid(pass):MoveTo(CoordX[pass], CoordY[pass])
				AccelerationX[pass] = 0
				AccelerationY[pass] = 0
			end
		end
		-- END GRAVITY ENGINE


		
		
		
		
		
		coroutine.yield()
	end

end