function LevelSetup()


	SetBackdropColour(0,0,0)

	Globals.Agents.MaxSpeed=600
	Globals.Agents.MinSpeed=130

	Globals.Asteroids.MaxTrees=3
	Globals.Asteroids.MinRadius=125
    Globals.Asteroids.MaxRadius=725
    Globals.Asteroids.RadiusPowerRule=1.5
	Globals.Asteroids.SizeFromEnergy=210
	Globals.Asteroids.SizeFromStrength=210
	Globals.Asteroids.SizeFromSpeed=210
	Globals.Asteroids.MinCoreHealth=400
	Globals.Asteroids.MaxCoreHealth=1000
	Globals.Asteroids.CoreHealthPower=3.5
    Globals.Asteroids.MinSendDistance=3500
    Globals.Asteroids.MaxSendDistance=6000
    Globals.Asteroids.SendPowerRule=1.4
	Globals.Asteroids.SpawnCap=150
	Globals.Asteroids.SeedlingCap=500

	Globals.AI.MinAttackTime=(5)
	Globals.AI.MaxAttackTime=(20)
	Globals.AI.MinGatherTime=(10)
	Globals.AI.MaxGatherTime=(20)
	Globals.AI.MinScoutTime=(1)
	Globals.AI.MaxScoutTime=(5)
	Globals.AI.GraceTimer=(1)


	Globals.G.EnemyFactionsMin=(4)
	Globals.G.EnemyFactionsMax=(4)
	Globals.G.MinAsteroidSeparation=100
	Globals.G.MaxAsteroidNeighbourDist=5500
	Globals.G.StartingSeedlings=(50)
	Globals.G.GreysProbability=0

	Globals.Structures.FlowerProbability=(0.3)

	-- Asteroid 0
	-- This is the player asteroid
	a = AddAsteroidWithAttribs(0,0, 0.7,0.5,0.8)
	a.Owner = 1
	a.TreeCap = 4
	a.SpawnCap = 1000
	a.SeedlingCap = 1000
	a:SetRadius(800)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	a:AddSeedlings(25)
	a.SendDistance = 3500
	a.Moveable = false

	
	-- Asteroid 1
	-- This is the badass asteroid
	a = AddAsteroidWithAttribs(6500,6500, 0.9,0.9,0.9)
	a.Owner = 2
	a.TreeCap = 10
	a.SpawnCap = 1000
	a.SeedlingCap = 1000
	a:SetRadius(1200)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	a:AddSeedlings(60)
	a.SendDistance = 6500
	a.Moveable = false
	
	

	--Asteroid rings
	AddAsteroidRing(15, 0, 0, 5500, 2000)
	AddAsteroidRing(10, 0, 0, 3250, 2000)

	SetCameraPositionToAsteroidID(0)
	SetCameraZoomNow(9)

	end

function OnAsteroidTaken(id, owner)
	if id == 1 and owner == 1 then
		GameWon = 1
	elseif id == 0 and owner ~= 1 then
		GameWon = 0
	end
end

function LevelLogic()

	Pause()
	MessageBox("Protect Fluffy Land from teh aggressors!  If you lose your home asteroid the game is over.")
	WaitDialog()
	Unpause()


	--AI
	GetAI(2).Cowardice = 0.2
	GetAI(2).MinExpansionForce = 10
	GetAI(2).BattleSavvy = 0.1
	GetAI(2).ReinforcementGreed = 0.9
	GetAI(2).GreedyExpansion = 0.9
	GetAI(2).AidEnthusiasm = 0.9
	GetAI(2).ExpandBlind = 0.9
	GetAI(2).ExpandToValuableAsteroidChance = 0.5
	



	EnemyStronghold = GetAsteroid(1)
	GameWon = 0
	Timer = GetGameTime() + 30
	TimerA = GetGameTime() + 90
	


	while GameRunning() do


		if GameWon == 1 then
	
	
			Pause()
			MessageBox("You have won the Battle of Fluffyland. :>")
			WaitDialog()
			Unpause()
			Quit(true)
	
		end
	
		if GameWon == 2 then
	
	
			Pause()
			MessageBox("You have lost the Battle of Fluffyland. :<")
			WaitDialog()
			Unpause()
			Quit(true)
	
		end
		coroutine.yield()
	end
end

function OnAsteroidTaken(id, owner)
	if id == 1 and owner == 1 then
		GameWon = 1
		return
	end
	
	if id == 0 and owner == 2 then
		GameWon = 2
		return
	end
end