function LevelSetup()


	SetBackdropColour(252,222,200)

	Globals.Agents.MaxSpeed=600
	Globals.Agents.MinSpeed=130

	Globals.Asteroids.SeedlingCap=1000
	Globals.Asteroids.MaxTrees=4
	Globals.Asteroids.MinRadius=95
    Globals.Asteroids.MaxRadius=725
    Globals.Asteroids.RadiusPowerRule=1.5
	Globals.Asteroids.SizeFromEnergy=210
	Globals.Asteroids.SizeFromStrength=210
	Globals.Asteroids.SizeFromSpeed=210
	Globals.Asteroids.MinCoreHealth=300
	Globals.Asteroids.MaxCoreHealth=900
	Globals.Asteroids.CoreHealthPower=3.5
    Globals.Asteroids.MinSendDistance=2500
    Globals.Asteroids.MaxSendDistance=5000
    Globals.Asteroids.SendPowerRule=1.4

	Globals.AI.MinAttackTime=(5)
	Globals.AI.MaxAttackTime=(20)
	Globals.AI.MinGatherTime=(10)
	Globals.AI.MaxGatherTime=(20)
	Globals.AI.MinScoutTime=(1)
	Globals.AI.MaxScoutTime=(5)
	Globals.AI.GraceTimer=(10)



	--experimental AI code
--[[
	Globals.AI.Cowardice = 0.01
	Globals.AI.BattleSavvy = 0.6
	Globals.AI.ReinforcementGreed = 0.8
	Globals.AI.GreedyExpansion = 0.4
	Globals.AI.AidEnthusiasm = 1.8
--]]

	Globals.G.EnemyFactionsMin=(11)
	Globals.G.EnemyFactionsMax=(11)
	Globals.G.MinAsteroidSeparation=1350
	Globals.G.MaxAsteroidNeighbourDist=5500
	Globals.G.StartingSeedlings=(100)
	Globals.G.GreysProbability=0

	Globals.Structures.FlowerProbability=(0.3)


	--AddAsteroidWithAttribs(x, y, energy, strength, speed)
	--#0 Midpoint
	AddAsteroidWithAttribs(0, 0, 0.1, 0.1, 0.1)
	Midpoint = GetAsteroid(0)
	Midpoint.TreeCap = 1
	Midpoint.CoreHealth = 5
	Midpoint.MaxCoreHealth = 10
	Midpoint.SendDistance = 16000
	Midpoint.Owner = 0
	Midpoint:AddSuperSeedlings(50)
	Midpoint:SetGraceTime(99990)

	--#1 Enemy Base
	AddAsteroidWithAttribs(14000, 1500, 1.0, 1.0, 1.0)

	--code specific to the Enemy Base
	EnemyBase = GetAsteroid(1)
	EnemyBase.TreeCap = 5
	EnemyBase.MaxCoreHealth = 500
	EnemyBase.SendDistance = 7000
	EnemyBase.Owner = 2
	EnemyBase.Moveable = false
	EnemyBase:Hide(1)
	EnemyBase:AddSuperSeedlings(500)
	--this is ugly but it works, would like to be able to set the AI to dormant or something instead
	EnemyBase:SetGraceTime(99990)

	--standard code for adding experienced trees
	a = EnemyBase
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	a:AddSeedlings(100)
	a:Hide(1)

	--The Foundry #1
	a = AddAsteroidWithAttribs(-19000, -4000, 0.9, 0.6, 1.0)
	a.Owner = 1
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	a:AddSeedlings(100)
	a:Hide(1)

	--The Foundry #2
	a = AddAsteroidWithAttribs(-18000, -3000, 0.6, 0.9, 1.0)
	a.Owner = 1
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	a:AddSeedlings(100)
	a:Hide(1)


	--#4 2nd Jumpgate by the foundry
	Jumpgate = AddAsteroidWithAttribs(-12500 -2500, 0, 0.1, 0.1, 0.1)
	Jumpgate.TreeCap = 1
	Jumpgate.CoreHealth = 5
	Jumpgate.MaxCoreHealth = 10
	Jumpgate.SendDistance = 16000
	Jumpgate.Owner = 0
	Jumpgate:Hide(1)
	Jumpgate:AddSeedlings(10)
	Jumpgate:SetGraceTime(99990)

	--Sample Code for Asteroid Ring:
	--AddAsteroidRing(int numAsteroids, float x, float y, float centreRadius, float beltWidth)
	--Return type: Nil
	--Adds an asteroid ring containing numAsteroids asteroids, centred around coordinates (x, y),
	--with radius centreRadius, and spreading asteroids out over a ring thickness of beltWidth game units.


	--outer ring
	--#5-34
	AddAsteroidRing(30, 0, 0, 6750, 500)


	--inner ring
	--#35-39
	AddAsteroidRing(5, 0, 0, 2500, 200)

	--Player Asteroid, Starts Developed
	a = GetRandomRangeAsteroid(5, 34)
	a.Owner = 1
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	a:AddSeedlings(100)


	--Trying to assign the computer to asteroids in the outer belt specificly
--[[
	for i = 3,11 do

	xyz= GetRandomRangeEmptyAsteroid(5, 34)
    xyz.Owner = i
	s = xyz:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = xyz:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = xyz:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = xyz:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()

	end
--]]
end


function LevelLogic()

	--Variable Declarations

	--these drive the main story events with StoryAct and the story text with StoryText
	StoryAct = 1
	StoryText = 1
	Timer = 99990
	Timer2 = 99990
	GameWon = 0
	DiscoveredMidpoint = false

	Pause()
	MessageBox("Our scientists have discovered a strange gravitational effect in the center of this asteroid belt.")
	WaitDialog()
	Unpause()

	Pause()
	MessageBox("Fend off the other swarms and discover what lies at the Midpoint.")
	WaitDialog()
	Unpause()



	while GameRunning() do


	--I was having problems with the game crashing with this in the OnAsteroidRevealed function when these were not in the GameRunning loop
	--Initially I tried putting dialog boxes in the OnAsteroidRevealed function but the game crashed often when I tried that

	--Main Story Text
	if StoryText == 2 then
		StoryText = 1
		Pause()
		MessageBox("This is the source of the Gravitational Flux.  Sieze control of the asteroid and plant a tree so our scientists can study its core.")
		WaitDialog()
		Unpause()
	end

	if StoryText == 3 and DiscoveredMidpoint == false then
		StoryText = 1
		DiscoveredMidpoint = true
		Pause()
		MessageBox("We have discovered some kind of jump gate technology.  Use it to colonize the asteroid belt and defeat the other swarms.")
		WaitDialog()
		Unpause()
	end

	if StoryText == 4 then
		StoryText = 1
		Pause()
		MessageBox("We have recieved reports of something attacking the Swarms to the Galactic East (i.e. ---> this way).  Defend the Jumpgate and investigate these rumors.")
		WaitDialog()
		Unpause()

		StoryAct = 4
	end

	if StoryText == 5 then
		StoryText = 1
		Pause()
		MessageBox("The arrival of this new enemy has activated some kind of signal at the Jumpgate.  Our scientists believe they have discovered another jumpgate outside the asteroid belt.")
		WaitDialog()
		Unpause()

		Pause()
		MessageBox("Send some forces to investigate before the whole asteroid belt is overrun!")
		WaitDialog()
		Unpause()


	end

	if StoryText == 6 then
		StoryText = 1
		Pause()
		MessageBox("There are friendly forces nearby!  Use them to defend the asteroid belt from this rampaging horde!")
		WaitDialog()
		Unpause()

		StoryAct = 6
	end

	if StoryText == 7 then
		StoryText = 1
		Pause()
		MessageBox("We have discovered the enemy base, gather your forces and move to destroy them.")
		WaitDialog()
		Unpause()


	end


	--Main Story Events


	if StoryAct == 2 then

		StoryAct = 1

		EnemyBase:SetGraceTime(10)



		Timer = GetGameTime()

		while GetGameTime() < Timer + 60 do

			coroutine.yield()

		end

		StoryText = 4

	end


	if StoryAct == 4 then

		StoryAct = 1

		EnemyBase:AddSeedlings(50)
		Timer = GetGameTime()

		while GetGameTime() < Timer + 60 do

			coroutine.yield()

		end

		Jumpgate:Reveal(1)

--		SetCameraTarget(-12500, 2500)

		StoryText = 5



	end

	if StoryAct == 5 then

		StoryAct = 1
		GetAsteroid(2):Reveal(1)
		GetAsteroid(3):Reveal(1)




		StoryText = 6

	end

	if StoryAct == 6 then

		StoryAct = 1
		Timer = GetGameTime()

		while GetGameTime() < Timer + 90 do

			coroutine.yield()

		end

		StoryText = 7

--		SetCameraTarget(14000, 1500)


		EnemyBase:AddSeedlings(150)
		EnemyBase:SetGraceTime(999990)
		EnemyBase:Reveal(1)

	end


	if GameWon == 1 then


		Pause()
		MessageBox("You have won the Battle of Midpoint.")
		WaitDialog()
		Unpause()
		Quit(true)

	end




	--1st end is GameRunning loop, second end is the end of function

		coroutine.yield()
	end
end



function OnAsteroidRevealed(id, owner)
	if id == 0 and owner == 1 then

		StoryText = 2

	end

--[[
	if id == 2 and owner == 1 then
		StoryText = 5
	end
--]]
end


function OnAsteroidTaken(id, owner)

	if id == 0 and owner == 1 then
		StoryText = 3
		StoryAct = 2
	end

	if id == 4 and owner == 1 then
		StoryAct = 5
	end


	if id == 1 and owner == 1 then
		GameWon = 1
	end

end
