function LevelSetup()


	SetBackdropColour(252,222,200)

	Globals.Agents.MaxSpeed=600
	Globals.Agents.MinSpeed=130

	Globals.Asteroids.MaxTrees=2
	Globals.Asteroids.MinRadius=95
    Globals.Asteroids.MaxRadius=725
    Globals.Asteroids.RadiusPowerRule=1.5
	Globals.Asteroids.SizeFromEnergy=210
	Globals.Asteroids.SizeFromStrength=210
	Globals.Asteroids.SizeFromSpeed=210
	Globals.Asteroids.MinCoreHealth=400
	Globals.Asteroids.MaxCoreHealth=1000
	Globals.Asteroids.CoreHealthPower=3.5
    Globals.Asteroids.MinSendDistance=2000
    Globals.Asteroids.MaxSendDistance=5000
    Globals.Asteroids.SendPowerRule=1.4

	Globals.AI.MinAttackTime=(5)
	Globals.AI.MaxAttackTime=(20)
	Globals.AI.MinGatherTime=(10)
	Globals.AI.MaxGatherTime=(20)
	Globals.AI.MinScoutTime=(1)
	Globals.AI.MaxScoutTime=(5)
	Globals.AI.GraceTimer=(10)


	Globals.G.EnemyFactionsMin=(4)
	Globals.G.EnemyFactionsMax=(6)
	Globals.G.MinAsteroidSeparation=1350
	Globals.G.MaxAsteroidNeighbourDist=5500
	Globals.G.StartingSeedlings=(50)
	Globals.G.GreysProbability=0

	Globals.Structures.FlowerProbability=(0.3)

	-- Asteroid 0
	-- This is the player asteroid
	a = AddAsteroidWithAttribs(6000,-6000, 0.7,0.5,0.8)
	a.Owner = 1
	a.TreeCap = 7
	a:SetRadius(1600)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	a:AddSeedlings(200)
	a.SendDistance = 6500
	a.Moveable = false


	--These are the central asteroids which are randomly generated each time you play
	AddAsteroidRing(22, 0, 0, 5000, 200)


	-- Asteroid 23
	-- This is the enemy stronghold
	a = AddAsteroidWithAttribs(-6000,6000, 1.0,1.0,0.7)
	a.Owner = 2
	a. TreeCap = 3
	a:SetRadius(1600)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	a.SendDistance = 8000
	a.Moveable = false
	a:AddSeedlings(250)
	a:AddSuperSeedlings(100)
	SetCameraPositionToAsteroidID(0)
	SetCameraZoomNow(9)

	end


function LevelLogic()

	Pause()
	MessageBox("Protect Your Home Asteroid and Conquer the other Giant to Win.  Move Fast, The Enemy is Flooding into this Sector!")
	WaitDialog()
	Unpause()


	--Experimental AI Code
	--
	GetAI(2).Cowardice = 0.01
	GetAI(2).MinExpansionForce = 40
	GetAI(2).BattleSavvy = 0.3
	GetAI(2).ReinforcementGreed = 0.8
	GetAI(2).GreedyExpansion = 0.4
	GetAI(2).AidEnthusiasm = 1.8
	--]]



	EnemyStronghold = GetAsteroid(23)
	win = false
	Timer = GetGameTime() + 30

	--The BattleFront Vars are for the AI to distinguish asteroids that are
	--on the front lines, they start out being set to his home asteroid.
	--BattleFront1 = EnemyStronghold.ID
	--BattleFront2 = EnemyStronghold.ID




	while GameRunning() do

	--This is the Reinforcement Timer, so far I've tried 50 Seedlings every 90 seconds which was too much
	--For the Alpha version I settled on 50 seedlings every 150 seconds - which was too easy
		if GetGameTime() > Timer then
			EnemyStronghold:AddSeedlings(30)
--			EnemyStronghold:AddSuperSeedlings(5)
			Timer = Timer + 90
		end


		if win == 1 then
			Pause()
			MessageBox("You Have Conquered Your Nemesis.")
			WaitDialog()
			Unpause()
			Quit(true)
		end

		if win == 0 then
			Pause()
			MessageBox("You Have Been Overwhelmed!")
			WaitDialog()
			Unpause()
			Quit(false)
		end
	--]]

	--Code to force computer to disperse from his homeworld
	--[[

		if EnemyStronghold:GetNumSeedlings(2) > 250 then
			EnemyStronghold:SendSeedlingsToTarget(2, 50, GetAsteroid(BattleFront1) )
			EnemyStronghold:SendSeedlingsToTarget(2, 50, GetAsteroid(BattleFront2) )
		end
	--]]


		coroutine.yield()
	end
end


function OnAsteroidTaken(id, owner)
	if id == 23 and owner == 1 then
		win = 1
	elseif id == 0 and owner ~= 1 then
		win = 0
	end


	--Additional AI Code allowing it to tell where the front is likely to be.
--[[
	if id ~= 23 and owner == 2 then
		BattleFront2 = BattleFront1
		BattleFront1 = id
	end
--]]

end
