-- ============================================================================================================================ --

function LevelSetup()  
	SetGlobals()
   SetVariables()
   SetAI()	
	SetPlanets()
end

function SetVariables()
	px, py, powner, pradius = 0,0,0,0
	
	-- for colouring planets
	colourtable = {}
	colourtable[0] = { red = 0, green = 0, blue = 0 } -- (0) gray
	table.insert( colourtable, { red = 0, green = 0, blue = 255 } ) -- (1) blue
	table.insert( colourtable, { red = 255, green = 0, blue = 0 } ) -- (2) red
	table.insert( colourtable, { red = 0, green = 255, blue = 0 } ) -- (3) green
	table.insert( colourtable, { red = 125, green = 125, blue = 0 } ) -- (4) yellow
	table.insert( colourtable, { red = 0, green = 125, blue = 125 } ) -- (5) cyan
	table.insert( colourtable, { red = 125, green = 0, blue = 125 } ) -- (6) purple
	
	factions = Globals.G.EnemyFactionsMax + 2
	
	-- graph matrix
   graph = {} 
	for f=0,(factions-1) do
      graph[f] = {} 
   end
	
	yscale = {}
	
	highest_troops = 0
	enemy_strength = 0
	Display = 0
	do_once = false
	strength = {}
	
end

function SetGlobals()
   
	math.randomseed(os.time())
	math.random(); math.random(); math.random()
	NumAI = math.random(1,5)
	Globals.G.EnemyFactionsMin=(5)
	Globals.G.EnemyFactionsMax=(5)
	
	Globals.G.Asteroids = (NumAI + 2) * 4
	
	Globals.G.BeltWidth = 1500
	Globals.G.BeltRadius = 500
		
	GameSpeed = 6
	Globals.Structures.SpawnTime1 = (GameSpeed*4)
   Globals.Structures.SpawnTime2 = (GameSpeed*3)
   Globals.Structures.SpawnTime3 = (GameSpeed*2)
   Globals.Structures.SpawnTime4 = (GameSpeed*1)
	
	StartSeedlings = math.random(10,40)
	Globals.G.GreysProbability = (0)
	Globals.G.StartingSeedlingsPlayer = StartSeedlings
	Globals.G.StartingSeedlings = StartSeedlings
   Globals.G.GreysMin = StartSeedlings
	Globals.G.GreysMax = StartSeedlings
	
	Globals.AI.GraceTimer = 0
	
	Globals.G.MaxAsteroidNeighbourDist = (4500)
	Globals.Asteroids.MinSendDistance = (6500)
	Globals.Asteroids.MaxSendDistance = (6500)
	
   Globals.Asteroids.MinCoreHealth = 50
	Globals.Asteroids.MaxCoreHealth = 400
	Globals.Asteroids.CoreHealthPower = 3
	
	Globals.Structures.MinHealth = 300
	Globals.Structures.MaxHealth = 2000
	Globals.Structures.HealthPower = 3
	
	Globals.Structures.RootSpeed = 80
	
	Globals.StructuresDefense.MinHealth = 375
	Globals.StructuresDefense.MaxHealth = 2400
	Globals.StructuresDefense.HealthPower = 3
	
end

function SetAI()
	
   for n=2, (factions-1) do
	
      --Globals.AI.MinDecisionTime = 0
		--Globals.AI.MaxDecisionTime = 0
	
		GetAI(n).MinScoutTime = 6000
		GetAI(n).MaxScoutTime = 6000
		GetAI(n).MinScoutableArmy = 300
		
		--GetAI(n).MinBattleAnalysisTime = 0
		--GetAI(n).MaxBattleAnalysisTime = 0
		
		GetAI(n).Cowardice = 0
	   GetAI(n).BattleSavvy = 0.5
		GetAI(n).RecognisableThreatProportion = 1
	   GetAI(n).ReinforcementGreed = 1
	   GetAI(n).AidEnthusiasm = 1
		
      GetAI(n).MinExpansionTime = 0
      GetAI(n).MaxExpansionTime = 0
	   GetAI(n).MinExpansionForce = 10
	   GetAI(n).ExpandToValuableAsteroidChance = 1
	   GetAI(n).GreedyExpansion = 1
	   GetAI(n).ExpandBlind = 1
		
		GetAI(n).MinAttackTime = 0
		GetAI(n).MaxAttackTime = 0
		
		GetAI(n).MinPlantTime = 0
      GetAI(n).MaxPlantTime = 0
		
      GetAI(n).MinGatherTime = 0
	   GetAI(n).MaxGatherTime = 0
		
      GetAI(n).MinTotalSeedlings = 0
	   GetAI(n).MinTotalAddPerAsteroid = 0
		
   end
end

function SetPlanets()

	-- Asteroid 0
	PlayerHome = AddAsteroidWithAttribs(0,0,0.5,0.5,0.5)
	PlayerHome.Owner = 1
	PlayerHome:AddSeedlings(40)
	PlayerHome:AddDysonTree()
	
	-- Asteroids 1 - 6 (Player's Ring)
	AddAsteroidRing(6,0,0,1500,0)
	
	-- Stepping Stones
	for a=1,Globals.G.EnemyFactionsMax do
	   i = 4500 * math.cos(math.rad(a*(360/Globals.G.EnemyFactionsMax)))
		j = 4500 * math.sin(math.rad(a*(360/Globals.G.EnemyFactionsMax)))
		AddAsteroid(i,j)
	end  
	
	-- More Stepping Stones
	for a=1,Globals.G.EnemyFactionsMax do
	   i = 7500 * math.cos(math.rad(a*(360/Globals.G.EnemyFactionsMax)))
		j = 7500 * math.sin(math.rad(a*(360/Globals.G.EnemyFactionsMax)))
	AddAsteroid(i,j)
	end  
	
	-- Enemy Rings
	for a=1,Globals.G.EnemyFactionsMax do
		i = 13500 * math.cos(math.rad(a*(360/Globals.G.EnemyFactionsMax)))
		j = 13500 * math.sin(math.rad(a*(360/Globals.G.EnemyFactionsMax))) 
      EnemyHome = AddAsteroidWithAttribs(i,j,1,1,1)	
      EnemyHome.Owner = a + 1
      EnemyHome:AddSeedlings(10)
      EnemyHome.TreeCap = 8
		for n=1,4 do
         s= EnemyHome:AddDysonTree()
	   end
         AddAsteroidRing(6,i,j,3000,0)		
	end
	
end

-- ============================================================================================================================ --

function LevelDraw()
   if GetGameTime() > 1 then
   scale = GetCameraZoom()
   xpos = (GetCameraX())
   ypos = (GetCameraY())
	
	--ScreenSize()
	height = GetScreenHeight()
	width = GetScreenWidth()
	
   ColourPlanets()
   DrawGraph()
	DrawBar()
	end
	
end

function round(num) 
   if num >= 0 then 
	   return math.floor(num+.5) 
   else 
	   return math.ceil(num-.5) 
	end
end

function ColourPlanets()
   for n=0, (GetNumAsteroids()-1) do
	   px, py, powner, pradius = GetAsteroid(n).position.x, GetAsteroid(n).position.y, GetAsteroid(n).Owner, GetAsteroid(n).Radius
		if IsOnScreen(px,py,pradius) then
		   if GetAsteroid(n):IsVisible(1) then
			   if GetAsteroid(n).Owner ~= 0 then
	            DrawSprite(5,px,py,colourtable[powner].red,colourtable[powner].green,colourtable[powner].blue,1,(1.15*pradius))
				end
			end
		end
	end
end

function DrawGraph()

  	for f=1,(factions-1) do
      for t=1,(#graph[f]-1) do
	      x1 = 0.475 - ((t-1) *(0.15/(#graph[f]-1)))
		 --x1 = 0.475 - (t * 0.0015)
	      x2 = 0.475 - ((t) *(0.15/(#graph[f]-1)))
		 --x2 = 0.475 - ((t+1) * 0.0015)
         y1 = 0.277 + (0.18* graph[f][t]/highest_troops)
         y2 = 0.277 + (0.18* graph[f][t+1]/highest_troops)
	      DrawLine((xpos - scale*width*x1), (ypos - scale*height*y1), (xpos - scale*width*x2), (ypos - scale*height*y2), colourtable[f].red,colourtable[f].blue,colourtable[f].green,0.99,colourtable[f].red,colourtable[f].blue,colourtable[f].green,0.99,1*scale)   
	   end
	end
	
	DrawLine((xpos - scale*width*0.475),(ypos - scale*height*0.275),(xpos - scale*width*0.325),(ypos - scale*height*0.275), 0,0,0,0.5,0,0,0,0.5,3*scale)
	DrawLine((xpos - scale*width*0.475),(ypos - scale*height*0.475),(xpos - scale*width*0.325),(ypos - scale*height*0.475), 0,0,0,0.5,0,0,0,0.5,3*scale)
	DrawLine((xpos - scale*width*0.475),(ypos - scale*height*0.475),(xpos - scale*width*0.475),(ypos - scale*height*0.275), 0,0,0,0.5,0,0,0,0.5,3*scale)
	DrawLine((xpos - scale*width*0.325),(ypos - scale*height*0.475),(xpos - scale*width*0.325),(ypos - scale*height*0.275), 0,0,0,0.5,0,0,0,0.5,3*scale)
	--DrawTexLine(3,(xpos - scale*width*0.475),(ypos - scale*height*0.375),(xpos - scale*width*0.325),(ypos - scale*height*0.375), 0,0,0,0.25,0,0,0,0.25,1*(height/2560)*scale)

end

function DrawBar()
   DrawLine((xpos - scale*width*0.178),(ypos - scale*height*0.470),(xpos + scale*width*0.178),(ypos - scale*height*0.470), 0,0,0,0.9,0,0,0,0.9,3*scale)
	DrawLine((xpos + scale*width*0.178),(ypos - scale*height*0.4705),(xpos + scale*width*0.178),(ypos - scale*height*0.4045), 0,0,0,0.9,0,0,0,0.9,3*scale)
	DrawLine((xpos + scale*width*0.178),(ypos - scale*height*0.405),(xpos - scale*width*0.178),(ypos - scale*height*0.405), 0,0,0,0.9,0,0,0,0.9,3*scale)
	DrawLine((xpos - scale*width*0.178),(ypos - scale*height*0.4045),(xpos - scale*width*0.178),(ypos - scale*height*0.4705), 0,0,0,0.9,0,0,0,0.9,3*scale)
	
	DrawTexLine( 4, (xpos - scale*width*0.178),(ypos - scale*height*0.4375),((xpos - scale*width*0.178) + (0.356*scale*width*(GetGameTime()/1500))),(ypos - scale*height*0.4375), 255,0,0,0.8,255,0,0,0.8,0.65*scale*height/2560)
end

-- ============================================================================================================================ --

function LevelLogic()

   Pause()
	MessageBox("The game will last twenty-five minutes. \n\n If you are the strongest empire after twenty-five minutes you will win. \n\n You can view your progress on the graph. \n\n Each seedling is worth 1 point and each tree is worth 10 points. \n\n Good Luck!!!")
	WaitDialog()
	Unpause()

   SetBackdropColour(255,255,255)
	
	NumTroops()
   NumTroops()
		
	Display = 0
   while GameRunning() do
	
	   Timer = GetGameTime()
		coroutine.yield()
		
		if Timer >= 1500 then
		   WinConditions()
		end
		
		if Timer > Display then
		   SetVisibility()
			NumTroops()
		   Display = Timer + 5
		end
	end
end

function NumTroops()
   for n=0,(factions-1) do	   
	troops = ((GetEmpire(n).NumSeedlings) + (GetEmpire(n).NumTrees * 10))
	   if #graph[n] == 100 then
		   table.remove(graph[n],1)
		end
	   table.insert(graph[n],troops)
	if troops > highest_troops then
	   highest_troops = troops
	end
	end
end

function SetVisibility()
   for p=0,(GetNumAsteroids()-1) do
	   if GetAsteroid(p).Owner == 1 then
	      for n=2,(factions-1) do
		      GetAsteroid(0):SetVisible(n,true)
	      end
		end
	end
end

function WinConditions()
leader = 0
leader_power = 0
power = 0

   for n=1,(Globals.G.EnemyFactionsMax + 1) do
	   power = (GetEmpire(n).NumSeedlings) + (GetEmpire(n).NumTrees * 10)
		strength[n] = power
		
	   if power >= leader_power then
		   leader_power = power
		   leader = n
		end
	end
	
	n = math.random(1,4)
	if n == 1 then 
	   hint = "That mines are extremely useful?"
	end
	if n == 2 then 
	   hint = "That the center is a very scary place for an empire?"
	end
	if n == 3 then
	   hint = "That early expansion is vital?"
	end
	if n == 4 then
	   hint = "That it's best to retreat from fights you cannot win?"
	end
	
	if leader ~= 1 then
	   Pause()
		MessageBox("Oh no! You've been defeated.\n\n You scored "..strength[1].." points.\n\n Red Empire scored "..strength[2].." points. \n Green Empire scored "..strength[3].." points. \n Yellow Empire scored "..strength[4].." points. \n Cyan Empire scored "..strength[5].." points. \n Purple Empire scored "..strength[6].." points. \n\n Did you know... \n\n ... ".. hint)
		WaitDialog()
		Unpause()
		
		Quit(false)
	end
	
	if leader == 1 then
	   Pause()
		MessageBox("Congratulations, you are awesome.\n\n You scored "..strength[1].." points.\n\n Red Empire scored "..strength[2].." points. \n Green Empire scored "..strength[3].." points. \n Yellow Empire scored "..strength[4].." points. \n Cyan Empire scored "..strength[5].." points. \n Purple Empire scored "..strength[6].." points.")
		WaitDialog()
		Unpause()
	
	   Quit(true)
	end
end