
-- empire colours
Game = luanet.import_type("Eufloria.ColonyGame");
	
colours = {}
for e=0,7 do
	colours[e] = {}
	for c=0,3 do
		colours[e][c] = Game.GetFactionColour(e,c)
	end
end

function LevelSetup()

   SetBackdropColour(0,0,0)
	SetCameraPosition(0,0)
	SetCameraZoomNow(4.5 + ((1600 - GetScreenHeight())/500))
	
	-- globals
	Globals.Agents.MinDamage=(10)
	Globals.Agents.MaxDamage=(30)
	Globals.Agents.MinSpeed=(250)
	Globals.Agents.MaxSpeed=(850)
	Globals.Agents.DamagePower=(3)
	
	Globals.Asteroids.SpawnCap=(0)
   
   Globals.G.EnemyFactionsMin=(0)
   Globals.G.EnemyFactionsMax=(0)
   Globals.G.GreysProbability=(0)
   Globals.G.Asteroids=(0)
   Globals.G.StartingSeedlings=(0)
   Globals.G.StartingSeedlingsPlayer=(0)
   Globals.G.GreysMin=(0)
   Globals.G.GreysMax=(0)
	
	Globals.Structures.LevelTime1=(0.1)
   Globals.Structures.LevelTime2=(0.1)
   Globals.Structures.LevelTime3=(0.1)
   Globals.Structures.LevelTime4=(0.1)
	Globals.Structures.FlowerProbability=(0)
	
	
	a = AddAsteroidWithAttribs(0,0, 1,1,1)
	a.Owner=(1)
	a.TreeCap=(3)
	a:Reveal(1)
	a:SetRadius(500)
	a.Moveable = false
	
	for n=1,3 do
	   GetAsteroid(0):GetSurfaceNode(math.rad((360/3)*n))
		a = GetAsteroid(0):AddDysonTree()
		a:LevelUp()
		a:LevelUp()
		a:LevelUp()
		a:LevelUp()
	end
	
	
	polar = {}
   
	for n=1,6 do
	   polar[n] = {}
	   polar[n].i = 4000 + n * 1000
		polar[n].j = math.random(1,360)
		if math.random(0,1) >= 0.5 then
		   polar[n].v = math.random(1,3)
		else
		   polar[n].v = -math.random(1,3)
		end
		x = polar[n].i * math.cos(math.rad(polar[n].v * polar[n].j))
		y = polar[n].i * math.sin(math.rad(polar[n].v * polar[n].j))
		AddAsteroid(x,y)
		GetAsteroid(n).Owner = 2
		GetAsteroid(n):Reveal(1)
		GetAsteroid(n).TreeCap = 0
		GetAsteroid(n).Moveable = false
		GetAsteroid(n).SeedlingCap = 0
	end
	
	for n=1,4 do
	   GetAsteroid(n).attribs.strength = 0.01
		GetAsteroid(n).attribs.speed = 0.25
	end
	
	GetAsteroid(5).attribs.strength = 0.5
   GetAsteroid(6).attribs.strength = 1
	GetAsteroid(6).attribs.speed = 0.01
	
	numtospawn = 1
	enemy_swarm = {}
	boss_swarm = {}
	seedlings_killed = 0
	bosses_killed = 0
	
	boss = {}
	for n=1,10 do
	   boss[n] = {}
		boss[n].timer = n*30
		boss[n].sent = false
	end

	boss[1].energy = 3
	boss[1].speed = 2
	boss[1].strength = 0
	boss[1].health = 10
	
	boss[2].energy = -3
	boss[2].speed = 2
	boss[2].strength = -1
	boss[2].health = 10
	
	boss[3].energy = -3
	boss[3].speed = 2
	boss[3].stength = 1
	boss[3].health = 10
	
	boss[4].energy = 3
	boss[4].speed = 2
	boss[4].strength = 0
	boss[4].health = 10
	
	boss[5].energy = 3
	boss[5].speed = 2
	boss[5].strength = 0
	boss[5].health = 10
	
	boss[6].energy = 3
	boss[6].speed = 2
	boss[6].strength = 0
	boss[6].health = 10
	
	boss[7].energy = 3
	boss[7].speed = 2
	boss[7].strength = 0
	boss[7].health = 10
	
	boss[8].energy = 3
	boss[8].speed = 2
	boss[8].strength = 0
	boss[8].health = 10
	
	boss[9].energy = 3
	boss[9].speed = 2
	boss[9].strength = 0
	boss[9].health = 10
	
	boss[10].energy = 3
	boss[10].speed = 2
	boss[10].strength = 0
	boss[10].health = 10
	
	wave = {}
	
	for n=1,10 do
	   wave[n] = {}
	   wave[n].timer = (30 * n) - 15
	   wave[n].sent = false
	   wave[n].amount = 10 + n
	end
	
	timer = 0
	hit = false
	NovaEnergy = 0
	MaxNovaEnergy = 100
	NovaPosIncrement = 5
	NovaNegIncrement = 10
	
end

function LevelDraw()
	
	for n=0,GetAsteroid(0):GetNumTrees()-1 do
	   owner = GetAsteroid(0).Owner
	   tree = GetAsteroid(0):GetTreeByIndex(n)
	   ratio = tree.CurrentEnergy/tree.MaxEnergy
		x,y = tree.position.x, tree.position.y
		DrawSprite(6, x,y, colours[owner][0].r, colours[owner][0].g, colours[owner][0].b, 0.75, 100)
		DrawSprite(5, x,y, colours[owner][0].r, colours[owner][0].g, colours[owner][0].b, 0.75, 100*ratio)
	end
	
	if #boss_swarm > 0 then
	   for n=1,#boss_swarm do
	      DrawSprite(5, boss_swarm[n].link.position.x, boss_swarm[n].link.position.y, colours[3][0].r, colours[3][0].g, colours[3][0].b, 0.75, 50)
		end
	end
end

function ScreenDraw()
   w = GetScreenWidth()
   h = GetScreenHeight()
	ratio = NovaEnergy / MaxNovaEnergy
   DrawSprite(6, w*0.9, h*0.85, colours[1][2].r, colours[1][2].g, colours[1][2].b, 0.9, 75)
	DrawSprite(5, w*0.9, h*0.85, colours[1][2].r, colours[1][2].g, colours[1][2].b, 0.9, 80*ratio)
end

function LevelLogic()

   GetAsteroid(0).SendDistance = 10000
	
   for n=1,6 do
	   GetAsteroid(n).SendDistance = 35000
	end
   
	Pause()
	MessageBox("Survive The Swarm\n\n Click on the nose of each invader to knock them out of the sky!\n\n Note:- Some invaders require more than one click.")
	WaitDialog()
	Unpause()
	
	Pause()
	MessageBox("Each successful hit adds energy to your Nova Bomb ability (right click)\n\n However, each miss drains energy!\n\n Nova bomb can only be used when your energy gauge is full (The circle in the bottom right of the screen)\n\n")
	WaitDialog()
	Unpause()
	
	Pause()
	MessageBox("They'll be here soon...\n\n Enjoy the calm while it lasts...")
	
   while GameRunning() do
	
	   while timer < 305 do
	      GameLoop()
		   LoseConditions()
			coroutine.yield()
		end
		
		SetCameraPosition(0,0)
	   SetCameraZoomNow(4.5 + ((1600 - GetScreenHeight())/500))
		
		-- prune seedlings
   	if #enemy_swarm > 0 then
         for n=#enemy_swarm,1,-1 do
	         if enemy_swarm[n].health <= 0 then
		         enemy_swarm[n].link:Die()
   				seedlings_killed = seedlings_killed + 1
	   			table.remove(enemy_swarm, n)
	   	   end
	      end
	   end
	
	   -- prune bosses
	   if #boss_swarm > 0 then
	      for n=#boss_swarm,1,-1 do
		      if boss_swarm[n].health <= 0 then
			      boss_swarm[n].link:Die()
			   	bosses_killed = bosses_killed + 1
			   	table.remove(boss_swarm, n)
			   end
		   end
	   end
		
		WinConditions()
		
	   coroutine.yield()
	end
end

function GameLoop()
      -- prune seedlings
	if #enemy_swarm > 0 then
      for n=#enemy_swarm,1,-1 do
	      if enemy_swarm[n].health <= 0 then
		      enemy_swarm[n].link:Die()
				seedlings_killed = seedlings_killed + 1
				table.remove(enemy_swarm, n)
		   end
	   end
	end
	
	-- prune bosses
	if #boss_swarm > 0 then
	   for n=#boss_swarm,1,-1 do
		   if boss_swarm[n].health <= 0 then
			   boss_swarm[n].link:Die()
				bosses_killed = bosses_killed + 1
				table.remove(boss_swarm, n)
			end
		end
	end
	
   -- timer
	timer = GetGameTime()
	   
	-- move enemy asteroids
	for n=1,6 do
	   x = polar[n].i * math.cos(math.rad(polar[n].v * (polar[n].j + timer)))
		y = polar[n].i * math.sin(math.rad(polar[n].v * (polar[n].j + timer)))
	   GetAsteroid(n):MoveTo(x,y)
	end
		
	-- set camera
	SetCameraPosition(0,0)
	SetCameraZoomNow(4.5 + ((1600 - GetScreenHeight())/500))
		
	-- spawn enemy seedlings
	for n=1,4 do
	   if GetAsteroid(n):GetNumSeedlings() == 0 then
		   for m=1,numtospawn do
		      GetAsteroid(n):AddSeedlings(1)
				seedling = {}
				seedling.link = GetAsteroid(n):Seedlings(2)[m-1]
				seedling.health = math.random(1,3)
				seedling.boss = false
				seedling.link.attribs.energy = (-1/3 * seedling.health) -1
				seedling.link.attribs.strength = 0
				seedling.link.attribs.speed = (-2/3 * seedling.health) - 1
			   table.insert(enemy_swarm, seedling)
			end
		end
		GetAsteroid(n):SendSeedlingsToTarget(2,numtospawn,GetAsteroid(0))
	end
				
	-- boss timer
	for n=1,10 do
	   if GetGameTime() > boss[n].timer and boss[n].sent == false then
		   GetAsteroid(5):AddSeedlings(1)
			seedling = {}
			seedling.link = GetAsteroid(5):Seedlings(2)[0]
			seedling.health = boss[n].health
			seedling.boss = true
			seedling.link.attribs.energy = boss[n].energy
			seedling.link.attribs.strength = boss[n].strength
			seedling.link.attribs.speed = boss[n].speed
			table.insert(boss_swarm, seedling)
		   boss[n].sent = true
			GetAsteroid(5):SendSeedlingsToTarget(2,1,GetAsteroid(0))
		end
	end
		
	-- wave timer
	for n=1,10 do
	   if GetGameTime() > wave[n].timer and wave[n].sent == false then
		   GetAsteroid(6):AddSeedlings(wave[n].amount)
			for m=0,wave[n].amount -1 do
			   seedling = {}
            seedling.link = GetAsteroid(6):Seedlings(2)[m]
				seedling.health = math.random(2,4)
				seedling.boss = false
				seedling.link.attribs.energy = (-1/3 * seedling.health) - 1
				seedling.link.attribs.strength = 0
				seedling.link.attribs.speed = (-2/3 * seedling.health) - 1
				table.insert(enemy_swarm, seedling)
			end
   		--GetAsteroid(6):SendSeedlingsToTarget(2,wave[n].amount, GetAsteroid(0)) ?? doesn't work? Only sends one!!!
			wave[n].sent = true
		end
	end
	
	-- send wave seedlings
	if GetAsteroid(6):GetNumSeedlings() > 0 then
	   GetAsteroid(6):SendSeedlingsToTarget(2,1,GetAsteroid(0))
	end
	
	-- update boss asteroid speed
	speedratio = GetGameTime()/315
	if speedratio > 1 then
	   speedratio = 1
	end
	GetAsteroid(6).attribs.speed = speedratio
	
	-- update wave asteroid speed/strength
	strengthratio = 0.5 + (0.25 * GetGameTime()/315)
	speedratio = 0.5 + (0.5* GetGameTime()/315)
	if strengthratio > 1 then
	   strengthratio = 1
	end
	if speedratio > 1 then
	   speedratio = 1
	end
	GetAsteroid(5).attribs.speed = speedratio 
	GetAsteroid(5).attribs.strength = strengthratio
end

function LoseConditions()
	-- lose
	a = GetAsteroid(0):GetNumTrees()
	if a < 3 then
	   timeleft = math.floor(315 - GetGameTime())
		if (timeleft) <= 0 then
		   GetAsteroid(0).Owner = 2
			MessageBox("You have failed to beat back the horde.\n\n Seedlings Killed = "..seedlings_killed.."\n\n Bosses Killed = "..bosses_killed.." out of 10\n\n The Swarm were running out of troops... If only you could have killed the remaining "..#enemy_swarm.. "enemies...")
			WaitDialog()
		else
	      GetAsteroid(0).Owner = 2
	      MessageBox("You have failed to beat back the horde.\n\n Seedlings Killed = "..seedlings_killed.."\n\n Bosses Killed = "..bosses_killed.." out of 10\n\n If only you could have survived "..timeleft.." seconds longer! :(")
			WaitDialog()
		end
		Quit(false)
	end
end

function WinConditions()
   if #enemy_swarm == 0 then
	   MessageBox("Hoorah! You have prevailed!\n\n Seedlings Killed = "..seedlings_killed.."\n\n Bosses Killed = "..bosses_killed)
		WaitDialog()
		Quit(true)
	end
end

function OnMouseLeftDown(x,y)
   
	dist = math.sqrt((x - GetAsteroid(0).position.x)^2 + (y - GetAsteroid(0).position.y)^2)
	if dist > GetAsteroid(0).Radius then 

      -- prune seedlings
   	if #enemy_swarm > 0 then
         for n=#enemy_swarm,1,-1 do
	         if enemy_swarm[n].health <= 0 then
		         enemy_swarm[n].link:Die()
				   table.remove(enemy_swarm, n)
   		   end
	      end
   	end
	
	   hit = false
		if #enemy_swarm > 0 then
   	   for n=#enemy_swarm,1,-1 do
   	      distance = math.sqrt((enemy_swarm[n].link.position.x - x)^2 + (enemy_swarm[n].link.position.y - y)^2)
   		   if distance <= 50 then
			      hit = true
   		      enemy_swarm[n].health = enemy_swarm[n].health - 1
   		   end
   	   end
		end
		
		-- prune bosses
		if #boss_swarm > 0 then
		   for n=#boss_swarm,1,-1 do
			   if boss_swarm[n].health <= 0 then
				   boss_swarm[n].link:Die()
					table.remove(boss_swarm, n)
				end
			end
		end
		
		if #boss_swarm > 0 then
		   for n=#boss_swarm,1,-1 do
			   distance = math.sqrt((boss_swarm[n].link.position.x - x)^2 + (boss_swarm[n].link.position.y - y)^2)
			   if distance <= 50 then
			      hit = true
   		      boss_swarm[n].health = boss_swarm[n].health - 1
   		   end
		   end
		end
		
		if hit == true then
		   NovaEnergy = NovaEnergy + NovaPosIncrement
			if NovaEnergy > MaxNovaEnergy then
			   NovaEnergy = MaxNovaEnergy
			end
	   else
			NovaEnergy = NovaEnergy - NovaNegIncrement
			if NovaEnergy < 0 then
			   NovaEnergy = 0
			end
		end
		
	end
end

function OnMouseRightDown(x,y)
   -- prune seedlings
   if #enemy_swarm > 0 then
      for n=#enemy_swarm,1,-1 do
	      if enemy_swarm[n].health <= 0 then
	         enemy_swarm[n].link:Die()
				seedlings_killed = seedlings_killed + 1
			   table.remove(enemy_swarm, n)
         end
	   end
   end
	
	if NovaEnergy >= MaxNovaEnergy then
	   for n=#enemy_swarm,1,-1 do
         distance = math.sqrt((enemy_swarm[n].link.position.x - x)^2 + (enemy_swarm[n].link.position.y - y)^2)
      	if distance <= 450 and not enemy_swarm[n].boss then
   	      enemy_swarm[n].health = enemy_swarm[n].health - 10
   	   end
      end
		NovaEnergy = 0
	end
		
end