function LevelDraw()
end

function LevelSetup()

	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(1)

        Globals.Structures.SpawnTime1 = (1)
        Globals.Structures.SpawnTime2 = (1)
        Globals.Structures.SpawnTime3 = (1)
        Globals.Structures.SpawnTime4 = (1)

        Globals.G.GreysProbability = (0)

	--AI stuff - Copied from the Binary-Black map by AWS
	GetAI(2).Cowardice = 0.04 
	GetAI(2).MinExpansionForce = 12
	GetAI(2).BattleSavvy = 0.4 
	GetAI(2).ReinforcementGreed = 0.4 
	GetAI(2).GreedyExpansion = 0.4 	
	GetAI(2).AidEnthusiasm = 0.3 	
	GetAI(2).ExpandBlind = 0.4 	
	GetAI(2).ExpandToValuableAsteroidChance = 0.6 
       
        -- I think this should make the AI expand faster
        GetAI(2).MinPlantTime = 1
        GetAI(2).MaxPlantTime = 5
        GetAI(2).MinExpansionTime = 1
        GetAI(2).MaxExpansionTime = 5

	-- Asteroid 0 - starting asteroid
	a = AddAsteroidWithAttribs(-6000,0, 1,1,1)
	a.Owner = 1
	a.TreeCap = 8
	a:SetRadius(250)
	a.SendDistance = 2500

	a:AddSeedlings(100)
        a.Moveable = false


	-- Asteroid 1
	a = AddAsteroidWithAttribs(6000,0, 1,1,1)
	a.Owner = 2
	a.TreeCap = 8
	a:SetRadius(250)
	a.SendDistance = 2500
	
	a:AddSeedlings(100)
        a.Moveable = false


        -- Asteroid Inner Circle
        for t=0,5 do
          deg = math.rad(t*60)
          i = 2000 * math.sin(deg)  
          j = 2000 * math.cos(deg)
          a = AddAsteroidWithAttribs(i,j,0.5,0.5,0.5)
          a.Moveable = false
        end

        -- Asteroid Outer Circle 
       
        for t=0,5 do
          deg = math.rad(t*60)
          i = 4000 * math.sin(deg)  
          j = 4000 * math.cos(deg)
          a = AddAsteroidWithAttribs(i,j,1,1,1)
          a.Moveable = false
        end
      
        -- Set Variables
        Score = 0
        OldTime = 0
        ScoreIncrement = 0
        ConsoleTime = 0
        Pseed = 0
        Cseed = 0
        Reinforcements = 0


		
end



function LevelLogic()

Pause()
MessageBox("They spread far and wide, their ravenous hunger insatiable.")
WaitDialog()
Unpause()

Pause()
MessageBox("They multiplied, they swarmed. A blight upon the lands.")
WaitDialog()
Unpause()

Pause()
MessageBox("The earth-mother wept.")
WaitDialog()
Unpause()

Pause()
MessageBox("Will her tears be soothed?")
WaitDialog()
Unpause()

Pause()
MessageBox("Or will the flood begin?")
WaitDialog()
Unpause()

Pause()
MessageBox("You have five minutes...")
WaitDialog()
Unpause()


      while GameRunning() do

          -- Time the game has been running
          Timer = GetGameTime()
          
          -- How much time has passed since last loop?
          TimeIncrement = Timer - OldTime

          -- How many asteroids does the player hold?
          PlanetsHeld = GetEmpire(1):GetNumOwnedAsteroids()
      
          -- How many points to add to score
          ScoreIncrement = PlanetsHeld * TimeIncrement

          -- Update player's score
          Score = Score + ScoreIncrement

          -- Save current time for next loop
          OldTime = Timer

   
          -- Show score in console
            if ConsoleTime < Timer then
              print ("Score")
              print (math.ceil(Score))
              ConsoleTime = math.ceil(Timer)
            end


          -- Check for end conditions
            if Timer > 300 then
              Pause()
              MessageBox(math.ceil(Score))
              WaitDialog()
              Unpause()
              
              Quit(true)
            end

          -- Reinforcements
            for p = 0,13 do
              Pseed = Pseed + GetAsteroid(p):GetNumSeedlings(1)
              Cseed = Cseed + GetAsteroid(p):GetNumSeedlings(2)
            end

            if Pseed > Cseed then
              Reinforcements = Pseed - Cseed
              GetAsteroid(1):AddSuperSeedlings(Reinforcements,2,1,1,1)
            end

          -- Reset Variables
            Pseed = 0
            Cseed = 0
                      
    
          -- Simulate the Sun 
            rcolour = 255 - (Timer * 0.85)
            gcolour = 255 - (Timer * 0.85)
            bcolour = 255 - (Timer * 0.85)
            SetBackdropColour(rcolour,gcolour,bcolour)
                                          coroutine.yield()
               

      end

end