function LevelSetup()

	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.G.EnemyFactionsMin=(0)
	Globals.G.EnemyFactionsMax=(0)
        Globals.G.GreysProbability=(0)
        SetDysonTreeButtonAvailable(true)
        SetTreeInfoAvailable(true)
        SetCoreInfoAvailable(true)
        SetAttribsInfoAvailable(true)
        SetEnemyInfoAvailable(true)

	


        -- Create Map


	-- Asteroid 0
	a = AddAsteroidWithAttribs(200,1100, 0.4,0.4,0.6)
	a.Owner = 1
	a:AddSeedlings(40)
        a:AddDysonTree()
	
	-- Asteroid 1
	a = AddAsteroidWithAttribs(500,-500, 0.7,0.7,0.4)
	a.Owner = 0

	-- Asteroid 2
	a = AddAsteroidWithAttribs(3600,-2400, 0.7,0.6,0.9)
        a.Owner = 0

        -- Asteroid 3
	a = AddAsteroidWithAttribs(800,-2500, 0.9,0.9,0.9)
        a.Owner = 0

        -- Asteroid 4
        a = AddAsteroidWithAttribs(1200,-3200, 0.4,0.6,0.2)
        a.Owner = 0
       
        -- Asteroid 5
        a = AddAsteroidWithAttribs(-1500,-7000, 0.2,0.8,0.4)
        a.Owner = 2
        a:AddSeedlings(250)
        a:SetRadius(500)
        a.TreeCap = 6
        a:AddDysonTree()
        a:AddDefenseTree()
       
        -- Asteroid Ring
        AddAsteroidRing(5,2300,-4800,900,900)


	
	
end

        	




function LevelLogic()

for i=1,11 do
   Roid = GetAsteroid((i-1))
   Roid.SendDistance = 50
end    

	GetAI(2).Cowardice = 0.05
	GetAI(2).MinExpansionForce = 10
	GetAI(2).BattleSavvy = 0.1
	GetAI(2).ReinforcementGreed = 0.9
	GetAI(2).GreedyExpansion = 0.9
	GetAI(2).AidEnthusiasm = 0.9
	GetAI(2).ExpandBlind = 0.9
	GetAI(2).ExpandToValuableAsteroidChance = 0.1

Pause()
MessageBox("The sun is our life source.")
WaitDialog()
Unpause()

Pause()
MessageBox(" Without it we do not function, we cannot function.")
WaitDialog()
Unpause()

Pause()
MessageBox("The dark ones have taken root in this cluster, seek them out and destroy them.")
WaitDialog()
Unpause()
    
Pause()
MessageBox("But beware young seedling, they do not share our affinity to the light.")
WaitDialog()
Unpause()

    while GameRunning() do
       
       -- Time the game has been running
          Timer = GetGameTime()

       -- Simulate the Sun 
          rcolour = 127.5 + (127.5*(math.cos(math.rad(Timer))))
          gcolour = 127.5 + (127.5*(math.cos(math.rad(Timer))))
          SetBackdropColour(rcolour,gcolour,0)
       coroutine.yield()

       -- Determines Send Distance
       for i=1,11 do
           Roid = GetAsteroid((i-1))
           nSlots = Roid:FreeSlots()
           nTrees = Roid:GetNumTrees() 
           tTrees = nTrees + nSlots
           Roid.SendDistance = (nTrees/tTrees)*(2500 + (2499 *(math.cos(math.rad(Timer)))))

              if GetAI(2):OwnsAsteroidID(Roid.ID) == true then
                 Roid.SendDistance = 3000
              end
       end

       -- Determines Functionality
           if (math.cos(math.rad(Timer))) < 0 then 
              SetDysonTreeButtonAvailable(false)
           end
       

           if (math.cos(math.rad(Timer))) < 0 then 
              SetDefenseTreeButtonAvailable(false)
           end
       
           if (math.cos(math.rad(Timer))) > 0 then 
              SetDysonTreeButtonAvailable(true)
           end
       
           if (math.cos(math.rad(Timer))) > 0 then 
              SetDefenseTreeButtonAvailable(true)
           end

        -- Reinforcements
           if (math.cos(math.rad(Timer))) == -1 then
              GetAsteroid(11):AddSeedlings(50)
           end  

        -- Check for end conditions
           if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
              Pause()
              MessageBox("You have been defeated")
              WaitDialog()
              Unpause()
              
              Quit(false)
           end

           if GetAI(2):GetNumOwnedAsteroids() == 0 then
              Pause()
              MessageBox("You are victorious!")
              WaitDialog()
              Unpause()

              Quit(true)
           end            
    end

end

