--------------------------------------
-- Map by njursten (mail is nickname at home.se).
-- Feel free to modify.
--------------------------------------

function LevelSetup()
   SetBackdropColour(252,222,200)

   Globals.Agents.MaxSpeed = 600
   Globals.Agents.MinSpeed = 400

   Globals.AI.MinAttackTime = 5
   Globals.AI.MaxAttackTime = 20
   Globals.AI.MinGatherTime = 10
   Globals.AI.MaxGatherTime = 20
   Globals.AI.MinScoutTime = 1
   Globals.AI.MaxScoutTime = 5
   Globals.AI.GraceTimer = 0

   Globals.G.EnemyFactionsMin = 0
   Globals.G.EnemyFactionsMax = 0
   Globals.G.MinAsteroidSeparation = 1350
   Globals.G.MaxAsteroidNeighbourDist = 5500

   Globals.Structures.FlowerProbability = (0.3)

   Globals.G.GreysProbability = 0
   Globals.G.Asteroids = 0

   x = 0
   dx = -1
   for y = 0,3 do
      for x = (3 - 3*dx)/2,(3 + 3*dx)/2,dx do
	 a = AddAsteroidWithAttribs(x*1500,
				    y*3000,
				    0.7,0.7,0.7)
	 a:SetRadius(200)
	 a.SendDistance = 1500;
	 a.Moveable = false
	 a.owner = 2
      end

      a = AddAsteroidWithAttribs(x,
				 y*3000 + 1500,
				 0.7,0.7,0.7)
      a.owner = 2
      a:SetRadius(200)
      a.SendDistance = 1500;
      a.Moveable = false

      x = 4500 - x
      dx = -dx
   end

   a.owner = 1
   a:AddSeedlings(100)

   EnemyBase = GetAsteroid(0)
   YourBase = GetAsteroid(4*5 - 1)

   SetCameraPositionToAsteroidID(0)
   SetCameraZoomNow(10)

   for id = 0,(4*5 - 1) do
      GetAsteroid(id):Reveal(1)
   end
end


function LevelLogic()
   Pause()
   MessageBox("Your goal is at the top. Be quick though, your enemy seems to have found some new way to spawn more seedlings.")
   WaitDialog()
   Unpause()

   -- AI parameters
   EnemyAI = GetAI(2)

   EnemyAI.MinScoutTime = 2
   EnemyAI.MaxScoutTime = 3
   EnemyAI.MinBattleAnalysisTime = 3
   EnemyAI.MaxBattleAnalysisTime = 5
   EnemyAI.MinPlantTime = 2
   EnemyAI.MaxPlantTime = 3

   EnemyAI.Cowardice = 0.4
   EnemyAI.MinExpansionForce = 15
   EnemyAI.BattleSavvy = 0.4
   EnemyAI.ReinforcementGreed = 0.8
   EnemyAI.AidEnthusiasm = 0.3
--   EnemyAI.RecognisableThreatProportion = 0.7
   EnemyAI.GreedyExpansion = 0.8
   EnemyAI.ExpandBlind = 0.2

   -------

   win = false
   lose = false

   ReinforcementTick = 15
   AITick = 1
   AITickLong = 10
   AILongRatio = 10

   RatioTicker = 0
   NextReinforcement = GetGameTime() + ReinforcementTick
   NextAITick = GetGameTime() + AITick

   while GameRunning() do
      if GetGameTime() > NextReinforcement then
	 for id = 0,(4*5 - 1) do
	    Curr = GetAsteroid(id)

	    if (Curr.Owner ~= 1) then
	       Curr:AddSeedlings(1)
	    end
	 end

	 NextReinforcement = NextReinforcement + ReinforcementTick
      end

      if GetGameTime() > NextAITick then
	 AIAction()
	 RatioTicker = RatioTicker + 1

	 if RatioTicker > AILongRatio then
	    RatioTicker = 0
	    NextAITick = NextAITick + AITickLong
	 else
	    NextAITick = NextAITick + AITick
	 end
      end

      if win then
	 Pause()
	 MessageBox("You've won. Congratulations!")
	 WaitDialog()
	 Unpause()
	 Quit(win)
      elseif lose then
	 Pause()
	 MessageBox("You've lost. Better luck next time.")
	 WaitDialog()
	 Unpause()
	 Quit(win)
      end

      coroutine.yield()
   end
end

function AIAction()
   Target = 0
   for id = 0,(4*5 - 2) do
      if GetAsteroid(id).owner == 1 then
	 break
      else
	 Target = id
      end
   end

--   if Target > 3 then
--      Target = Target - 1
--   end

   if Target > 0 then
      for id = 0,(Target-2) do
	 -- A small change to skip the movement order for a certain asteroid
	 if math.random() < 0.5 then
	    C = GetAsteroid(id)
	    C:SendSeedlingsToTarget(2, C:GetNumSeedlings(2)*3/4,
				    GetAsteroid(id+1))
	 end
      end

      -- Only send to the very last asteroid if we'll be more than the enemy.
      C = GetAsteroid(Target-1)
      T = GetAsteroid(Target)
      if T:GetNumSeedlings(1) <
	 C:GetNumSeedlings(2) +
	 T:GetNumSeedlings(2) then
	 C:SendSeedlingsToTarget(2, C:GetNumSeedlings(2), T)
      end
   end
end

function OnAsteroidTaken(id, owner)
   if id == EnemyBase.ID and owner == 1 then
      win = true
   elseif id == YourBase.ID then
      lose = true
   end
end
