function LevelSetup()

	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.Asteroids.MinSendDistance=0.5
	Globals.Asteroids.MaxSendDistance=0.5
	Globals.Asteroids.CoreHealthPower=1
	Globals.Mines.MinSpeed=700
	Globals.Mines.MaxSpeed=700
	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(1)
	Globals.G.GreysProbability=1
	Globals.AI.GraceTimer=(99999)
	Globals.Structures.FlowerProbability=(0.1)
	Globals.Asteroids.MinCoreHealth=350
	Globals.Asteroids.MaxCoreHealth=1000
	Globals.Asteroids.SpawnCap=100
	Globals.Asteroids.SeedlingCap=2750
	Globals.Agents.MaxSpeed=1000
	Globals.Agents.MinSpeed=400
	Globals.Mines.MinHealth=70
	Globals.Mines.MaxHealth=70
	Globals.Structures.LevelTime1=20
	Globals.Structures.LevelTime2=30
	Globals.Structures.LevelTime3=40
	Globals.Structures.LevelTime4=60
	Globals.Structures.SpawnTime1=10     --30
	Globals.Structures.SpawnTime2=15    --30
	Globals.Structures.SpawnTime3=20     --25
	Globals.Structures.SpawnTime4=30     --20
	Globals.Mines.NumberOfLasers=1
	Globals.P.AutoHide=1
	Globals.P.BGFade=1



	t = 1600

	coordx = {}
	coordy = {}
	roidradius = {}
	
	roidnumber = 69
	

	for i=0,roidnumber do 

		x = math.cos(t) * t * -1
		y = math.sin(t) * t

		
		roidradius[i] = 125 + ((i / roidnumber) * math.random(600,1500))
	
		if i ~= 0 then
			
			e = math.random(roidradius[i] / 10,roidradius[i]) / 1625
			
			s = math.random(roidradius[i] / 10,roidradius[i]) / 1625
			
			sp = math.random(roidradius[i] / 10,roidradius[i]) / 1625
			
			
			
		else
			e = 0.14
			s = 0.12
			sp = 0.32
		end

		a = AddAsteroidWithAttribs(x,y,e,s,sp)
		a.Owner = 0
		a.TreeCap = 3
		a:SetRadius(roidradius[i])
		
		

		
		
		a.Moveable = False
		
	
	
		coordx[i] = x
		coordy[i] = y
	
	
	
		t = t + 294.5
		
		a.SendDistance = (roidradius[i] * 7) + 1500
		
		
	end

	
	
	

	
	for i = 1,roidnumber do
		GetAsteroid(i):Hide(1)
	end
	
	
	-- Add the AI players
	
	a = GetAsteroid(69)
	a.owner = 2
	a:AddSeedlings(10)
	a.owner = 0
	a:Reveal(1)
	
	
	a = GetAsteroid(65)
	a.owner = 6
	a:AddSeedlings(180,6,1,1,1)
	
	
	
	
	-- add a spacer asteroid
		a = AddAsteroidWithAttribs(20000,20000,0,0,0)
		a.Owner = 0
		a.radius = 0
	
		viewdistance = AddAsteroidWithAttribs(GetAsteroid(69).position.x,GetAsteroid(69).position.y,0,0,0)
		viewdistance.Moveable = false
		viewdistance.SendDistance = 3000
		viewdistance.Owner = 1
		viewdistance.radius = 0
		viewdistance:Reveal(1)
		
		
		
	SetCameraZoomNow(0.01)


	AIinit()

	
	-- Add the human player
	
	minecontrol = AddAsteroidWithAttribs(-400,-20000,0,0,1)
	minecontrol.Moveable = false
	minecontrol.owner = 2
	minecontrol.radius = 0
	minecontrol.Name = "Mine Control"
	minecontrol.TreeCap = 0
	minecontrol.MaxCoreHealth = 420
	minecontrol.SendDistance = 50
	minecontrol:Reveal(1)
	playermine = minecontrol:AddMine()
	playermine:GrowToMax()
	destinationx = -400
	destinationy = -20000
	energy = 0.1
	playermine.Attribs.Energy = energy
	lasers = 1
	hotsistersactive = false
	hotsisterstimer = 0
	lives = 3
	deathtime = 0
	res = false
	restimer = 0
	redlevel = 0
	levelledhere = {}
	SetBackdropColour(0,0,0)
	revtime = 0
	revroid = roidnumber
	disabletimer = GetGameTime() + 10
	respawntimer = 0
	died = false
	minepresent = {}
	latchmessage = true
	bonusmines = {}
	rewardtimer = {}
	for i = 0,roidnumber do
		if math.random(1,3) ~= 1 then
			levelledhere[i] = false
		else
			levelledhere[i] = true
		end
	end
	levelledhere[69] = true
	GetAsteroid(69).Name = "Fluffy"
	laserrange = 200
	renewflashytimer = 0
	Globals.Mines.LaserRange = laserrange

	vig = 255
	SetVignetteAlpha(vig)
	
end

function OnMouseLeftDown(x,y)
	
	if disabletimer < GetGameTime() then
		destinationx = x
		destinationy = y
		playermine:SendTo(minecontrol)
	end
end

function LevelDraw()

	r = (math.sin(GetGameTime() / 3) + 1) / 2
	g = (math.sin(GetGameTime() / 6) + 1) / 2
	b = (math.sin(GetGameTime() / 9) + 1) / 2
	
	if disabletimer > GetGameTime() then
		a = (math.sin(GetGameTime() * 25) + 1) / 2
		size = 50 * (1 / GetCameraScale())
	else
		a = (math.sin(GetGameTime() * 7) + 1) / 2 + 0.3
		size = 30 * (1 / GetCameraScale())
	end
	
	
	
	DrawSprite(1, destinationx,destinationy, r,g,b,a, size)

	
	flashy = ((math.sin(GetGameTime() * 20) + 1) / 2) - 0.6
	for i = 0,roidnumber do
	
		if levelledhere[i] == false and GetAsteroid(i).owner == 2 then
			DrawSprite(5,GetAsteroid(i).position.x,GetAsteroid(i).position.y,flashy,flashy,flashy,flashy,GetAsteroid(i).radius)
		end
	
	end

end

function ScreenDraw()

	
	if playermine ~= nil then
		green = (playermine.CurrentEnergy / playermine.MaxEnergy) + 0.2
		red = 1.4 - green
		blue = 0.2
		
		
	
		if disabletimer > GetGameTime() then
			healthalpha = (math.sin(GetGameTime() * 25) + 1) / 2
		else
			healthalpha = math.sin(GetGameTime() * 12) + (playermine.CurrentEnergy / playermine.MaxEnergy) + 1.4
		end
	
		DrawLine(20,20,20,20 + (playermine.MaxEnergy / 2.5),0.5,0.5,0.5,healthalpha - 0.1,0.5,0.5,0.5,healthalpha - 0.1,16)
		DrawLine(20,20,20,20 + (playermine.CurrentEnergy / 2.5),red,blue,green,healthalpha,red,blue,green,healthalpha,16)
		
	end

end

function MineMechanics()
	-- The AI engine needs to know if there is a mine (the player mine) present at the asteroid, so init an array so that this can be checked for each asteroid.
	for i = 0,roidnumber do
		minepresent[i] = false
	end

	-- x and y are being updated every time the player left clicks.  Move the mine control asteroid to wherever they clicked last.
	minecontrol:MoveTo(destinationx,destinationy)

	
	-- fade the background up to red if the mine is at low health
	if playermine ~= nil then
		if playermine.Active == true then
			redlevel = 1 - playermine.CurrentEnergy / playermine.MaxEnergy
			redlevel = redlevel - 0.6
			if redlevel > 0 then
				redlevel = redlevel * 255
			end
		end
	end

	SetBackdropColour(redlevel,0,0)
	
	if redlevel > 0 then
		redlevel = redlevel - 1
	end
	
	
	
	-- the disable timer prevents any rewards or anything from happening, in case the player has recently (re)spawned.
	if disabletimer < GetGameTime() then
		-- init a variable called deployment.  this will be used to send the mine to an asteroid the player has selected, so that it can attack.
		deployment = false
		
		-- check each of the asteroids...
		for i = 0,roidnumber do
			-- if the player has selected this asteroid then..
			if math.sqrt((destinationx - GetAsteroid(i).position.x)^2 + (destinationy - GetAsteroid(i).position.y)^2) < GetAsteroid(i).radius + 200 and GetAsteroid(i) ~= minecontrol then
				-- send the mine to the asteroid - we are now deploying
				playermine:SendTo(GetAsteroid(i))
				if hotsistersactive == true then
				for eh = 0,100 do
					if bonusmines[eh] ~= nil then
						bonusmines[eh]:SendTo(GetAsteroid(i))
					end
				end	
			end
				deployment = true
				
				-- if the asteroid called minecontrol is inside the selected aseroid, then
				if math.sqrt((minecontrol.position.x - GetAsteroid(i).position.x)^2 + (minecontrol.position.y - GetAsteroid(i).position.y)^2) < GetAsteroid(i).radius then
				
				
					-- *** MOVE MINECONTROL OUT OF THE SELECTED ASTEROID ***
					xdiff = minecontrol.position.x - GetAsteroid(i).position.x
					ydiff = minecontrol.position.y - GetAsteroid(i).position.y
					
					-- find the length of the vector..
					vectorlength = math.sqrt(xdiff^2 + ydiff^2)
					-- divide the vectors by the length to normalise
					NormalisedVectorX = xdiff / vectorlength
					NormalisedVectorY = ydiff / vectorlength
					-- these normalised vectors are values between 0 and 1 that give us a direction :>
					
					-- move minecontrol to the correct point
					
					destinationx = GetAsteroid(i).position.x + (GetAsteroid(i).radius * NormalisedVectorX * 1.1)
					destinationy = GetAsteroid(i).position.y + (GetAsteroid(i).radius * NormalisedVectorY * 1.1)
					minecontrol:MoveTo(destinationx,destinationy)
					
					
					
				
				end
			end
			
			-- End of deployment check and mine deployment
			
			
			-- if the mine is at close range to the selected asteroid then
			if GetAsteroid(i):DistanceSquaredTo(playermine) < (GetAsteroid(i).radius + 200)^2 then
				-- check if the asteroid belongs to empire 2 (the player's empire)
				if GetAsteroid(i).owner == 2 then
					-- yes, it's the player's asteroid
					
					-- Check the levelledhere array to see if the player has received a reward here before
					if levelledhere[i] == false and rewardtimer[i] < GetGameTime() and gamewon == false then
						-- they haven't so it's time to give a reward
						levelledhere[i] = true
						if GetEmpire(2):GetNumOwnedAsteroids() < 8 then
							-- it's still the early game.  no multimines allowed yet.
							reward = math.random(1,94)
						else
							reward = math.random(1,100)
						end
						
						
						if reward <= 2 then
							-- extra life!
							lives = lives + 1
							Pause()
							if lives == 1 then
								MessageBox("Extra life! " .. lives .. " life remaining.")
							else
								MessageBox("Extra life! " .. lives .. " lives remaining.")
							end
							WaitDialog()
							Unpause()
							break
						end
						
						if reward >= 3 and reward <= 26 then
							-- increase laser range !
							if laserrange < 800 then
								-- record the current coordinates
								oldx = playermine.position.x
								oldy = playermine.position.y
								-- destroy the old mine
								playermine.Active = false
								-- restore the mine's position variables to minecontrol's position variables
								destinationx = oldx
								destinationy = oldy
								-- move minecontrol to the position of the old mine
								minecontrol:MoveTo(oldx,oldy)
								-- Set the new laser range
								laserrange = laserrange + 75
								Globals.Mines.LaserRange = laserrange
								-- add a new mine to minecontrol
								playermine = minecontrol:AddMine(2)
								-- restore the mine's old stats
								playermine.Attribs.Energy = energy
								playermine.Attribs.Strength = energy
								-- grow the mine to full
								playermine:GrowToMax()
								-- Inform the player
								Pause()
								if laserrange < 800 then
									MessageBox("Laser Range: " .. laserrange .. "!")
								elseif laserrange == 800 then
									MessageBox("MAX Laser Range:" .. laserrange .. "!!")
								end
								WaitDialog()
								Unpause()						
								-- don't do anything else on this pass
								break
							else
								-- laser range already maxed.  try again
								levelledhere[i] = false
							end
						end
						
						
						
						if reward >= 27 and reward <= 56 then
							-- INCREASED STATS BY 10%
							-- if the player has less than max energy stat then
							if energy < 0.99 then
								
								-- increase the enery and strength of the mine by 0.1
								energy = energy + 0.1
								-- convert the current energy of the mine into a percentage, and display it to the player
								currentstats = energy * 100
								-- alert the player that they have been rewarded
								Pause()
								if energy == 1 then
									MessageBox("MAX Health and Damage: " .. currentstats .. "%!!")
								else
									MessageBox("Health and Damage: " .. currentstats .. "%")
								end
								WaitDialog()
								Unpause()
								-- record the current coordinates
								oldx = playermine.position.x
								oldy = playermine.position.y
								-- destroy the old mine
								playermine.Active = false
								-- set the new health for mines
								Globals.Mines.MinHealth = (energy * (energy * 1000)) + 100
								Globals.Mines.MaxHealth = (energy * (energy * 1000)) + 100
								-- restore the mine's position variables to minecontrol's position variables
								destinationx = oldx
								destinationy = oldy
								-- move minecontrol to the position of the old mine
								minecontrol:MoveTo(oldx,oldy)
								-- add a new mine to minecontrol
								playermine = minecontrol:AddMine(2)
								-- restore the mine's old stats
								playermine.Attribs.Energy = energy
								playermine.Attribs.Strength = energy
								-- grow the mine to full
								playermine:GrowToMax()
								-- don't do anything else on this pass
								break
							else
								-- already maxed.  try again
								levelledhere[i] = false
							end
						end
						
						if reward >= 57 and reward <= 86 then
							-- INCREASE NUMBER OF LASERS
							-- the player is only allowed up to 10 lasers, so only run the reward code if lasers is less than 10
							if lasers < 10 then
								-- increment the lasers counter
								lasers = lasers + 1
								Pause()
								if lasers == 10 then
									MessageBox("MAX Lasers: " .. lasers .. "!!")
								else
									MessageBox("Upgrade to " .. lasers .. " lasers!!")
								end
								WaitDialog()
								Unpause()
								-- store the settings for the current mine
								oldx = playermine.position.x
								oldy = playermine.position.y
								-- destroy the old mine
								playermine.Active = false
								-- set the number of lasers to value of the lasers counter
								Globals.Mines.NumberOfLasers=lasers
								-- restore the mine's position variables to minecontrol's position variables
								destinationx = oldx
								destinationy = oldy
								-- move minecontrol to the position of the old mine
								minecontrol:MoveTo(oldx,oldy)
								-- add a new mine to minecontrol
								playermine = minecontrol:AddMine(2)
								-- restore the mine's old stats
								playermine.Attribs.Energy = energy
								playermine.Attribs.Strength = energy
								-- grow the mine to full
								playermine:GrowToMax()
								-- move the mine to the position of the old mine
								-- *********** THESE LINES SUSPECTED OF CAUSING A CRASH: INVESTIGATE!
								--playermine.position.x = oldx
								--playermine.position.y = oldy
								--MessageBox("Well, it didn't cause a crash..")
								-- let the player know they just got a lasers uprade
								
								-- don't do anything else on this pass
								break
							else
								-- already maxed, try again
								levelledhere[i] = false
							end
						end
						
						if reward >= 87 and reward <= 94 then
							-- calculate how many seeds the player gets
							seedreward = math.floor(GetGameTime() / 115) + 10
							-- alert the player to their new seedlings
							Pause()
							MessageBox(seedreward .. " super seedlings!")
							WaitDialog()
							Unpause()
							-- SUPER SEEDLINGS
							GetAsteroid(i):AddSuperSeedlings(seedreward,2,1,1,1)
							-- don't do anything else on this pass
							break
						end
						
						if reward >= 95 and hotsistersactive == false then
							-- move minecontrol to playermine
							minecontrol:MoveTo(playermine.position.x,playermine.position.y)
							
							hotsisterstimer = GetGameTime() + 60
							hotsistersactive = true
							playermine.Active = false
							
							if reward >= 95 and reward <= 97 then
								-- add 15 1-laser mines
								Globals.Mines.NumberOfLasers=1
								numberofsisters = 14
								for i = 0,14 do
									bonusmines[i] = minecontrol:AddMine(2)
									bonusmines[i]:GrowToMax()
									bonusmines[i].Attribs.Energy = energy
									bonusmines[i].Attribs.Strength = energy
								end
							elseif reward == 98 or reward == 99 then
								-- add 8 2-laser mines
								Globals.Mines.NumberOfLasers=2
								numberofsisters = 7
								for i = 0,7 do
									bonusmines[i] = minecontrol:AddMine(2)
									bonusmines[i]:GrowToMax()
									bonusmines[i].Attribs.Energy = energy
									bonusmines[i].Attribs.Strength = energy
								end
							elseif reward == 100 then
								-- add 4 5-laser mines
								Globals.Mines.NumberOfLasers=5
								numberofsisters = 3
								for i = 0,3 do
									bonusmines[i] = minecontrol:AddMine(2)
									bonusmines[i]:GrowToMax()
									bonusmines[i].Attribs.Energy = energy
									bonusmines[i].Attribs.Strength = energy
								end
							end
							Globals.Mines.NumberOfLasers=lasers
							Pause()
							MessageBox("Multimines for 60 seconds!!")
							WaitDialog()
							Unpause()
							playermine = minecontrol:AddMine(2)
							playermine.Attribs.Energy = energy
							playermine.Attribs.Strength = energy
							playermine:GrowToMax()
						elseif reward >= 95 and hotsistersactive == true then
							-- hot sisters already active.  try again.
							levelledhere[i] = false
						end
					end
					
					-- *** HEALING CODE ***
					
					-- if the mine's health is lower than full, AND there are no enemy seedlings here, then
					if playermine.CurrentEnergy < playermine.MaxEnergy and GetAsteroid(i):GetNumSeedlings() - GetAsteroid(i):GetNumSeedlings(2) == 0 then
						-- store the mine's current settings
						--[[Pause()
						MessageBox("Healing")
						WaitDialog()
						Unpause()--]]
						
						oldx = playermine.position.x
						oldy = playermine.position.y
						-- destroy the old mine
						playermine.Active = false
						-- restore the old position of the playermine to minecontrol's position variables
						destinationx = oldx
						destinationy = oldy
						-- move the minecontrol asteroid to the new location
						minecontrol:MoveTo(oldx,oldy)
						-- now add a brand new mine
						playermine = minecontrol:AddMine(2)
						-- set its stats to be like the one we just killed
						playermine.Attribs.Energy = energy
						playermine.Attribs.Strength = energy
						-- grow the mine to full instantly
						playermine:GrowToMax()
						-- move the mine to the position of the old mine
						playermine.position.x = oldx
						playermine.position.y = oldy
						-- don't do anything else on this pass
						break
					end
					
					-- *** END HEALING CODE ***
					
				elseif GetAsteroid(i).owner ~= 2 and GetAsteroid(i).owner ~= 0 then
					-- *** ENEMY ASTEROID!!  Alert the AI engine.  The player is attacking.
					minepresent[i] = true
					
				end
				
			end
		
			-- finally, is this asteroid visible to empire 2?  If so, show it to the player too
			if GetAsteroid(i):IsVisible(2) == true then
				GetAsteroid(i):Reveal(1)
			end
		end
		-- end of the check on all asteroids.
	

		-- if the mine hasn't just been sent to an asteroid on a deployment (from being clicked on this cycle) then
		if deployment == false then
			-- try to send the mine back to mine control.  This will be activated CONSTANTLY but the mine only needs to move out for a second to engage, so this should just make the mine always follow minecontrol.
			playermine:SendTo(minecontrol)
			if hotsistersactive == true then
				for i = 0,300 do
					if bonusmines[i] ~= nil then
						bonusmines[i]:SendTo(minecontrol)
					end
				end	
			end
		end
		
	end
	-- That's the end of the code that will only be run if disabletimer is engaged
	

	
	-- if the player's mine is dead, then
	if playermine.Active == false and died == false and res == false and lives == 0 then
		-- register the death
		died = true
		-- set a respawn timer starting now and ending in 30 sec
		amountoftime = 30 + (GetGameTime() / 100)
		respawntimer = GetGameTime() + amountoftime
		deathtime = GetGameTime() + 5
		-- prepare the message latch
		latchmessage = false
		-- set a disabletimer so that the player can't use the mine for rewards until it's grown a bit
		-- do it NOW so that the player doesn't spam the button and set the mine location to somewhere erroneous
		disabletimer = GetGameTime() + amountoftime + 10
		-- change the location of the asteroid back to the original location now.
		destinationx = -400
		destinationy = -20000
		-- move the minecontrol asteroid back to asteroid 69's position
		minecontrol:MoveTo(destinationx,destinationy)
		-- finally, reset the rewards for some of the asteroids so that the player can go around collecting them again.
		for i = 0,roidnumber do
			chance = math.random(1,math.ceil(GetEmpire(2):GetNumOwnedAsteroids() / 4))
			if chance == 1 then
				levelledhere[i] = false
			else
				levelledhere[i] = true
			end
		end
	elseif playermine.Active == false and died == false and lives > 0 then
		-- the player has died, but they have an extra life!  subtract 1 life and res them
		died = true
		lives = lives - 1
		restimer = GetGameTime() + 3
		res = true
		disabletimer = GetGameTime() + 3.1
		destinationx = -400
		destinationy = -20000
		minecontrol:MoveTo(destinationx,destinationy)

	end
	
	if res == true then
	
		if restimer < GetGameTime() then
		
			res = false
			died = false
			destinationx = -400
			destinationy = -20000
			minecontrol:MoveTo(destinationx,destinationy)
			playermine = minecontrol:AddMine(2)
			playermine:GrowToMax()
			playermine.Attribs.Energy = energy
			playermine.Attribs.Strength = energy
			Pause()
			if lives == 0 then
				MessageBox("You resurrected. " .. lives .. " lives remaining.  Careful now!")
			elseif lives == 1 then
				MessageBox("You resurrected. " .. lives .. " life remaining.")
			else
				MessageBox("You resurrected. " .. lives .. " lives remaining.")
			end
			WaitDialog()
			Unpause()
			-- move the camera there too
			SetCameraTargetToAsteroidID(minecontrol.ID)
		end
	
	end
	
	-- if 5 seconds has passed since the death, and the message latch is false, then
	if GetGameTime() > deathtime and latchmessage == false then
		-- set the latch message to true to prevent multiple popups
		latchmessage = true
		-- let the player know they'll be respawning
		MessageBox("Respawning in " .. math.floor(amountoftime - 5) .. " seconds.")
	end
	
	
	-- if the player has died and the required time has passed then
	if died == true and respawntimer < GetGameTime() and res == false then
		-- they are coming back to life now - unregister the death
		died = false
		-- set the energy and lasers back to defaults again
		energy = 0.1
		lasers = 1
		laserrange = 200
		Globals.Mines.LaserRange = laserrange
		Globals.Mines.NumberOfLasers=lasers
		Globals.Mines.MinHealth = (energy * (energy * 1000)) + 100
		Globals.Mines.MaxHealth = (energy * (energy * 1000)) + 100
		destinationx = -400
		destinationy = -20000
		minecontrol:MoveTo(destinationx,destinationy)
		
		-- move the camera there too
		SetCameraTargetToAsteroidID(minecontrol.ID)
		-- add a new mine
		playermine = minecontrol:AddMine(2)
		
		

	end
	
	if hotsistersactive == true then
		if hotsisterstimer < GetGameTime() then
			-- ok game's up, deactive hot sisters
			hotsistersactive = false

			-- delete all mines except for playermine
			for i = 0,numberofsisters do
				bonusmines[i].Active = false
			end
		end
	end
	
	

	
	if GetGameTime() > 600 then
		if renewflashytimer < GetGameTime() then
			renewflashytimer = GetGameTime() + 120
			levelledhere[GetRandomAsteroid().ID] = false
		end
	end
	
	
	-- check if enemy empire is losing...
	if GetEmpire(6):GetNumOwnedAsteroids() < 17 and GetEmpire(2):GetNumOwnedAsteroids() > 35 then
		-- the player is going to win soon at this rate.  time to spice things up a bit...
		finalbattle = GetRandomAsteroid()
		
		if finalbattle.owner == 6 then
			
			if GetEmpire(6):GetNumOwnedAsteroids() < 5 then
			-- add some seedling
				
			elseif GetEmpire(6):GetNumOwnedAsteroids() < 12 then	
				Globals.Asteroids.SeedlingCap=3250
				finalbattle:AddSuperSeedlings(1,6,0.2,0.1,0.5)
			else
				Globals.Asteroids.SeedlingCap=3000
				if math.random(1,5) <= 3 then
					finalbattle:AddSeedlings(1,6,0.45,0.2,1)
				end
			end
		end
		
		if GetEmpire(6):GetNumOwnedAsteroids() < 5 and GetEmpire(6):GetNumOwnedAsteroids() ~= 0 then
			Globals.Asteroids.SeedlingCap=3500
			if math.random(1,30) == 1 then
				GetEmpire(6):GetRandomAsteroid():AddSuperSeedlings(1,6,1,1,1)
			end
		end
	end
	
end

function LevelLogic()

	
	
	SetCameraZoom(4)


	
	minecontrol.SendDistance = 50
	SetCameraPositionToAsteroidID(minecontrol.ID)
	addseeds = 0
	vigtimer = 0
	gamewon = false
	
	
	
	while GameRunning() do
	
		MineMechanics()
		
		if GetEmpire(2):GetNumOwnedAsteroids() == 2 then
			if vigtimer == 0 then
				vigtimer = GetGameTime() + 5
			end
			if vigtimer < GetGameTime() then
				if vig > 0 then
					vig = vig - 1
					SetVignetteAlpha(vig)
				end
			end
		end
		
		
		if GetAsteroid(69):GetNumSeedlings(0) > 0 then
			GetAsteroid(69):RemoveSeedlings(0,1)
		end
	
		if viewdistance.SendDistance < GetAsteroid(69).SendDistance + 500 then
			viewdistance.SendDistance = viewdistance.SendDistance + 7
		end
		
		if GetCameraZoom() > 20 then
			SetCameraZoom(14)
		end
		
		if addseeds < 50 and math.random(1,10) == 10 then
			addseeds = addseeds + 1
			GetAsteroid(69):AddSuperSeedlings(1,2,1,1,1)
		end
		
		if GetEmpire(2):GetNumOwnedAsteroids() == 1 and GetGameTime() > 60 then
		

			Quit(false)
		
		end
	
		if GetEmpire(2):GetNumOwnedAsteroids() == roidnumber + 2 and gamewon == false then
		
			Pause()
			MessageBox("Congratulations, you pwned them!  With your laz0rz.")
			WaitDialog()
			Unpause()
			gamewon = true
		end

		if gamewon == true then
			vig = vig + 1
			SetVignetteAlpha(vig)
			if vig >= 255 then
				Quit(true)
			end
		end
		
		
		
		InfectedAIEngine()
	
		coroutine.yield()
	end
	
end


function AIinit()
	-- *** INFECTED AI V2.3 : INIT ***
	-- *** AUTHOR: ANNIKK.EXE ***
	-- *** EMAIL: annikk [dot] exe [at] gmail [dot] com ***
	
	Globals.AI.GraceTimer=(99999)
	
	-- Number of times the engine is run per While loop:
	numberofiterations = 0
	-- Set to 0 for very large maps. (50 asteroids+)
	-- Set to 2-4 for small maps for quicker AI response.
	
	metric = {}
	currentowner = {}
	
	for i = 0,200 do
		metric[i] = 500
	end
	

	-- *** END INFECTED AI : INIT ***
end


function InfectedAIEngine()
	-- *** INFECTED AI V2.3 : ENGINE ***
	-- Author: ANNIKK.EXE [at] GMAIL [dot] COM
	numberofasteroids = -1
	neighbours = {}

	for i = 0, 200 do
		if GetAsteroid(i) ~= nil then
			if GetAsteroid(i).radius > 10 then
				numberofasteroids = numberofasteroids + 1
			end
		end
	end

	-- now the variable called "numberofasteroids" accurately represents the number of playable asteroids on the field.

	for iterations = 0,numberofiterations do
	
		-- Select an asteroid for checking.
		checkedroid = GetAsteroid(math.random(0,numberofasteroids))

		-- Record the current asteroid owner
		changedowner = false
		
		if currentowner[checkedroid.id] ~= nil then
			if currentowner[checkedroid.id] ~= checkedroid.owner then
				currentowner[checkedroid.id] = checkedroid.owner
				changedowner = true
			end
		else
			currentowner[checkedroid.id] = checkedroid.owner
		end
	
		tree = nil
		flower = nil
	
		-- flower check !
		tree = checkedroid:GetRandomDysonTree()
		
		if tree ~= nil then
			flower = tree:GetSuperSeedling()
		end
		
		if checkedroid.owner > 1 and flower ~= nil then
			flower:Pluck()
		end
		
		flower = checkedroid:GetFlower(checkedroid.owner)
		
		if checkedroid.owner > 1 and flower ~= nil then
			flower:PlantOnRandomDysonTree()
		end

		-- calculate which asteroids are a neighbour to checkedroid
		numberofneighbours = -1

		for i = 0,numberofasteroids do
			
			length = GetAsteroid(i).position.x - checkedroid.position.x
			height = GetAsteroid(i).position.y - checkedroid.position.y
			
			distancetoroid = math.sqrt((length * length) + (height * height))
			distancetoroid = distancetoroid - GetAsteroid(i).Radius
			
			if distancetoroid < checkedroid.SendDistance then
				-- this asteroid is in range.  Add it to the neighbours list, and increment the neighbour count by one.  ALSO ADDS SELF AS NEIGHBOUR!  But we trap for this in the Metric Update section.
				numberofneighbours = numberofneighbours + 1
				neighbours[numberofneighbours] = GetAsteroid(i)
			end
		end

		-- Metric update
		-- did we update from our own status?
		updated = false

		-- are we under attack?  if so set metric 0
		if checkedroid.owner ~= 1 and checkedroid.owner ~= 0 then
			
			if (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner)) > (checkedroid:GetNumTrees() * 5) or minepresent[checkedroid.ID] == true then
				
				-- ok well we own this asteroid, and there are more enemy seeds here than our seeds (or there's a player mine here).  Now, we DO have at least 1 tree worth defending here, right?
				if checkedroid:GetNumTrees() > 0 then
					-- ok, we're under attack!  METRIC 0!
					metric[checkedroid.ID] = 0
					updated = true
				
				end
			end
		end
		
		-- are we maxed on trees?  if not, set metric 100
		-- (make sure we don't run this if we are under attack!)
		if updated == false then

			if checkedroid:GetNumTrees() < checkedroid.TreeCap then
				-- we don't have max trees here yet.  Metric 100!
				metric[checkedroid.ID] = 100
				updated = true
			end
			
		end
		-- Not under attack, maxed on trees, and ready to contribute to the empire.
		-- Check the status of our neighbours first before trying to become a gather point.
		-- only run this part of the code if we didn't get our metric from our own status
		if updated == false then
			-- are we a suitable gather point?
			
			enemydetected = false
			frienddetected = false
			gatherpointdetected = false
			lowermetricsnearby = false
		
			for i = 0, numberofneighbours do
				
				
				-- check that we're not examining ourself.
				if neighbours[i] ~= checkedroid then
		
					if neighbours[i].owner == checkedroid.owner then
						-- this asteroid is friendly to us
						frienddetected = true
					end
				
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i].owner ~= 0 and neighbours[i]:GetNumTrees() > 0 then
						-- this asteroid doesn't belong to us or player 0, and has at least 1 tree.  It must be an enemy roid.
						enemydetected = true
					end
					
					numberofenemies = neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)
				
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumTrees() == 0 and numberofenemies > 0 then
						-- this asteroid doesn't belong to us, has no trees on it, but has enemy seedlings on it.  Treat it as enemy.
						enemydetected = true
					end
					
					if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].ID] == 200 then
						-- this asteroid is friendly to us, and is a gather point.
						gatherpointdetected = true
					end
				
					if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] < 200 then
						-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
						lowermetricsnearby = true
					end
					
					if neighbours[i].owner == 0 and metric[neighbours[i].id] < 200 then
						-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
						lowermetricsnearby = true
					end
				end
			
			end
			
			if enemydetected == true and frienddetected == true and gatherpointdetected == false and lowermetricsnearby == false then
				-- the conditions are right for me to become a gather point.
				metric[checkedroid.id] = 200
			elseif changedowner == true then
				-- the asteroid just became mine.  insta-gather point please!
				metric[checkedroid.id] = 200
			end

			-- Find the lowest metric among my neighbours
			lowestmetric = metric[checkedroid.ID]
			
			for i = 0, numberofneighbours do
				
				-- check that we're not examining ourself.
				if neighbours[i].id ~= checkedroid.id then
			
					if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
						-- this asteroid belongs to our empire, or it doesn't belong to anyone (and we should therefore follow its metrics)
						
						-- is this neighbour's metric less than mine?  (also, have we just taken this asteroid..?)
						if metric[neighbours[i].ID] < lowestmetric and changedowner == false then
							-- yes it's lower.
							lowestmetric = metric[neighbours[i].ID]
						end
					
					end
				
				end
			end
		
			-- now we've established what the lowest metric is.  If it's lower than ours, set ours to that +1.  If the lowest metric of a neighbour is the same as our metric, increase ours by 1.
			-- UNLESS we are a gather point
			if metric[checkedroid.ID] > lowestmetric and metric[checkedroid.ID] ~= 200 and metric[checkedroid.ID] ~= 100 then
				metric[checkedroid.ID] = lowestmetric + 5
			end
			
			if metric[checkedroid.ID] == lowestmetric and metric[checkedroid.ID] ~= 200 and metric[checkedroid.ID] ~= 100 then
				-- if my metric is the same as the lowest metric of my neighbours, i must be 1 step further away than they are.
				metric[checkedroid.ID] = metric[checkedroid.ID] + 5
			end
			
			-- check for errors, reset metric if necessary
			
			if metric[checkedroid.id] > 500 then
				metric[checkedroid.id] = 200
			end
			
			if metric[checkedroid.ID] > 0 and metric[checkedroid.ID] < 99 then
				stillinneed = false
				
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner and metric[i] == 0 then
						stillinneed = true
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 0 and metric[i] < 99 then
							metric[i] = 500
						end
					end
				end
			
			end
			
			if metric[checkedroid.ID] > 100 and metric[checkedroid.ID] < 199 then
				stillinneed = false
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner or GetAsteroid(i).owner == 0 then
						if metric[i] == 100 then
							stillinneed = true
						end
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 100 and metric[i] < 199 then
							metric[i] = 500
						end
					end
				end
			end
			
			if metric[checkedroid.ID] > 200 and metric[checkedroid.ID] < 299 then
				stillinneed = false
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner and metric[i] == 200 then
						stillinneed = true
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 200 and metric[i] < 299 then
							metric[i] = 500
						end
					end
				end
			end
			
		end

		-- Now to check that if we have metric 0, 100 or 200, we still require that status.
		
		if metric[checkedroid.id] == 0 then
			-- ok.  Am I REALLY still under attack?
			if checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner) > 1 or minepresent[checkedroid.ID] == true then
				-- the enemy outnumber us, or there's a player mine here.  Yes, we're really under attack...
			else
				-- we're not really under attack anymore.  lets reset the metric.
				for i = 0, numberofasteroids do
					if GetAsteroid(i).owner == checkedroid.owner then
						metric[i] = 500
					end
				
				end
				metric[checkedroid.id] = 200
			end
		end
		
		if metric[checkedroid.id] == 100 then
			-- ok.  Am I REALLY still under construction?
			if checkedroid:GetNumTrees() < checkedroid.TreeCap then
				-- we do indeed have less trees than the treecap, so we still need seeds.
			else
				-- we're not really under construction anymore.  lets reset the metric.
				metric[checkedroid.id] = 200
			end
		end

		enemydetected = false
		frienddetected = false
		gatherpointdetected = false	
		lowermetricsnearby = false

		-- ok.  Am I REALLY still a suitable gather point?
		for i = 0, numberofneighbours do
			-- check that we're not examining ourself.
			if metric[checkedroid.ID] == 200 and neighbours[i].ID ~= checkedroid.id and changedowner == false then
				if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
					-- this asteroid is friendly or neutral to us
					frienddetected = true
				end
			
				if neighbours[i].owner ~= checkedroid.owner and neighbours[i].owner ~= 0 and neighbours[i]:GetNumTrees() > 0 then
					-- this asteroid doesn't belong to us or player 0, and has at least 1 tree.  It must be an enemy roid.
					enemydetected = true
				end
				
				numberofenemies = neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)
				
				if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumTrees() == 0 and numberofenemies > 9 then
					-- this asteroid doesn't belong to us, has no trees on it, but has enemy seedlings on it.  Treat it as enemy.
					enemydetected = true
				end
				
				if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].ID] == 200 then
					-- this asteroid is friendly to us, and is a gather point.
					gatherpointdetected = true
				end
				
				if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] < 200 then
					-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
					lowermetricsnearby = true
				end			
				if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] < 200 then
					-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
					lowermetricsnearby = true
				end	
				if neighbours[i].owner == 0 and metric[neighbours[i].id] < 200 then
					-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
					lowermetricsnearby = true
				end	
			end
		
		end
		
		if metric[checkedroid.id] == 200 and changedowner == false then
			
			if enemydetected == true and gatherpointdetected == false and lowermetricsnearby == false then
				-- the conditions are right for me to continue as a gather point.

			else
				-- the conditions are no longer right.  Best to reset the metric.
				metric[checkedroid.id] = 500
			end
			
		end
	
		if frienddetected == false and enemydetected == true and checkedroid:GetNumTrees() == checkedroid.TreeCap then
			-- we're an orphan with max trees!  lets become a gather point.
			metric[checkedroid.id] = 200
		end
	
		-- Actions
		
		-- There are 3 different action types.  We must make sure not to use any actions for players 0 and 1!
		-- 1.  Plant trees
		
		-- trap for player 0, exclude player 1
		if checkedroid.owner == 0 or checkedroid.owner > 1 then
			-- so plant one :>
			for i = 2,10 do		
				
				if metric[checkedroid.id] == 100 and (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(i)) < 5 and checkedroid:GetNumSeedlings(i) > 9 then
					-- this asteroid isn't owned by greys or player, the enemy only has a bit of seedlings here
					-- its metric is 100
					-- and it has enough seedlings belonging to the asteroid's empire to plant a tree
					
					-- Threephi's Bug Workaround: and there are zero growing trees on the asteroid, or the faction with enough seeds to plant actually owns the asteroid
					-- this is necessary as PlantDysonTree() will plant a foreign tree on another faction's asteroid even if trees are already present
					if checkedroid:IsBarren() or checkedroid.owner == i then
						a = checkedroid:PlantDysonTree(i)
					end
				-- bug workaround end
				end
			end
		end

		-- 2.  Send seedlings to the next lowest metric
		
		if metric[checkedroid.id] ~= 0 and metric[checkedroid.id] ~= 100 and metric[checkedroid.id] ~= 500 and checkedroid.owner > 1 then
		
			-- we're not under attack or construction.
			numberofdestinations = 0
			
			for i = 0,numberofneighbours do
				if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
					-- this neighbour is one of our asteroids, or it's a blank asteroid

					if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
						if metric[neighbours[i].ID] < metric[checkedroid.ID] then
							-- we've found a friendly neighbour with a metric lower than ours!
							-- add it to the destinations list
							numberofdestinations = numberofdestinations + 1
						end
					end

				end
			end
			
			if numberofdestinations > 0 then
			
				-- we've found some destinations to send seeds to.  Lets send some.
				numberofseedsleft = checkedroid:GetNumSeedlings(checkedroid.owner) - (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner))
				numberperdestination = numberofseedsleft / numberofdestinations
				
				for i = 0,numberofneighbours do
					if neighbours[i] ~= checkedroid then
						if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
							if metric[neighbours[i].ID] < metric[checkedroid.ID] then
								-- this destination has less than our metric.  This is one of the valid destinations.  Send a proportional amount of seeds to it.
								if neighbours[i].owner == 0 and numberofseedsleft < 10 then
									-- don't bother sending.
								
								elseif neighbours[i].owner == 0 and neighbours[i]:GetNumSeedlings(0) > 0 and numberofseedsleft > 9 + (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) then
									-- attack the greys!
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, checkedroid:GetNumSeedlings(checkedroid.owner), neighbours[i])
									numberofseedsleft = 0
								
								elseif neighbours[i].owner == 0 and numberofseedsleft > 9 and (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) == 0 then
									-- this is the last we can manage.  Send all 10.
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, 10, neighbours[i])
									numberofseedsleft = numberofseedsleft - 10
								
								elseif neighbours[i].owner == checkedroid.owner then
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, numberperdestination, neighbours[i])
									numberofseedsleft = numberofseedsleft - numberperdestination
								end
							end
						end
					end
				end
			end

			-- 3.  Attack the weakest nearby asteroid
			
			-- Are we a gather point?  Only gather points are allowed to attack.
			
			if metric[checkedroid.id] == 200 then

				totalenemies = 0
				totalfriendlies = checkedroid:GetNumSeedlings(checkedroid.owner)
				weakestamount = 10000
				weakestroid = checkedroid
				attack = false
				orphan = true
				numberofenemyroids = 0
				
				for i = 0,numberofneighbours do
					
					if neighbours[i].owner == checkedroid.owner and neighbours[i] ~= checkedroid then
						orphan = false
					end
					
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner) > 5 then
						-- found an attack path
						numberofenemyroids = numberofenemyroids + 1
					end
					
					for j = 0,10 do
						if checkedroid.owner ~= j then
							totalenemies = totalenemies + neighbours[i]:GetNumSeedlings(j)
							
							if weakestamount > neighbours[i]:GetNumSeedlings(j) and neighbours[i].owner == j then
								-- the owner of this asteroid has a smaller number of seeds than we've seen before...
								weakestamount = neighbours[i]:GetNumSeedlings(j)
								weakestroid = neighbours[i]
							end
						
						end
					end
					
					if neighbours[i] ~= checkedroid and neighbours[i].owner ~= checkedroid.owner then
						if neighbours[i]:GetNumSeedlings(checkedroid.owner) > (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) then
							-- already attacking, and winning.  send reinforcements.
							checkedroid:SendSeedlingsToTarget(checkedroid.owner, checkedroid:GetNumSeedlings(checkedroid.owner), neighbours[i])
						end
					end
				end
				
				-- in the first case, we have more seedlings than all the neighbouring asteroids put together.
				if totalfriendlies > totalenemies + (weakestroid:GetNumTrees() * 10) then
					attack = true
				end
				
				split = false
				
				-- in the second case, we have more than 150 seedlings on this roid, and it's time to move out!
				if totalfriendlies > 150 then
					attack = true
					split = true
				end
				
				if totalfriendlies >= Globals.Asteroids.SpawnCap and orphan == true then
					attack = true
				end
				
				if attack == true and checkedroid.owner > 1 and split == false then
					-- ok so we're a gather point, we're ready to attack, and we aren't a player or greys asteroid.
					-- lets move out.
					checkedroid:SendSeedlingsToTarget(checkedroid.owner, totalfriendlies, weakestroid)
				elseif attack == true and checkedroid.owner > 1 and split == true then
				
					for i = 0,numberofneighbours do
						if neighbours[i].owner ~= checkedroid.owner then
							-- attackable path - send proportional amount of seeds.
							checkedroid:SendSeedlingsToTarget(checkedroid.owner, totalfriendlies / numberofenemyroids, neighbours[i])
						end
					end
				end
			end
		end
		-- Set asteroid names to whatever their metric is.  Uncomment the
		-- line below for testing purposes if the AI shows unexpected behaviours.
		--checkedroid.Name = metric[checkedroid.ID]
	end
	-- *** END INFECTED AI : ENGINE ***
	
end

function OnAsteroidTaken(id, owner)

	if GetEmpire(2):GetNumOwnedAsteroids() > 3 then
		if math.random(1,2) == 1 then
			levelledhere[id] = false
		else
			levelledhere[id] = true
		end
	else
		levelledhere[id] = false
	end
	
	if owner == 2 then
		rewardtimer[id] = GetGameTime() + 2
		distance = math.sqrt((GetAsteroid(id).position.x - viewdistance.position.x)^2 + (GetAsteroid(id).position.y - viewdistance.position.y)^2)
		if distance + GetAsteroid(id).SendDistance + 500 > viewdistance.SendDistance then
			viewdistance.SendDistance = distance + GetAsteroid(id).SendDistance + 500
		end
		for i = 0,roidnumber do
			distance = math.sqrt((GetAsteroid(id).position.x - GetAsteroid(i).position.x)^2 + (GetAsteroid(id).position.y - GetAsteroid(i).position.y)^2) - GetAsteroid(i).radius
			if distance < GetAsteroid(id).SendDistance then
				GetAsteroid(i):Reveal(1)
				GetAsteroid(i):Reveal(2)
			end
		end
	end
end